diff -uNr ./freebios2/src/mainboard/tyan/s2850/adaptec_scsi.c ../freebios2/src/mainboard/tyan/s2850/adaptec_scsi.c
--- ./freebios2/src/mainboard/tyan/s2850/adaptec_scsi.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/adaptec_scsi.c	2003-09-02 12:42:31.000000000 -0400
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void adaptec_scsi_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("ADAPTEC_SCSI_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations adaptec_scsi_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = adaptec_scsi_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver adaptec2_scsi_driver __pci_driver = {
+	.ops    = &adaptec_scsi_ops,
+	.vendor = PCI_VENDOR_ID_ADAPTEC2,
+	.device = 0x8012,
+};
+static struct pci_driver adaptec_scsi_driver __pci_driver = {
+        .ops    = &adaptec_scsi_ops,
+        .vendor = PCI_VENDOR_ID_ADAPTEC,
+        .device = PCI_DEVICE_ID_ADAPTEC_7895,
+};
+ 
Binary files ./freebios2/src/mainboard/tyan/s2850/ati.rom and ../freebios2/src/mainboard/tyan/s2850/ati.rom differ
Binary files ./freebios2/src/mainboard/tyan/s2850/atix.rom and ../freebios2/src/mainboard/tyan/s2850/atix.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s2850/auto.c ../freebios2/src/mainboard/tyan/s2850/auto.c
--- ./freebios2/src/mainboard/tyan/s2850/auto.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/auto.c	2003-10-14 19:48:41.000000000 -0400
@@ -0,0 +1,179 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <cpu/p6/apic.h>
+#include <arch/io.h>
+#include <arch/romcc_io.h>
+#include "pc80/serial.c"
+#include "arch/i386/lib/console.c"
+#include "ram/ramtest.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "southbridge/amd/amd8111/amd8111_early_smbus.c"
+#include "northbridge/amd/amdk8/raminit.h"
+#include "cpu/k8/apic_timer.c"
+#include "lib/delay.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+#include "debug.c"
+#include "northbridge/amd/amdk8/cpu_rev.c"
+ 
+
+#define REV_B_RESET 0
+static void memreset_setup(void)
+{
+#if REV_B_RESET==1
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=0
+#else
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=1
+#endif
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 17); 
+}
+
+static void memreset(int controllers, const struct mem_controller *ctrl)
+{
+        udelay(800);
+#if REV_B_RESET==1
+        outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 17); //REVB_MEMRST_L=1
+#endif
+        udelay(90);
+}
+
+static unsigned int generate_row(uint8_t node, uint8_t row, uint8_t maxnodes)
+{
+	uint32_t ret=0x00010101; /* default row entry */
+
+	return ret;
+}
+
+static inline int spd_read_byte(unsigned device, unsigned address)
+{
+	return smbus_read_byte(device, address);
+}
+
+/* include mainboard specific ht code */
+#include "hypertransport.c"
+
+//#include "northbridge/amd/amdk8/cpu_ldtstop.c"
+//#include "southbridge/amd/amd8111/amd8111_ldtstop.c"
+
+#include "northbridge/amd/amdk8/raminit.c"
+#include "northbridge/amd/amdk8/coherent_ht.c"
+#include "sdram/generic_sdram.c"
+
+static void enable_lapic(void)
+{
+	msr_t msr;
+	msr = rdmsr(0x1b);
+	msr.hi &= 0xffffff00;
+	msr.lo &= 0x000007ff;
+	msr.lo |= APIC_DEFAULT_BASE | (1 << 11);
+	wrmsr(0x1b, msr);
+}
+
+static void stop_this_cpu(void)
+{
+	unsigned apicid;
+	apicid = apic_read(APIC_ID) >> 24;
+
+	/* Send an APIC INIT to myself */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR, APIC_INT_LEVELTRIG | APIC_INT_ASSERT | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* Deassert the APIC INIT */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR,  APIC_INT_LEVELTRIG | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* If I haven't halted spin forever */
+	for(;;) {
+		hlt();
+	}
+}
+#define FIRST_CPU  1
+#define SECOND_CPU 0
+#define TOTAL_CPUS (FIRST_CPU + SECOND_CPU)
+static void main(void)
+{
+	static const struct mem_controller cpu[] = {
+#if FIRST_CPU
+		{
+			.node_id = 0,
+			.f0 = PCI_DEV(0, 0x18, 0),
+			.f1 = PCI_DEV(0, 0x18, 1),
+			.f2 = PCI_DEV(0, 0x18, 2),
+			.f3 = PCI_DEV(0, 0x18, 3),
+			.channel0 = { (0xa<<3)|0, (0xa<<3)|2, 0, 0 },
+			.channel1 = { (0xa<<3)|1, (0xa<<3)|3, 0, 0 },
+		},
+#endif
+#if SECOND_CPU
+		{
+			.node_id = 1,
+			.f0 = PCI_DEV(0, 0x19, 0),
+			.f1 = PCI_DEV(0, 0x19, 1),
+			.f2 = PCI_DEV(0, 0x19, 2),
+			.f3 = PCI_DEV(0, 0x19, 3),
+			.channel0 = { (0xa<<3)|4, (0xa<<3)|6, 0, 0 },
+			.channel1 = { (0xa<<3)|5, (0xa<<3)|7, 0, 0 },
+		},
+#endif
+	};
+	if (cpu_init_detected()) {
+		asm("jmp __cpu_reset");
+	}
+	enable_lapic();
+	init_timer();
+	if (!boot_cpu() ) {
+		notify_bsp_ap_is_stopped();
+		stop_this_cpu();
+	}
+	uart_init();
+	console_init();
+	setup_default_resource_map();
+	setup_coherent_ht_domain();
+	enumerate_ht_chain(0);
+	distinguish_cpu_resets(0);
+	
+#if 0
+	print_pci_devices();
+#endif
+	enable_smbus();
+#if 0
+	dump_spd_registers(&cpu[0]);
+#endif
+	memreset_setup();
+	sdram_initialize(sizeof(cpu)/sizeof(cpu[0]), cpu);
+
+#if 0
+	dump_pci_devices();
+#endif
+#if 0
+	dump_pci_device(PCI_DEV(0, 0x18, 1));
+#endif
+
+	/* Check all of memory */
+#if 0
+	msr_t msr;
+	msr = rdmsr(TOP_MEM2);
+	print_debug("TOP_MEM2: ");
+	print_debug_hex32(msr.hi);
+	print_debug_hex32(msr.lo);
+	print_debug("\r\n");
+#endif
+/*
+#if  0
+	ram_check(0x00000000, msr.lo+(msr.hi<<32));
+#else
+#if TOTAL_CPUS < 2
+	// Check 16MB of memory @ 0
+	ram_check(0x00000000, 0x01000000);
+#else
+	// Check 16MB of memory @ 2GB 
+	ram_check(0x80000000, 0x81000000);
+#endif
+#endif
+*/
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/broadcom_nic.c ../freebios2/src/mainboard/tyan/s2850/broadcom_nic.c
--- ./freebios2/src/mainboard/tyan/s2850/broadcom_nic.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/broadcom_nic.c	2003-09-18 22:55:22.000000000 -0400
@@ -0,0 +1,56 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+static void broadcom_nic_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("BROADCOM_NIC_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations broadcom_nic_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = broadcom_nic_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver broadcom_nic_driver __pci_driver = {
+	.ops    = &broadcom_nic_ops,
+	.vendor = PCI_VENDOR_ID_BROADCOM,
+	.device = PCI_DEVICE_ID_TIGON3_5703X,
+};
+static struct pci_driver broadcom_nic2_driver __pci_driver = {
+        .ops    = &broadcom_nic_ops,
+        .vendor = PCI_VENDOR_ID_BROADCOM,
+        .device = 0x1653,
+};
+static struct pci_driver broadcom_nic3_driver __pci_driver = {
+        .ops    = &broadcom_nic_ops,
+        .vendor = PCI_VENDOR_ID_BROADCOM,
+        .device = 0x4401,
+};
+
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s2850/chip.h ../freebios2/src/mainboard/tyan/s2850/chip.h
--- ./freebios2/src/mainboard/tyan/s2850/chip.h	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/chip.h	2003-09-18 21:37:31.000000000 -0400
@@ -0,0 +1,6 @@
+extern struct chip_control mainboard_tyan_s2850_control;
+
+struct mainboard_tyan_s2850_config {
+	int fixup_scsi;
+	int fixup_vga;
+};
diff -uNr ./freebios2/src/mainboard/tyan/s2850/cmos.layout ../freebios2/src/mainboard/tyan/s2850/cmos.layout
--- ./freebios2/src/mainboard/tyan/s2850/cmos.layout	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/cmos.layout	2003-06-13 17:27:45.000000000 -0400
@@ -0,0 +1,74 @@
+entries
+
+#start-bit length  config config-ID    name
+#0            8       r       0        seconds
+#8            8       r       0        alarm_seconds
+#16           8       r       0        minutes
+#24           8       r       0        alarm_minutes
+#32           8       r       0        hours
+#40           8       r       0        alarm_hours
+#48           8       r       0        day_of_week
+#56           8       r       0        day_of_month
+#64           8       r       0        month
+#72           8       r       0        year
+#80           4       r       0        rate_select
+#84           3       r       0        REF_Clock
+#87           1       r       0        UIP
+#88           1       r       0        auto_switch_DST
+#89           1       r       0        24_hour_mode
+#90           1       r       0        binary_values_enable
+#91           1       r       0        square-wave_out_enable
+#92           1       r       0        update_finished_enable
+#93           1       r       0        alarm_interrupt_enable
+#94           1       r       0        periodic_interrupt_enable
+#95           1       r       0        disable_clock_updates
+#96         288       r       0        temporary_filler
+0          384       r       0        reserved_memory
+384          1       e       4        boot_option
+385          1       e       4        last_boot
+386          1       e       1        ECC_memory
+388          4       r       0        reboot_bits
+392          3       e       5        baud_rate
+400          1       e       1        power_on_after_fail
+412          4       e       6        debug_level
+416          4       e       7        boot_first
+420          4       e       7        boot_second
+424          4       e       7        boot_third
+428          4       h       0        boot_index
+432	     8       h       0        boot_countdown
+1008         16      h       0        check_sum
+
+enumerations
+
+#ID value   text
+1     0     Disable
+1     1     Enable
+2     0     Enable
+2     1     Disable
+4     0     Fallback
+4     1     Normal
+5     0     115200
+5     1     57600
+5     2     38400
+5     3     19200
+5     4     9600
+5     5     4800
+5     6     2400
+5     7     1200
+6     6     Notice
+6     7     Info
+6     8     Debug
+6     9     Spew
+7     0     Network
+7     1     HDD
+7     2     Floppy
+7     8     Fallback_Network
+7     9     Fallback_HDD
+7     10    Fallback_Floppy
+#7     3     ROM
+
+checksums
+
+checksum 392 1007 1008
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s2850/Config.lb ../freebios2/src/mainboard/tyan/s2850/Config.lb
--- ./freebios2/src/mainboard/tyan/s2850/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/Config.lb	2003-10-14 19:47:10.000000000 -0400
@@ -0,0 +1,177 @@
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses USE_FALLBACK_IMAGE
+uses MAINBOARD
+uses ARCH
+#
+#
+###
+### Set all of the defaults for an x86 architecture
+###
+#
+#
+###
+### Build the objects we have code for in this directory.
+###
+##object mainboard.o
+config chip.h
+register "fixup_scsi" = "1" 
+register "fixup_vga" = "1"
+
+
+driver mainboard.o
+driver adaptec_scsi.o
+driver promise_sata.o
+driver intel_nic.o
+driver broadcom_nic.o
+object reset.o
+#object static_devices.o
+if HAVE_MP_TABLE object mptable.o end
+if HAVE_PIRQ_TABLE object irq_tables.o end
+#
+arch i386 end
+#cpu k8 end
+#
+###
+### Build our 16 bit and 32 bit linuxBIOS entry code
+###
+mainboardinit cpu/i386/entry16.inc
+mainboardinit cpu/i386/entry32.inc
+ldscript /cpu/i386/entry16.lds
+ldscript /cpu/i386/entry32.lds
+#
+###
+### Build our reset vector (This is where linuxBIOS is entered)
+###
+if USE_FALLBACK_IMAGE 
+	mainboardinit cpu/i386/reset16.inc 
+	ldscript /cpu/i386/reset16.lds 
+else
+	mainboardinit cpu/i386/reset32.inc 
+	ldscript /cpu/i386/reset32.lds 
+end
+#
+#### Should this be in the northbridge code?
+mainboardinit arch/i386/lib/cpu_reset.inc
+#
+###
+### Include an id string (For safe flashing)
+###
+mainboardinit arch/i386/lib/id.inc
+ldscript /arch/i386/lib/id.lds
+#
+####
+#### This is the early phase of linuxBIOS startup 
+#### Things are delicate and we test to see if we should
+#### failover to another image.
+####
+#option MAX_REBOOT_CNT=2
+if USE_FALLBACK_IMAGE
+  ldscript /arch/i386/lib/failover.lds 
+end
+#
+###
+### Setup our mtrrs
+###
+mainboardinit cpu/k8/earlymtrr.inc
+###
+### Only the bootstrap cpu makes it here.
+### Failover if we need to 
+###
+#
+if USE_FALLBACK_IMAGE
+  mainboardinit ./failover.inc
+end
+
+#
+#
+###
+### Setup the serial port
+###
+#mainboardinit superiowinbond/w83627hf/setup_serial.inc
+mainboardinit pc80/serial.inc
+mainboardinit arch/i386/lib/console.inc
+#
+####
+#### O.k. We aren't just an intermediary anymore!
+####
+#
+###
+### When debugging disable the watchdog timer
+###
+##option MAXIMUM_CONSOLE_LOGLEVEL=7
+#default MAXIMUM_CONSOLE_LOGLEVEL=7
+#
+#if USE_FALLBACK_IMAGE mainboardinit arch/i386/lib/noop_failover.inc  end
+#
+###
+### Romcc output
+###
+#makerule ./failover.E dep "$(MAINBOARD)/failover.c" act "$(CPP) -I$(TOP)/src $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failever.E"
+#makerule ./failover.inc dep "./romcc ./failover.E" act "./romcc -O ./failover.E > failover.inc"
+#mainboardinit .failover.inc
+
+makerule ./failover.E
+	depends "$(MAINBOARD)/failover.c" 
+	action "$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E"
+end
+
+makerule ./failover.inc
+	depends "./romcc ./failover.E"
+	action "./romcc -O -o failover.inc --label-prefix=failover ./failover.E"end
+
+makerule ./auto.E 
+	depends	"$(MAINBOARD)/auto.c" 
+	action	"$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E"
+end
+makerule ./auto.inc 
+	depends "./romcc ./auto.E"
+	action "./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E" 
+#	action	"./romcc -mcpu=k8  -O ./auto.E > auto.inc"
+end
+mainboardinit cpu/k8/enable_mmx_sse.inc
+mainboardinit ./auto.inc
+mainboardinit cpu/k8/disable_mmx_sse.inc
+#
+###
+### Include the secondary Configuration files 
+###
+northbridge amd/amdk8 "mc0"
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.1
+        pci 0:18.2
+        pci 0:18.3
+        southbridge amd/amd8111 "amd8111" link 0
+                pci 0:0.0
+                pci 0:1.0 on
+                pci 0:1.1 on
+                pci 0:1.2 on
+                pci 0:1.3 on
+                pci 0:1.5 off
+                pci 0:1.6 off
+                pci 1:0.0 on
+                pci 1:0.1 on
+                pci 1:0.2 on
+                pci 1:1.0 off
+        end
+end
+
+#northbridge amd/amdk8
+#end
+#southbridge amd/amd8111 "amd8111"
+#end
+#mainboardinit archi386/smp/secondary.inc
+#superio NSC/pc87360
+#	register "com1" = "{1}"
+#	register "lpt" = "{1}"
+#end
+dir /pc80
+##dir /src/superio/winbond/w83627hf
+#dir /bioscall
+#dir /cpu/k8
+cpu k8 "cpu0"
+  register "up" = "{.chip = &amd8111, .ht_width=8, .ht_speed=200}"
+end
+
diff -uNr ./freebios2/src/mainboard/tyan/s2850/debug.c ../freebios2/src/mainboard/tyan/s2850/debug.c
--- ./freebios2/src/mainboard/tyan/s2850/debug.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/debug.c	2003-08-02 00:25:41.000000000 -0400
@@ -0,0 +1,127 @@
+
+static void print_debug_pci_dev(unsigned dev)
+{
+	print_debug("PCI: ");
+	print_debug_hex8((dev >> 16) & 0xff);
+	print_debug_char(':');
+	print_debug_hex8((dev >> 11) & 0x1f);
+	print_debug_char('.');
+	print_debug_hex8((dev >> 8) & 7);
+}
+
+static void print_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		print_debug_pci_dev(dev);
+		print_debug("\r\n");
+	}
+}
+
+static void dump_pci_device(unsigned dev)
+{
+	int i;
+	print_debug_pci_dev(dev);
+	print_debug("\r\n");
+	
+	for(i = 0; i <= 255; i++) {
+		unsigned char val;
+		if ((i & 0x0f) == 0) {
+			print_debug_hex8(i);
+			print_debug_char(':');
+		}
+		val = pci_read_config8(dev, i);
+		print_debug_char(' ');
+		print_debug_hex8(val);
+		if ((i & 0x0f) == 0x0f) {
+			print_debug("\r\n");
+		}
+	}
+}
+
+static void dump_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		dump_pci_device(dev);
+	}
+}
+
+static void dump_spd_registers(const struct mem_controller *ctrl)
+{
+	int i;
+	print_debug("\r\n");
+	for(i = 0; i < 4; i++) {
+		unsigned device;
+		device = ctrl->channel0[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".0: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+		device = ctrl->channel1[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".1: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/failover.c ../freebios2/src/mainboard/tyan/s2850/failover.c
--- ./freebios2/src/mainboard/tyan/s2850/failover.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/failover.c	2003-07-24 23:10:59.000000000 -0400
@@ -0,0 +1,38 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <device/pci_ids.h>
+#include <arch/io.h>
+#include "arch/romcc_io.h"
+#include "pc80/mc146818rtc_early.c"
+#include "southbridge/amd/amd8111/amd8111_enable_rom.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+
+static void main(void)
+{
+	/* Nothing special needs to be done to find bus 0 */
+	/* Allow the HT devices to be found */
+	enumerate_ht_chain(0);
+
+	/* Setup the 8111 */
+	amd8111_enable_rom();
+
+	/* Is this a cpu reset? */
+	if (cpu_init_detected()) {
+		if (last_boot_normal()) {
+			asm("jmp __normal_image");
+		} else {
+			asm("jmp __cpu_reset");
+		}
+	}
+	/* Is this a secondary cpu? */
+	else if (!boot_cpu() && last_boot_normal()) {
+		asm("jmp __normal_image");
+	}
+	/* This is the primary cpu how should I boot? */
+	else if (do_normal_boot()) {
+		asm("jmp __normal_image");
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/hypertransport.c ../freebios2/src/mainboard/tyan/s2850/hypertransport.c
--- ./freebios2/src/mainboard/tyan/s2850/hypertransport.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/hypertransport.c	2003-09-18 22:21:03.000000000 -0400
@@ -0,0 +1,54 @@
+/* coherent hypertransport initialization for AMD64 
+ *
+ * tyan mainboard specific setup code from lyh
+ * 
+ * This code is licensed under GPL.
+ */
+
+ static void coherent_ht_mainboard(unsigned cpus)
+{
+
+     static const unsigned int register_values[] = {
+        PCI_ADDR(0, 0x18, 0, 0x84), 0x88ff9c05, 0x00000020,
+        PCI_ADDR(0, 0x18, 0, 0xa4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x18, 0, 0xc4), 0x88ff9c05, 0x770000d0,
+
+
+        PCI_ADDR(0, 0x18, 0, 0x88), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xa8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xc8), 0xfffff0ff, 0x00000000,
+
+        PCI_ADDR(0, 0x18, 0, 0x94), 0xff0000ff, 0x00ff0000,
+        PCI_ADDR(0, 0x18, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xd4), 0xff0000ff, 0x00000000,
+
+      };
+        int i;
+        int max;
+
+
+        device_t dev;
+        unsigned where;
+        unsigned long reg;
+	
+        print_debug("setting up ht links....\r\n");
+        max = sizeof(register_values)/sizeof(register_values[0]);
+        for(i = 0; i < max; i += 3) {
+#if 0
+                print_debug_hex32(i);
+                print_debug(": ");
+                print_debug_hex32(register_values[i]);
+                print_debug(" <-");
+                print_debug_hex32(register_values[i+2]);
+                print_debug("\r\n");
+#endif
+                dev = register_values[i] & ~0xff;
+                where = register_values[i] & 0xff;
+                reg = pci_read_config32(dev, where);
+                reg &= register_values[i+1];
+                reg |= register_values[i+2];
+                pci_write_config32(dev, where, reg);
+        }
+	print_debug("done\r\n");
+
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/intel_nic.c ../freebios2/src/mainboard/tyan/s2850/intel_nic.c
--- ./freebios2/src/mainboard/tyan/s2850/intel_nic.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/intel_nic.c	2003-09-02 12:42:31.000000000 -0400
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void intel_nic_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("INTEL_NIC_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations intel_nic_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = intel_nic_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver intel_nic_driver __pci_driver = {
+	.ops    = &intel_nic_ops,
+	.vendor = PCI_VENDOR_ID_INTEL,
+	.device = 0x1010,
+};
+static struct pci_driver intel_nic2_driver __pci_driver = {
+        .ops    = &intel_nic_ops,
+        .vendor = PCI_VENDOR_ID_INTEL,
+        .device = 0x100f,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s2850/irq_tables.c ../freebios2/src/mainboard/tyan/s2850/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s2850/irq_tables.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/irq_tables.c	2003-11-18 21:22:30.000000000 -0500
@@ -0,0 +1,36 @@
+/* This file was generated by getpir.c, do not modify! 
+   (but if you do, please run checkpir on it to verify)
+   Contains the IRQ Routing Table dumped directly from your memory , wich BIOS sets up
+
+   Documentation at : http://www.microsoft.com/hwdev/busbios/PCIIRQ.HTM
+*/
+
+#include <arch/pirq_routing.h>
+
+const struct irq_routing_table intel_irq_routing_table = {
+	PIRQ_SIGNATURE, /* u32 signature */
+	PIRQ_VERSION,   /* u16 version   */
+	32+16*12,        /* there can be total 12 devices on the bus */
+	1,           /* Where the interrupt router lies (bus) */
+	(2<<3)|3,           /* Where the interrupt router lies (dev) */
+	0,         /* IRQs devoted exclusively to PCI usage */
+	0x1022,         /* Vendor */
+	0x746b,         /* Device */
+	0,         /* Crap (miniport) */
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
+	0x9b,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
+	{
+		{1,0x38, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{0x2,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
+		{0x2,0x68, {{0x4, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x58, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x5, 0},
+		{0x2,0x30, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x1, 0},
+		{0x2,0x38, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x2, 0},
+		{0x2,0x40, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x3, 0},
+		{0x2,0x48, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x4, 0},
+		{0x2,0x50, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x5, 0},
+		{0x2,0x70, {{0x1, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x60, {{0x2, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+	}
+};
diff -uNr ./freebios2/src/mainboard/tyan/s2850/mainboard.c ../freebios2/src/mainboard/tyan/s2850/mainboard.c
--- ./freebios2/src/mainboard/tyan/s2850/mainboard.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/mainboard.c	2003-09-18 21:37:19.000000000 -0400
@@ -0,0 +1,196 @@
+#include <console/console.h>
+#include <device/device.h>
+#include <device/chip.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+#include "../../../northbridge/amd/amdk8/northbridge.h"
+#include "chip.h"
+//#include <part/mainboard.h>
+//#include "lsi_scsi.c"
+unsigned long initial_apicid[CONFIG_MAX_CPUS] =
+{
+	0
+};
+#if 0
+static void fixup_lsi_53c1030(struct device *pdev)
+{
+//	uint8_t byte;
+	uint16_t word;
+
+	byte = 1;
+        pci_write_config8(pdev, 0xff, byte);
+           // Set the device id 
+//      pci_write_config_word(pdev, PCI_DEVICE_ID, PCI_DEVICE_ID_LSILOGIC_53C1030);
+           // Set the subsytem vendor id 
+//      pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, PCI_VENDOR_ID_TYAN);  
+        word = 0x10f1;
+	pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, word);
+            // Set the subsytem id 
+	word = 0x2880;
+        pci_write_config16(pdev, PCI_SUBSYSTEM_ID, word);
+            // Disable writes to the device id 
+	byte = 0;
+        pci_write_config8(pdev, 0xff, byte);
+
+//	lsi_scsi_init(pdev);
+	
+}
+#endif
+//extern static void lsi_scsi_init(struct device *dev);
+#if 1
+static void print_pci_regs(struct device *dev)
+{
+      uint8_t byte;
+      int i;
+
+      for(i=0;i<256;i++) {
+	     byte = pci_read_config8(dev, i);
+   
+             if((i%16)==0) printk_debug("\n%02x:",i);
+             printk_debug(" %02x",byte);
+      }
+      printk_debug("\n");
+	
+//        pci_write_config8(dev, 0x4, byte);
+
+}
+#endif
+#if 0
+static void print_mem(void)
+{
+        int i;
+	int low_1MB = 0;
+	for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %02x ",(unsigned char)*((unsigned char *)i));
+             }
+
+        for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %c ",(unsigned char)*((unsigned char *)i));
+             }
+ }
+#endif
+#if 0
+static void amd8111_enable_rom(void)
+{
+        uint8_t byte;
+        struct device *dev;
+
+        /* Enable 4MB rom access at 0xFFC00000 - 0xFFFFFFFF */
+        /* Locate the amd8111 */
+        dev = dev_find_device(0x1022, 0x7468, 0);
+
+        /* Set the 4MB enable bit bit */
+        byte = pci_read_config8(dev, 0x43);
+        byte |= 0x80;
+        pci_write_config8(dev, 0x43, byte);
+}
+#endif
+static void onboard_scsi_fixup(void)
+{
+        struct device *dev;
+#if 0
+	unsigned char i,j,k;
+
+	for(i=0;i<=6;i++) {
+		for(j=0;j<=0x1f;j++) {
+			for (k=0;k<=6;k++){
+				dev = dev_find_slot(i, PCI_DEVFN(j, k));
+				if (dev) {
+			                printk_debug("%02x:%02x:%02x",i,j,k);
+					print_pci_regs(dev);
+        			}
+			}
+		}
+	}
+#endif
+
+
+#if 0
+        dev = dev_find_device(PCI_VENDOR_ID_LSI_LOGIC, PCI_DEVICE_ID_LSI_53C1030,0);
+        if(!dev) {
+                printk_info("LSI_SCSI_FW_FIXUP: No Device Found!");
+                return;
+        }
+
+	lsi_scsi_init(dev); 
+#endif
+//	print_mem();
+//	amd8111_enable_rom();
+}
+#if 1
+static void vga_fixup(void) {
+        // we do this right here because:
+        // - all the hardware is working, and some VGA bioses seem to need
+        //   that
+        // - we need page 0 below for linuxbios tables.
+#if CONFIG_REALMODE_IDT == 1
+        printk_debug("INSTALL REAL-MODE IDT\n");
+        setup_realmode_idt();
+#endif
+#if CONFIG_VGABIOS == 1
+        printk_debug("DO THE VGA BIOS\n");
+        do_vgabios();
+        post_code(0x93);
+#endif
+
+}
+#endif 
+
+static void
+enable(struct chip *chip, enum chip_pass pass)
+{
+
+        struct mainboard_tyan_s2850_config *conf = 
+		(struct mainboard_tyan_s2850_config *)chip->chip_info;
+
+        switch (pass) {
+		default: break;
+//		case CONF_PASS_PRE_CONSOLE:
+//		case CONF_PASS_PRE_PCI:
+//		case CONF_PASS_POST_PCI:		
+                case CONF_PASS_PRE_BOOT:
+			if (conf->fixup_scsi)
+        			onboard_scsi_fixup();
+			if (conf->fixup_vga)
+				vga_fixup();
+			printk_debug("mainboard fixup pass %d done\r\n",
+					pass);
+			break;
+	}
+
+}
+void final_mainboard_fixup(void)
+{
+#if 0
+        enable_ide_devices();
+#endif
+}
+static struct device_operations mainboard_operations = {
+        .read_resources   = root_dev_read_resources,
+        .set_resources    = root_dev_set_resources,
+        .enable_resources = enable_childrens_resources,
+        .init             = 0,
+        .scan_bus         = amdk8_scan_root_bus,
+        .enable           = 0,
+};
+
+static void enumerate(struct chip *chip)
+{
+        struct chip *child;
+        dev_root.ops = &mainboard_operations;
+        chip->dev = &dev_root;
+        chip->bus = 0;
+        for(child = chip->children; child; child = child->next) {
+                child->bus = &dev_root.link[0];
+        }
+}
+struct chip_control mainboard_tyan_s2850_control = {
+        .enable = enable,
+        .enumerate = enumerate,
+        .name      = "Tyan s2850 mainboard ",
+};
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s2850/mptable.c ../freebios2/src/mainboard/tyan/s2850/mptable.c
--- ./freebios2/src/mainboard/tyan/s2850/mptable.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/mptable.c	2003-09-18 22:28:41.000000000 -0400
@@ -0,0 +1,84 @@
+#include <console/console.h>
+#include <arch/smp/mpspec.h>
+#include <device/pci.h>
+#include <string.h>
+#include <stdint.h>
+
+void *smp_write_config_table(void *v, unsigned long * processor_map)
+{
+        static const char sig[4] = "PCMP";
+        static const char oem[8] = "TYAN    ";
+        static const char productid[12] = "S2850       ";
+        struct mp_config_table *mc;
+
+        mc = (void *)(((char *)v) + SMP_FLOATING_TABLE_LEN);
+        memset(mc, 0, sizeof(*mc));
+
+        memcpy(mc->mpc_signature, sig, sizeof(sig));
+        mc->mpc_length = sizeof(*mc); /* initially just the header */
+        mc->mpc_spec = 0x04;
+        mc->mpc_checksum = 0; /* not yet computed */
+        memcpy(mc->mpc_oem, oem, sizeof(oem));
+        memcpy(mc->mpc_productid, productid, sizeof(productid));
+        mc->mpc_oemptr = 0;
+        mc->mpc_oemsize = 0;
+        mc->mpc_entry_count = 0; /* No entries yet... */
+        mc->mpc_lapic = LAPIC_ADDR;
+        mc->mpe_length = 0;
+        mc->mpe_checksum = 0;
+        mc->reserved = 0;
+
+        smp_write_processors(mc, processor_map);
+
+
+/*Bus:		Bus ID	Type*/
+	smp_write_bus(mc, 0, "PCI   ");
+	smp_write_bus(mc, 1, "PCI   ");
+	smp_write_bus(mc, 2, "PCI   ");
+	smp_write_bus(mc, 3, "ISA   ");
+	
+/*I/O APICs:	APIC ID	Version	State		Address*/
+	smp_write_ioapic(mc, 1, 0x11, 0xfec00000);
+  
+/*I/O Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#
+*/	
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x1, 0x1, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x0, 0x1, 0x2);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x3, 0x1, 0x3);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x4, 0x1, 0x4);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x5, 0x1, 0x5);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x6, 0x1, 0x6);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x7, 0x1, 0x7);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0x8, 0x1, 0x8);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0xc, 0x1, 0xc);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0xd, 0x1, 0xd);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0xe, 0x1, 0xe);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x3, 0xf, 0x1, 0xf);
+ 
+	
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x1, 0x1f, 0x1, 0x13);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x3, 0x1, 0x13);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x34, 0x1, 0x13);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x2c, 0x1, 0x12);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x38, 0x1, 0x10);
+
+
+/*Local Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#*/
+	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x0, 0x0, MP_APIC_ALL, 0x0);
+	smp_write_intsrc(mc, mp_NMI, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x0, 0x0, MP_APIC_ALL, 0x1);
+	/* There is no extension information... */
+
+	/* Compute the checksums */
+	mc->mpe_checksum = smp_compute_checksum(smp_next_mpc_entry(mc), mc->mpe_length);
+	mc->mpc_checksum = smp_compute_checksum(mc, mc->mpc_length);
+	printk_debug("Wrote the mp table end at: %p - %p\n",
+		mc, smp_next_mpe_entry(mc));
+	return smp_next_mpe_entry(mc);
+}
+
+unsigned long write_smp_table(unsigned long addr, unsigned long *processor_map)
+{
+	void *v;
+	v = smp_write_floating_table(addr);
+	return (unsigned long)smp_write_config_table(v, processor_map);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/promise_sata.c ../freebios2/src/mainboard/tyan/s2850/promise_sata.c
--- ./freebios2/src/mainboard/tyan/s2850/promise_sata.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/promise_sata.c	2003-09-02 12:42:31.000000000 -0400
@@ -0,0 +1,45 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void promise_sata_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("PROMISE_SATA_FIXUP:  done  \n");
+	
+}
+
+static struct device_operations promise_sata_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = promise_sata_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver promise_sata_driver __pci_driver = {
+        .ops    = &promise_sata_ops,
+        .vendor = PCI_VENDOR_ID_PROMISE,
+        .device = PCI_DEVICE_ID_PROMISE_20378,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s2850/reset.c ../freebios2/src/mainboard/tyan/s2850/reset.c
--- ./freebios2/src/mainboard/tyan/s2850/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/reset.c	2003-09-18 22:04:34.000000000 -0400
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x02, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2850/VERSION ../freebios2/src/mainboard/tyan/s2850/VERSION
--- ./freebios2/src/mainboard/tyan/s2850/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2850/VERSION	2003-06-13 17:27:51.000000000 -0400
@@ -0,0 +1 @@
+2.0
Binary files ./freebios2/src/mainboard/tyan/s2880/ati.rom and ../freebios2/src/mainboard/tyan/s2880/ati.rom differ
Binary files ./freebios2/src/mainboard/tyan/s2880/atix.rom and ../freebios2/src/mainboard/tyan/s2880/atix.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s2880/auto.c ../freebios2/src/mainboard/tyan/s2880/auto.c
--- ./freebios2/src/mainboard/tyan/s2880/auto.c	2003-11-04 07:06:02.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/auto.c	2003-11-18 19:06:46.000000000 -0500
@@ -169,7 +169,7 @@
 	enable_lapic();
 	init_timer();
 	if (!boot_cpu() ) {
-//		notify_bsp_ap_is_stopped();
+		notify_bsp_ap_is_stopped();
 		stop_this_cpu();
 	}
 	uart_init();
diff -uNr ./freebios2/src/mainboard/tyan/s2880/Config ../freebios2/src/mainboard/tyan/s2880/Config
--- ./freebios2/src/mainboard/tyan/s2880/Config	2003-10-15 16:05:06.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/Config	1969-12-31 19:00:00.000000000 -0500
@@ -1,269 +0,0 @@
-##
-## Set all of the defaults for an x86 architecture
-##
-arch i386
-cpu k8
-
-option DEBUG=1
-
-##
-## Build our 16 bit and 32 bit linuxBIOS entry code
-##
-mainboardinit cpu/i386/entry16.inc
-mainboardinit cpu/i386/entry32.inc
-ldscript cpu/i386/entry16.lds
-ldscript cpu/i386/entry32.lds
-
-##
-## Build our reset vector (This is where linuxBIOS is entered)
-##
-mainboardinit cpu/i386/reset16.inc USE_FALLBACK_IMAGE
-ldscript cpu/i386/reset16.lds USE_FALLBACK_IMAGE
-mainboardinit cpu/i386/reset32.inc USE_NORMAL_IMAGE
-ldscript cpu/i386/reset32.lds USE_NORMAL_IMAGE
-
-### Should this be in the northbridge code?
-mainboardinit arch/i386/lib/cpu_reset.inc
-
-##
-## Include an id string (For safe flashing)
-##
-mainboardinit arch/i386/lib/id.inc
-ldscript arch/i386/lib/id.lds
-
-##
-## Setup our mtrrs
-##
-mainboardinit cpu/k8/earlymtrr.inc
-
-###
-### This is the early phase of linuxBIOS startup 
-### Things are delicate and we test to see if we should
-### failover to another image.
-###
-option MAX_REBOOT_CNT=1
-ldscript arch/i386/lib/failover.lds USE_FALLBACK_IMAGE
-
-
-##
-## Only the bootstrap cpu makes it here.
-## Failover if we need to 
-##
-
-mainboardinit ./failover.inc USE_FALLBACK_IMAGE
-
-###
-### O.k. We aren't just an intermediary anymore!
-###
-
-##
-## When debugging disable the watchdog timer
-##
-#option MAXIMUM_CONSOLE_LOGLEVEL=7
-
-##
-## Setup the serial port
-##
-#mainboardinit superio/winbond/w83627hf/setup_serial.inc
-mainboardinit pc80/serial.inc
-mainboardinit arch/i386/lib/console.inc
-#mainboardinit arch/i386/lib/noop_failover.inc USE_FALLBACK_IMAGE
-
-##
-## Romcc output
-##
-
-makerule ./failover.E: $(MAINBOARD)/failover.c; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E
-makerule ./failover.inc: ./romcc ./failover.E ; ./romcc -O -o failover.inc --label-prefix=failover ./failover.E
-makerule ./auto.E: $(MAINBOARD)/auto.c  ; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E
-makerule ./auto.inc: ./romcc ./auto.E ; ./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E
-mainboardinit cpu/k8/enable_mmx_sse.inc
-mainboardinit ./auto.inc
-mainboardinit cpu/k8/disable_mmx_sse.inc
-
-##
-## Include the secondary Configuration files 
-##
-northbridge amd/amdk8
-southbridge amd/amd8111
-southbridge amd/amd8131
-#mainboardinit arch/i386/smp/secondary.inc
-#nsuperio winbond/w83627hf com1={1} com2={0} floppy=1 lpt=1 keyboard=1
-dir ../../../pc80
-#dir /src/superio/winbond/w83627hf
-cpu p5
-cpu p6
-cpu k7
-cpu k8
-
-##
-## Build the objects we have code for in this directory.
-##
-#object mainboard.o
-driver lsi_scsi.o
-driver adaptec_scsi.o
-driver intel_nic.o
-driver promise_sata.o
-driver mainboard.o
-object static_devices.o
-object mptable.o HAVE_MP_TABLE
-object irq_tables.o HAVE_PIRQ_TABLE
-
-###
-### Build options
-###
-
-
-## OPTION ROM
-#option CONFIG_OPTION_ROM=0
-#option CONFIG_OPTION_ROM_BUSID_DEVFN=0x0340
-#option OPTION_ROM_LSILOGIC_53C1030=1
-
-option CONFIG_LSI_SCSI_FW_FIXUP=1
- 
-##
-## Build code for the fallback boot
-##
-option HAVE_FALLBACK_BOOT=1
-
-
-
-##
-## Delay timer options
-##
-#option CONFIG_UDELAY_TSC=1
-#option CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=1
-#option CONFIG_UDELAY_TIMER2=1
- 
-##
-## Build code to reset the motherboard from linuxBIOS
-##
-# option HAVE_HARD_RESET=1
-
-##
-## Build code to export a programmable irq routing table
-##
-option HAVE_PIRQ_TABLE=1
-option IRQ_SLOT_COUNT=13
-
-##
-## Build code to export an x86 MP table
-## Useful for specifying IRQ routing values
-##
-option HAVE_MP_TABLE=1
-
-##
-## Build code to export a CMOS option table
-##
-option HAVE_OPTION_TABLE=1
-
-##
-## Build code for SMP support
-## Only worry about 2 micro processors
-##
-option CONFIG_SMP=1
-option CONFIG_MAX_CPUS=2
-
-option MEMORY_CONFIG=MEMORY_TYAN_S2880
-
-##
-## Build code to setup a generic IOAPIC
-##
-option CONFIG_IOAPIC=1
-
-##
-## MEMORY_HOLE instructs earlymtrr.inc to
-## enable caching from 0-640KB and to disable 
-## caching from 640KB-1MB using fixed MTRRs 
-##
-## Enabling this option breaks SMP because secondary
-## CPU identification depends on only variable MTRRs
-## being enabled.
-##
-nooption MEMORY_HOLE
-
-##
-## Clean up the motherboard id strings
-##
-option MAINBOARD_PART_NUMBER=s2880
-option MAINBOARD_VENDOR=Tyan
-
-##
-## Figure out which type of linuxBIOS image to build
-## If we aren't a fallback image we must be a normal image
-## This is useful for optional includes
-##
-option USE_FALLBACK_IMAGE=0
-expr USE_NORMAL_IMAGE=!USE_FALLBACK_IMAGE
-
-###
-### LinuxBIOS layout values
-###
-
-## ROM_SIZE is the size of boot ROM that this board will use.
-#option ROM_SIZE=262144
-option ROM_SIZE=524288
-
-
-## LinuxBIOS C code runs at this location in RAM
-#option _RAMBASE=0x00008000
-
-## For the trick of using cache as ram
-## put the fake ram location at this address
-#option CACHE_RAM_BASE=0xfff70000
-#option CACHE_RAM_SIZE=0x00010000
- 
-## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
-option ROM_IMAGE_SIZE=65535
-#option ROM_IMAGE_SIZE=49152
-
-##
-## Use a small 8K stack
-##
-option STACK_SIZE=0x2000
-
-##
-## Use a small 8K heap
-##
-option HEAP_SIZE=0x2000
-#option HEAP_SIZE=0x10000
-
-##
-## Only use the option table in a normal image
-##
-expr USE_OPTION_TABLE=!USE_FALLBACK_IMAGE
-
-##
-## Compute the location and size of where this firmware image
-## (linuxBIOS plus bootloader) will live in the boot rom chip.
-##
-expr ROM_SECTION_SIZE  =(USE_FALLBACK_IMAGE*98304)+(USE_NORMAL_IMAGE*(ROM_SIZE - 98304))
-expr ROM_SECTION_OFFSET=(USE_FALLBACK_IMAGE*(ROM_SIZE-98304))+(USE_NORMAL_IMAGE*0)
-
-##
-## Compute the start location and size size of
-## The linuxBIOS bootloader.
-##
-expr PAYLOAD_SIZE            = ROM_SECTION_SIZE - ROM_IMAGE_SIZE
-expr CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
-option CONFIG_ROM_STREAM     = 1
-
-##
-## Compute where this copy of linuxBIOS will start in the boot rom
-##
-expr _ROMBASE      = CONFIG_ROM_STREAM_START + PAYLOAD_SIZE
-
-##
-## Compute a range of ROM that can cached to speed up linuxBIOS,
-## execution speed.
-##
-expr XIP_ROM_SIZE = 98304 
-expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
-#option XIP_ROM_SIZE=65536
-#option XIP_ROM_BASE=0xffff0000
-
-# XIP_ROM_SIZE && XIP_ROM_BASE values that work.
-#option XIP_ROM_SIZE=0x8000
-#option XIP_ROM_BASE=0xffff8000
-
-
diff -uNr ./freebios2/src/mainboard/tyan/s2880/irq_tables.c ../freebios2/src/mainboard/tyan/s2880/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s2880/irq_tables.c	2003-09-25 18:04:19.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/irq_tables.c	2003-11-22 04:50:26.000000000 -0500
@@ -12,26 +12,26 @@
 	PIRQ_VERSION,   /* u16 version   */
 	32+16*13,        /* there can be total 13 devices on the bus */
 	1,           /* Where the interrupt router lies (bus) */
-	0x3b,           /* Where the interrupt router lies (dev) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
 	0,         /* IRQs devoted exclusively to PCI usage */
 	0x1022,         /* Vendor */
 	0x746b,         /* Device */
 	0,         /* Crap (miniport) */
 	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
-	0x2b,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
+	0x37,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
 	{
-		{0,0x38, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{1,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
 		{0x4,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
-		{0x3,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
-		{0x3,0x30, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x2, 0},
-		{0x2,0x40, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x3, 0},
-		{0x2,0x38, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x4, 0},
-		{0x4,0x30, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
-		{0x4,0x20, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x5, 0},
-		{0x2,0x48, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
-		{0x2,0x50, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
-		{0x4,0x28, {{0x2, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
-		{0x3,0x20, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x6, 0},
-		{0x3,0x28, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x7, 0},
+		{0x3,(3<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
+		{0x3,(6<<3)|0, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x2, 0},
+		{0x2,(8<<3)|0, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x3, 0},
+		{0x2,(7<<3)|0, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x4, 0},
+		{0x4,(6<<3)|0, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x4,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x5, 0},
+		{0x2,(9<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,(0xa<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x4,(5<<3)|0, {{0x2, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x3,(4<<3)|0, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x6, 0},
+		{0x3,(5<<3)|0, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x7, 0},
 	}
 };
diff -uNr ./freebios2/src/mainboard/tyan/s2880/mptable.c ../freebios2/src/mainboard/tyan/s2880/mptable.c
--- ./freebios2/src/mainboard/tyan/s2880/mptable.c	2003-09-25 18:04:19.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/mptable.c	2003-11-22 05:00:25.000000000 -0500
@@ -11,6 +11,12 @@
         static const char productid[12] = "S2880       ";
         struct mp_config_table *mc;
 
+        unsigned char bus_num;
+        unsigned char bus_isa;
+        unsigned char bus_8131_1;
+        unsigned char bus_8131_2;
+        unsigned char bus_8111_1;
+  
         mc = (void *)(((char *)v) + SMP_FLOATING_TABLE_LEN);
         memset(mc, 0, sizeof(*mc));
 
@@ -30,14 +36,54 @@
 
         smp_write_processors(mc, processor_map);
 
+       
+        {
+                device_t dev;
+                
+                /* 8111 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x03,0));
+                if (dev) {
+                        bus_8111_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+                        bus_isa    = pci_read_config8(dev, PCI_SUBORDINATE_BUS);
+                        bus_isa++; 
+                }       
+                else {
+                        printk_debug("ERROR - could not find PCI 1:03.0, using defaults\n");
+
+                        bus_8111_1 = 4;
+                        bus_isa = 5;
+                }
+                /* 8131-1 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x01,0));
+                if (dev) {
+                        bus_8131_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:01.0, using defaults\n");
+
+                        bus_8131_1 = 2;
+                }
+                /* 8131-2 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x02,0));
+                if (dev) {
+                        bus_8131_2 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:02.0, using defaults\n");
+
+                        bus_8131_2 = 3;
+                }
+        }
+
+/*Bus:          Bus ID  Type*/
+        /* define bus and isa numbers */
+        for(bus_num = 0; bus_num < bus_isa; bus_num++) {
+                smp_write_bus(mc, bus_num, "PCI   ");
+        }
+        smp_write_bus(mc, bus_isa, "ISA   ");
 
-/*Bus:		Bus ID	Type*/
-	smp_write_bus(mc, 0, "PCI   ");
-	smp_write_bus(mc, 1, "PCI   ");
-	smp_write_bus(mc, 2, "PCI   ");
-	smp_write_bus(mc, 3, "PCI   ");
-	smp_write_bus(mc, 4, "PCI   ");
-	smp_write_bus(mc, 5, "ISA   ");
 	
 /*I/O APICs:	APIC ID	Version	State		Address*/
 	smp_write_ioapic(mc, 2, 0x11, 0xfec00000);
@@ -59,68 +105,71 @@
 	}
   
 /*I/O Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#
-*/	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x0, 0x2, 0x0);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x1, 0x2, 0x1);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x0, 0x2, 0x2);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x3, 0x2, 0x3);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x4, 0x2, 0x4);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x6, 0x2, 0x6);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x7, 0x2, 0x7);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0x8, 0x2, 0x8);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0xc, 0x2, 0xc);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0xd, 0x2, 0xd);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0xe, 0x2, 0xe);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x5, 0xf, 0x2, 0xf);
+*/	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x2, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x1, 0x2, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x2, 0x2);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x3, 0x2, 0x3);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x4, 0x2, 0x4);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x6, 0x2, 0x6);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x7, 0x2, 0x7);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x8, 0x2, 0x8);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xc, 0x2, 0xc);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xd, 0x2, 0xd);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xe, 0x2, 0xe);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xf, 0x2, 0xf);
 	
 
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 1, (4<<2)|0, 0x2, 0x13);
+
+
 //On Board AMD USB
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x3, 0x2, 0x13);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (0<<2)|3, 0x2, 0x13);
 
 //On Board ATI Display Adapter
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x18, 0x2, 0x12);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (6<<2)|0, 0x2, 0x12);
 
 //Slot 5 PCI 32
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x10, 0x2, 0x10);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x11, 0x2, 0x11);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x12, 0x2, 0x12); //
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x13, 0x2, 0x13); //
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|0, 0x2, 0x10);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|1, 0x2, 0x11);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|2, 0x2, 0x12); //
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|3, 0x2, 0x13); //
 
 //On Board Promise Serial ATA
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x4, 0x14, 0x2, 0x11);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (5<<2)|0, 0x2, 0x11);
 
 //Slot 3 PCIX 100/66
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x20, 0x3, 0x3);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x21, 0x3, 0x0);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x22, 0x3, 0x1);//
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x23, 0x3, 0x2);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|0, 0x3, 0x3);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|1, 0x3, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|2, 0x3, 0x1);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|3, 0x3, 0x2);//
 
 //Slot 4 PCIX 100/66        
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x1c, 0x3, 0x2);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x1d, 0x3, 0x3);//
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x1e, 0x3, 0x0);//
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x1f, 0x3, 0x1);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (7<<2)|0, 0x3, 0x2);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (7<<2)|1, 0x3, 0x3);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (7<<2)|2, 0x3, 0x0);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (7<<2)|3, 0x3, 0x1);//
 
 //On Board NIC and LSI scsi
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x24, 0x3, 0x0);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x25, 0x3, 0x1);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x28, 0x3, 0x0);
-	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x2, 0x29, 0x3, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|0, 0x3, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|1, 0x3, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (0xa<<2)|0, 0x3, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (0xa<<2)|1, 0x3, 0x1);
 
 //Slot 1 PCI-X 133/100/66
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0xc, 0x4, 0x0);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0xd, 0x4, 0x1);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0xe, 0x4, 0x2); //
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0xf, 0x4, 0x3); //
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|0, 0x4, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|1, 0x4, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|2, 0x4, 0x2); //
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|3, 0x4, 0x3); //
 
 //Slot 2 PCI-X 133/100/66
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0x18, 0x4, 0x1);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0x19, 0x4, 0x2);
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0x1a, 0x4, 0x3);//
-        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 0x3, 0x1b, 0x4, 0x0);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (6<<2)|0, 0x4, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (6<<2)|1, 0x4, 0x2);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (6<<2)|2, 0x4, 0x3);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (6<<2)|3, 0x4, 0x0);//
 
 /*Local Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#*/
-	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x0, 0x0, MP_APIC_ALL, 0x0);
-	smp_write_intsrc(mc, mp_NMI, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, 0x0, 0x0, MP_APIC_ALL, 0x1);
+	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x0);
+	smp_write_intsrc(mc, mp_NMI, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x1);
 	/* There is no extension information... */
 
 	/* Compute the checksums */
diff -uNr ./freebios2/src/mainboard/tyan/s2880/reset.c ../freebios2/src/mainboard/tyan/s2880/reset.c
--- ./freebios2/src/mainboard/tyan/s2880/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/reset.c	2003-09-12 17:32:45.000000000 -0400
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x04, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2880/static_devices.c.orig ../freebios2/src/mainboard/tyan/s2880/static_devices.c.orig
--- ./freebios2/src/mainboard/tyan/s2880/static_devices.c.orig	2003-08-27 10:33:13.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/static_devices.c.orig	1969-12-31 19:00:00.000000000 -0500
@@ -1,79 +0,0 @@
-#include <console/console.h>
-#include <stdlib.h>
-#include <string.h>
-#include <device/resource.h>
-#include <device/device.h>
-#include <device/pci.h>
-
-struct cdev {
-	unsigned int devfn;
-	struct cdev *next;
-	struct cdev *children;
-	void *private;
-};
-static struct cdev nodev;
-
-#define DEV(NAME, DEVICE, FUNCTION, NEXT, CHILDREN, PRIVATE) \
-static struct cdev NEXT; \
-static struct cdev CHILDREN; \
-static struct cdev NAME = { \
-	.devfn = PCI_DEVFN(DEVICE, FUNCTION), \
-	.next = &NEXT, \
-	.children = &CHILDREN, \
- 	.private = PRIVATE, \
-}
-
-DEV(dev0_2_0,  0x02, 0, dev0_1f_0, dev1_1c_0, 0);
-DEV(dev0_1f_0, 0x1f, 0, nodev,     nodev,     0);
-DEV(dev1_1c_0, 0x1c, 0, dev1_1e_0, nodev,     0);
-DEV(dev1_1e_0, 0x1e, 0, nodev,     nodev,     0);
-
-static void add_dev_list(struct device *bus, struct cdev *dev);
-
-static void add_device(struct device *bus, struct cdev *dev)
-{
-	struct device *pdev;
-
-#if 1
-	printk_debug("Adding%s %02x.%01x\n",
-		(dev->children == &nodev)?"":" bus",
-		PCI_SLOT(dev->devfn), PCI_FUNC(dev->devfn));
-#endif
-
-	pdev = malloc(sizeof(*pdev));
-	if (!pdev) 
-		goto no_mem;
-
-	memset(pdev, 0, sizeof(*pdev));
-	pdev->bus = bus;
-	pdev->devfn = dev->devfn;
-
-	/* Add to the list of devices on the parent bus. */
-	pdev->sibling = bus->children;
-	bus->children = pdev;
-
-	/* Add any children we might have */
-	add_dev_list(pdev, dev->children);
-	return;
- no_mem:
-	printk_err("PCI: out of memory.\n");
-	return;
-}
-
-static void add_dev_list(struct device *bus, struct cdev *dev)
-{
-	while(dev != &nodev) {
-		add_device(bus, dev);
-		dev = dev->next;
-	}
-}
-void enumerate_static_devices(void)
-{
-#if 0
-	struct cdev *dev = &dev0_2_0;
-	add_dev_list(&dev_root, dev);
-#endif
-#if 0
-	dev_root.ops = &default_ht_ops_root;
-#endif
-}
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,131 +0,0 @@
-## This will make a target directory of ./fallback
-## This is relative to where the configuration file resides in the filesystem
-target ./fallback
-
-mainboard tyan/s2880 
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Fallback
-
-## Build a fallback not a normal image.
-option USE_FALLBACK_IMAGE=1
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./fallback/romimage is just the last 64KB which we reserve for the fallback image.
-option ROM_SIZE=524288
-#option ROM_SIZE=1048576
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#48K
-#option ROM_IMAGE_SIZE=49152
-#42K
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#39K
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536
-#59k
-#option ROM_IMAGE_SIZE=60416
- 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-#payload ../../../../../../etherboot-5.1.8/src/bin/tg3--ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3.zelf
- 
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline console=ttyS0,9600n8 root=/dev/ram0
-                                              
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,134 +0,0 @@
-## This will make a target directory of ./normal
-## This is relative to where the configuration file resides in the filesystem
-target ./normal
-
-mainboard tyan/s2880
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Normal
-
-## Build a normal not a fallback image.
-option USE_FALLBACK_IMAGE=0
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./normal/romimage is the entire rom image except for the last 64KB
-## which are reserved for the fallback image.
-#option ROM_SIZE=524288
-option ROM_SIZE=475136
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#option ROM_IMAGE_SIZE=49152
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536  
- 
-
-## 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-#option CONFIG_IDE_STREAM=1
-#option CONFIG_ROM_STREAM=0
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ./bootloader.ebi
-
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3--ide_disk.zelf
-#payload ../../../../../../freebios/util/ADLO/payload
-#linux ../../../../../../linuxkernel
-
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters	
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-#option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline root=/dev/hda3 rw console=ttyS0,9600 
-                                                    
diff -uNr ./freebios2/src/mainboard/tyan/s2881/adaptec_scsi.c ../freebios2/src/mainboard/tyan/s2881/adaptec_scsi.c
--- ./freebios2/src/mainboard/tyan/s2881/adaptec_scsi.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/adaptec_scsi.c	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void adaptec_scsi_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("ADAPTEC_SCSI_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations adaptec_scsi_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = adaptec_scsi_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver adaptec2_scsi_driver __pci_driver = {
+	.ops    = &adaptec_scsi_ops,
+	.vendor = PCI_VENDOR_ID_ADAPTEC2,
+	.device = 0x8012,
+};
+static struct pci_driver adaptec_scsi_driver __pci_driver = {
+        .ops    = &adaptec_scsi_ops,
+        .vendor = PCI_VENDOR_ID_ADAPTEC,
+        .device = PCI_DEVICE_ID_ADAPTEC_7895,
+};
+ 
Binary files ./freebios2/src/mainboard/tyan/s2881/ati.rom and ../freebios2/src/mainboard/tyan/s2881/ati.rom differ
Binary files ./freebios2/src/mainboard/tyan/s2881/atix.rom and ../freebios2/src/mainboard/tyan/s2881/atix.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s2881/auto.c ../freebios2/src/mainboard/tyan/s2881/auto.c
--- ./freebios2/src/mainboard/tyan/s2881/auto.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/auto.c	2003-11-22 05:31:32.000000000 -0500
@@ -0,0 +1,223 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <cpu/p6/apic.h>
+#include <arch/io.h>
+#include <arch/romcc_io.h>
+#include "pc80/serial.c"
+#include "arch/i386/lib/console.c"
+#include "ram/ramtest.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "southbridge/amd/amd8111/amd8111_early_smbus.c"
+#include "northbridge/amd/amdk8/raminit.h"
+#include "cpu/k8/apic_timer.c"
+#include "lib/delay.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+#include "debug.c"
+#include "northbridge/amd/amdk8/cpu_rev.c"
+
+
+#define REV_B_RESET 0
+static void memreset_setup(void)
+{
+#if REV_B_RESET==1
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=0
+#else
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=1
+#endif
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 17); 
+}
+
+static void memreset(int controllers, const struct mem_controller *ctrl)
+{
+        udelay(800);
+#if REV_B_RESET==1
+        outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 17); //REVB_MEMRST_L=1
+#endif
+        udelay(90);
+}
+
+static unsigned int generate_row(uint8_t node, uint8_t row, uint8_t maxnodes)
+{
+	/* Routing Table Node i 
+	 *
+	 * F0: 0x40, 0x44, 0x48, 0x4c, 0x50, 0x54, 0x58, 0x5c 
+	 *  i:    0,    1,    2,    3,    4,    5,    6,    7
+	 *
+	 * [ 0: 3] Request Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [11: 8] Response Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [19:16] Broadcast route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 */
+
+	uint32_t ret=0x00010101; /* default row entry */
+
+	static const unsigned int rows_2p[2][2] = {
+		{ 0x00030101, 0x00010202 },
+		{ 0x00010202, 0x00030101 }
+	};
+
+	if(maxnodes>2) {
+		print_debug("this mainboard is only designed for 2 cpus\r\n");
+		maxnodes=2;
+	}
+
+
+	if (!(node>=maxnodes || row>=maxnodes)) {
+		ret=rows_2p[node][row];
+	}
+
+	return ret;
+}
+
+static inline void activate_spd_rom(const struct mem_controller *ctrl)
+{
+	/* nothing to do */
+}
+
+static inline int spd_read_byte(unsigned device, unsigned address)
+{
+	return smbus_read_byte(device, address);
+}
+
+/* include mainboard specific ht code */
+#include "hypertransport.c"
+
+//#include "northbridge/amd/amdk8/cpu_ldtstop.c"
+//#include "southbridge/amd/amd8111/amd8111_ldtstop.c"
+
+#include "northbridge/amd/amdk8/raminit.c"
+#include "northbridge/amd/amdk8/coherent_ht.c"
+#include "sdram/generic_sdram.c"
+
+#include "resourcemap.c" /* tyan does not want the default */
+
+static void enable_lapic(void)
+{
+	msr_t msr;
+	msr = rdmsr(0x1b);
+	msr.hi &= 0xffffff00;
+	msr.lo &= 0x000007ff;
+	msr.lo |= APIC_DEFAULT_BASE | (1 << 11);
+	wrmsr(0x1b, msr);
+}
+
+static void stop_this_cpu(void)
+{
+	unsigned apicid;
+	apicid = apic_read(APIC_ID) >> 24;
+
+	/* Send an APIC INIT to myself */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR, APIC_INT_LEVELTRIG | APIC_INT_ASSERT | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* Deassert the APIC INIT */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR,  APIC_INT_LEVELTRIG | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* If I haven't halted spin forever */
+	for(;;) {
+		hlt();
+	}
+}
+#define FIRST_CPU  1
+#define SECOND_CPU 1
+#define TOTAL_CPUS (FIRST_CPU + SECOND_CPU)
+static void main(void)
+{
+	static const struct mem_controller cpu[] = {
+#if FIRST_CPU
+		{
+			.node_id = 0,
+			.f0 = PCI_DEV(0, 0x18, 0),
+			.f1 = PCI_DEV(0, 0x18, 1),
+			.f2 = PCI_DEV(0, 0x18, 2),
+			.f3 = PCI_DEV(0, 0x18, 3),
+			.channel0 = { (0xa<<3)|0, (0xa<<3)|2, 0, 0 },
+			.channel1 = { (0xa<<3)|1, (0xa<<3)|3, 0, 0 },
+		},
+#endif
+#if SECOND_CPU
+		{
+			.node_id = 1,
+			.f0 = PCI_DEV(0, 0x19, 0),
+			.f1 = PCI_DEV(0, 0x19, 1),
+			.f2 = PCI_DEV(0, 0x19, 2),
+			.f3 = PCI_DEV(0, 0x19, 3),
+			.channel0 = { (0xa<<3)|4, (0xa<<3)|6, 0, 0 },
+			.channel1 = { (0xa<<3)|5, (0xa<<3)|7, 0, 0 },
+		},
+#endif
+	};
+	if (cpu_init_detected()) {
+		asm("jmp __cpu_reset");
+	}
+	enable_lapic();
+	init_timer();
+	if (!boot_cpu() ) {
+		notify_bsp_ap_is_stopped();
+		stop_this_cpu();
+	}
+	uart_init();
+	console_init();
+	setup_s2881_resource_map();
+	setup_coherent_ht_domain();
+	enumerate_ht_chain(0);
+	distinguish_cpu_resets(0);
+	
+#if 0
+	print_pci_devices();
+#endif
+	enable_smbus();
+#if 0
+	dump_spd_registers(&cpu[0]);
+#endif
+	memreset_setup();
+	sdram_initialize(sizeof(cpu)/sizeof(cpu[0]), cpu);
+
+#if 0
+	dump_pci_devices();
+#endif
+#if 0
+	dump_pci_device(PCI_DEV(0, 0x18, 1));
+#endif
+
+	/* Check all of memory */
+#if 0
+	msr_t msr;
+	msr = rdmsr(TOP_MEM2);
+	print_debug("TOP_MEM2: ");
+	print_debug_hex32(msr.hi);
+	print_debug_hex32(msr.lo);
+	print_debug("\r\n");
+#endif
+/*
+#if  0
+	ram_check(0x00000000, msr.lo+(msr.hi<<32));
+#else
+#if TOTAL_CPUS < 2
+	// Check 16MB of memory @ 0
+	ram_check(0x00000000, 0x01000000);
+#else
+	// Check 16MB of memory @ 2GB 
+	ram_check(0x80000000, 0x81000000);
+#endif
+#endif
+*/
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/chip.h ../freebios2/src/mainboard/tyan/s2881/chip.h
--- ./freebios2/src/mainboard/tyan/s2881/chip.h	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/chip.h	2003-11-22 03:56:59.000000000 -0500
@@ -0,0 +1,6 @@
+extern struct chip_control mainboard_tyan_s2881_control;
+
+struct mainboard_tyan_s2881_config {
+	int fixup_scsi;
+	int fixup_vga;
+};
diff -uNr ./freebios2/src/mainboard/tyan/s2881/cmos.layout ../freebios2/src/mainboard/tyan/s2881/cmos.layout
--- ./freebios2/src/mainboard/tyan/s2881/cmos.layout	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/cmos.layout	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,74 @@
+entries
+
+#start-bit length  config config-ID    name
+#0            8       r       0        seconds
+#8            8       r       0        alarm_seconds
+#16           8       r       0        minutes
+#24           8       r       0        alarm_minutes
+#32           8       r       0        hours
+#40           8       r       0        alarm_hours
+#48           8       r       0        day_of_week
+#56           8       r       0        day_of_month
+#64           8       r       0        month
+#72           8       r       0        year
+#80           4       r       0        rate_select
+#84           3       r       0        REF_Clock
+#87           1       r       0        UIP
+#88           1       r       0        auto_switch_DST
+#89           1       r       0        24_hour_mode
+#90           1       r       0        binary_values_enable
+#91           1       r       0        square-wave_out_enable
+#92           1       r       0        update_finished_enable
+#93           1       r       0        alarm_interrupt_enable
+#94           1       r       0        periodic_interrupt_enable
+#95           1       r       0        disable_clock_updates
+#96         288       r       0        temporary_filler
+0          384       r       0        reserved_memory
+384          1       e       4        boot_option
+385          1       e       4        last_boot
+386          1       e       1        ECC_memory
+388          4       r       0        reboot_bits
+392          3       e       5        baud_rate
+400          1       e       1        power_on_after_fail
+412          4       e       6        debug_level
+416          4       e       7        boot_first
+420          4       e       7        boot_second
+424          4       e       7        boot_third
+428          4       h       0        boot_index
+432	     8       h       0        boot_countdown
+1008         16      h       0        check_sum
+
+enumerations
+
+#ID value   text
+1     0     Disable
+1     1     Enable
+2     0     Enable
+2     1     Disable
+4     0     Fallback
+4     1     Normal
+5     0     115200
+5     1     57600
+5     2     38400
+5     3     19200
+5     4     9600
+5     5     4800
+5     6     2400
+5     7     1200
+6     6     Notice
+6     7     Info
+6     8     Debug
+6     9     Spew
+7     0     Network
+7     1     HDD
+7     2     Floppy
+7     8     Fallback_Network
+7     9     Fallback_HDD
+7     10    Fallback_Floppy
+#7     3     ROM
+
+checksums
+
+checksum 392 1007 1008
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s2881/Config ../freebios2/src/mainboard/tyan/s2881/Config
--- ./freebios2/src/mainboard/tyan/s2881/Config	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/Config	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,269 @@
+##
+## Set all of the defaults for an x86 architecture
+##
+arch i386
+cpu k8
+
+option DEBUG=1
+
+##
+## Build our 16 bit and 32 bit linuxBIOS entry code
+##
+mainboardinit cpu/i386/entry16.inc
+mainboardinit cpu/i386/entry32.inc
+ldscript cpu/i386/entry16.lds
+ldscript cpu/i386/entry32.lds
+
+##
+## Build our reset vector (This is where linuxBIOS is entered)
+##
+mainboardinit cpu/i386/reset16.inc USE_FALLBACK_IMAGE
+ldscript cpu/i386/reset16.lds USE_FALLBACK_IMAGE
+mainboardinit cpu/i386/reset32.inc USE_NORMAL_IMAGE
+ldscript cpu/i386/reset32.lds USE_NORMAL_IMAGE
+
+### Should this be in the northbridge code?
+mainboardinit arch/i386/lib/cpu_reset.inc
+
+##
+## Include an id string (For safe flashing)
+##
+mainboardinit arch/i386/lib/id.inc
+ldscript arch/i386/lib/id.lds
+
+##
+## Setup our mtrrs
+##
+mainboardinit cpu/k8/earlymtrr.inc
+
+###
+### This is the early phase of linuxBIOS startup 
+### Things are delicate and we test to see if we should
+### failover to another image.
+###
+option MAX_REBOOT_CNT=1
+ldscript arch/i386/lib/failover.lds USE_FALLBACK_IMAGE
+
+
+##
+## Only the bootstrap cpu makes it here.
+## Failover if we need to 
+##
+
+mainboardinit ./failover.inc USE_FALLBACK_IMAGE
+
+###
+### O.k. We aren't just an intermediary anymore!
+###
+
+##
+## When debugging disable the watchdog timer
+##
+#option MAXIMUM_CONSOLE_LOGLEVEL=7
+
+##
+## Setup the serial port
+##
+#mainboardinit superio/winbond/w83627hf/setup_serial.inc
+mainboardinit pc80/serial.inc
+mainboardinit arch/i386/lib/console.inc
+#mainboardinit arch/i386/lib/noop_failover.inc USE_FALLBACK_IMAGE
+
+##
+## Romcc output
+##
+
+makerule ./failover.E: $(MAINBOARD)/failover.c; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E
+makerule ./failover.inc: ./romcc ./failover.E ; ./romcc -O -o failover.inc --label-prefix=failover ./failover.E
+makerule ./auto.E: $(MAINBOARD)/auto.c  ; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E
+makerule ./auto.inc: ./romcc ./auto.E ; ./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E
+mainboardinit cpu/k8/enable_mmx_sse.inc
+mainboardinit ./auto.inc
+mainboardinit cpu/k8/disable_mmx_sse.inc
+
+##
+## Include the secondary Configuration files 
+##
+northbridge amd/amdk8
+southbridge amd/amd8111
+southbridge amd/amd8131
+#mainboardinit arch/i386/smp/secondary.inc
+#nsuperio winbond/w83627hf com1={1} com2={0} floppy=1 lpt=1 keyboard=1
+dir ../../../pc80
+#dir /src/superio/winbond/w83627hf
+cpu p5
+cpu p6
+cpu k7
+cpu k8
+
+##
+## Build the objects we have code for in this directory.
+##
+#object mainboard.o
+driver lsi_scsi.o
+driver adaptec_scsi.o
+driver intel_nic.o
+driver promise_sata.o
+driver mainboard.o
+object static_devices.o
+object mptable.o HAVE_MP_TABLE
+object irq_tables.o HAVE_PIRQ_TABLE
+
+###
+### Build options
+###
+
+
+## OPTION ROM
+#option CONFIG_OPTION_ROM=0
+#option CONFIG_OPTION_ROM_BUSID_DEVFN=0x0340
+#option OPTION_ROM_LSILOGIC_53C1030=1
+
+option CONFIG_LSI_SCSI_FW_FIXUP=1
+ 
+##
+## Build code for the fallback boot
+##
+option HAVE_FALLBACK_BOOT=1
+
+
+
+##
+## Delay timer options
+##
+#option CONFIG_UDELAY_TSC=1
+#option CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=1
+#option CONFIG_UDELAY_TIMER2=1
+ 
+##
+## Build code to reset the motherboard from linuxBIOS
+##
+# option HAVE_HARD_RESET=1
+
+##
+## Build code to export a programmable irq routing table
+##
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=13
+
+##
+## Build code to export an x86 MP table
+## Useful for specifying IRQ routing values
+##
+option HAVE_MP_TABLE=1
+
+##
+## Build code to export a CMOS option table
+##
+option HAVE_OPTION_TABLE=1
+
+##
+## Build code for SMP support
+## Only worry about 2 micro processors
+##
+option CONFIG_SMP=1
+option CONFIG_MAX_CPUS=2
+
+option MEMORY_CONFIG=MEMORY_TYAN_S2880
+
+##
+## Build code to setup a generic IOAPIC
+##
+option CONFIG_IOAPIC=1
+
+##
+## MEMORY_HOLE instructs earlymtrr.inc to
+## enable caching from 0-640KB and to disable 
+## caching from 640KB-1MB using fixed MTRRs 
+##
+## Enabling this option breaks SMP because secondary
+## CPU identification depends on only variable MTRRs
+## being enabled.
+##
+nooption MEMORY_HOLE
+
+##
+## Clean up the motherboard id strings
+##
+option MAINBOARD_PART_NUMBER=s2880
+option MAINBOARD_VENDOR=Tyan
+
+##
+## Figure out which type of linuxBIOS image to build
+## If we aren't a fallback image we must be a normal image
+## This is useful for optional includes
+##
+option USE_FALLBACK_IMAGE=0
+expr USE_NORMAL_IMAGE=!USE_FALLBACK_IMAGE
+
+###
+### LinuxBIOS layout values
+###
+
+## ROM_SIZE is the size of boot ROM that this board will use.
+#option ROM_SIZE=262144
+option ROM_SIZE=524288
+
+
+## LinuxBIOS C code runs at this location in RAM
+#option _RAMBASE=0x00008000
+
+## For the trick of using cache as ram
+## put the fake ram location at this address
+#option CACHE_RAM_BASE=0xfff70000
+#option CACHE_RAM_SIZE=0x00010000
+ 
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=65535
+#option ROM_IMAGE_SIZE=49152
+
+##
+## Use a small 8K stack
+##
+option STACK_SIZE=0x2000
+
+##
+## Use a small 8K heap
+##
+option HEAP_SIZE=0x2000
+#option HEAP_SIZE=0x10000
+
+##
+## Only use the option table in a normal image
+##
+expr USE_OPTION_TABLE=!USE_FALLBACK_IMAGE
+
+##
+## Compute the location and size of where this firmware image
+## (linuxBIOS plus bootloader) will live in the boot rom chip.
+##
+expr ROM_SECTION_SIZE  =(USE_FALLBACK_IMAGE*98304)+(USE_NORMAL_IMAGE*(ROM_SIZE - 98304))
+expr ROM_SECTION_OFFSET=(USE_FALLBACK_IMAGE*(ROM_SIZE-98304))+(USE_NORMAL_IMAGE*0)
+
+##
+## Compute the start location and size size of
+## The linuxBIOS bootloader.
+##
+expr PAYLOAD_SIZE            = ROM_SECTION_SIZE - ROM_IMAGE_SIZE
+expr CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+option CONFIG_ROM_STREAM     = 1
+
+##
+## Compute where this copy of linuxBIOS will start in the boot rom
+##
+expr _ROMBASE      = CONFIG_ROM_STREAM_START + PAYLOAD_SIZE
+
+##
+## Compute a range of ROM that can cached to speed up linuxBIOS,
+## execution speed.
+##
+expr XIP_ROM_SIZE = 98304 
+expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
+#option XIP_ROM_SIZE=65536
+#option XIP_ROM_BASE=0xffff0000
+
+# XIP_ROM_SIZE && XIP_ROM_BASE values that work.
+#option XIP_ROM_SIZE=0x8000
+#option XIP_ROM_BASE=0xffff8000
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s2881/Config.lb ../freebios2/src/mainboard/tyan/s2881/Config.lb
--- ./freebios2/src/mainboard/tyan/s2881/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/Config.lb	2003-11-22 05:34:21.000000000 -0500
@@ -0,0 +1,195 @@
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses USE_FALLBACK_IMAGE
+uses MAINBOARD
+uses ARCH
+#
+#
+###
+### Set all of the defaults for an x86 architecture
+###
+#
+#
+###
+### Build the objects we have code for in this directory.
+###
+##object mainboard.o
+config chip.h
+register "fixup_scsi" = "1" 
+register "fixup_vga" = "1"
+
+
+driver mainboard.o
+driver adaptec_scsi.o
+driver si_sata.o
+driver intel_nic.o
+object reset.o
+if HAVE_MP_TABLE object mptable.o end
+if HAVE_PIRQ_TABLE object irq_tables.o end
+#
+arch i386 end
+#cpu k8 end
+#
+###
+### Build our 16 bit and 32 bit linuxBIOS entry code
+###
+mainboardinit cpu/i386/entry16.inc
+mainboardinit cpu/i386/entry32.inc
+ldscript /cpu/i386/entry16.lds
+ldscript /cpu/i386/entry32.lds
+#
+###
+### Build our reset vector (This is where linuxBIOS is entered)
+###
+if USE_FALLBACK_IMAGE 
+	mainboardinit cpu/i386/reset16.inc 
+	ldscript /cpu/i386/reset16.lds 
+else
+	mainboardinit cpu/i386/reset32.inc 
+	ldscript /cpu/i386/reset32.lds 
+end
+#
+#### Should this be in the northbridge code?
+mainboardinit arch/i386/lib/cpu_reset.inc
+#
+###
+### Include an id string (For safe flashing)
+###
+mainboardinit arch/i386/lib/id.inc
+ldscript /arch/i386/lib/id.lds
+#
+####
+#### This is the early phase of linuxBIOS startup 
+#### Things are delicate and we test to see if we should
+#### failover to another image.
+####
+#option MAX_REBOOT_CNT=2
+if USE_FALLBACK_IMAGE
+  ldscript /arch/i386/lib/failover.lds 
+end
+#
+###
+### Setup our mtrrs
+###
+mainboardinit cpu/k8/earlymtrr.inc
+###
+### Only the bootstrap cpu makes it here.
+### Failover if we need to 
+###
+#
+if USE_FALLBACK_IMAGE
+  mainboardinit ./failover.inc
+end
+
+#
+#
+###
+### Setup the serial port
+###
+#mainboardinit superiowinbond/w83627hf/setup_serial.inc
+mainboardinit pc80/serial.inc
+mainboardinit arch/i386/lib/console.inc
+#
+####
+#### O.k. We aren't just an intermediary anymore!
+####
+#
+###
+### When debugging disable the watchdog timer
+###
+##option MAXIMUM_CONSOLE_LOGLEVEL=7
+#default MAXIMUM_CONSOLE_LOGLEVEL=7
+#
+#if USE_FALLBACK_IMAGE mainboardinit arch/i386/lib/noop_failover.inc  end
+#
+###
+### Romcc output
+###
+#makerule ./failover.E dep "$(MAINBOARD)/failover.c" act "$(CPP) -I$(TOP)/src $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failever.E"
+#makerule ./failover.inc dep "./romcc ./failover.E" act "./romcc -O ./failover.E > failover.inc"
+#mainboardinit .failover.inc
+
+makerule ./failover.E
+	depends "$(MAINBOARD)/failover.c" 
+	action "$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E"
+end
+
+makerule ./failover.inc
+	depends "./romcc ./failover.E"
+	action "./romcc -O -o failover.inc --label-prefix=failover ./failover.E"end
+
+makerule ./auto.E 
+	depends	"$(MAINBOARD)/auto.c" 
+	action	"$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E"
+end
+makerule ./auto.inc 
+	depends "./romcc ./auto.E"
+	action "./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E" 
+#	action	"./romcc -mcpu=k8  -O ./auto.E > auto.inc"
+end
+mainboardinit cpu/k8/enable_mmx_sse.inc
+mainboardinit ./auto.inc
+mainboardinit cpu/k8/disable_mmx_sse.inc
+#
+###
+### Include the secondary Configuration files 
+###
+northbridge amd/amdk8 "mc0"
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.1
+        pci 0:18.2
+        pci 0:18.3
+        southbridge amd/amd8131 "amd8131" link 2
+                pci 0:0.0
+                pci 0:0.1
+                pci 0:1.0
+                pci 0:1.1
+	end
+        southbridge amd/amd8111 "amd8111" link 2
+                pci 0:0.0
+                pci 0:1.0 on
+                pci 0:1.1 on
+                pci 0:1.2 on
+                pci 0:1.3 on
+                pci 0:1.5 off
+                pci 0:1.6 off
+                pci 1:0.0 on
+                pci 1:0.1 on
+                pci 1:0.2 on
+                pci 1:1.0 off
+        end
+end
+
+northbridge amd/amdk8 "mc1"
+        pci 0:19.0
+        pci 0:19.0
+        pci 0:19.0
+        pci 0:19.1
+        pci 0:19.2
+        pci 0:19.3
+end
+
+
+#northbridge amd/amdk8
+#end
+#southbridge amd/amd8111 "amd8111"
+#end
+#southbridge amd/amd8131 "amd8131"
+#end
+#mainboardinit archi386/smp/secondary.inc
+#superio NSC/pc87360
+#	register "com1" = "{1}"
+#	register "lpt" = "{1}"
+#end
+dir /pc80
+##dir /src/superio/winbond/w83627hf
+#dir /bioscall
+#dir /cpu/k8
+cpu k8 "cpu0"
+  register "up" = "{.chip = &amd8131, .ht_width=16, .ht_speed=600}"
+end
+
+cpu k8 "cpu1"
+end
diff -uNr ./freebios2/src/mainboard/tyan/s2881/debug.c ../freebios2/src/mainboard/tyan/s2881/debug.c
--- ./freebios2/src/mainboard/tyan/s2881/debug.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/debug.c	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,127 @@
+
+static void print_debug_pci_dev(unsigned dev)
+{
+	print_debug("PCI: ");
+	print_debug_hex8((dev >> 16) & 0xff);
+	print_debug_char(':');
+	print_debug_hex8((dev >> 11) & 0x1f);
+	print_debug_char('.');
+	print_debug_hex8((dev >> 8) & 7);
+}
+
+static void print_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		print_debug_pci_dev(dev);
+		print_debug("\r\n");
+	}
+}
+
+static void dump_pci_device(unsigned dev)
+{
+	int i;
+	print_debug_pci_dev(dev);
+	print_debug("\r\n");
+	
+	for(i = 0; i <= 255; i++) {
+		unsigned char val;
+		if ((i & 0x0f) == 0) {
+			print_debug_hex8(i);
+			print_debug_char(':');
+		}
+		val = pci_read_config8(dev, i);
+		print_debug_char(' ');
+		print_debug_hex8(val);
+		if ((i & 0x0f) == 0x0f) {
+			print_debug("\r\n");
+		}
+	}
+}
+
+static void dump_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		dump_pci_device(dev);
+	}
+}
+
+static void dump_spd_registers(const struct mem_controller *ctrl)
+{
+	int i;
+	print_debug("\r\n");
+	for(i = 0; i < 4; i++) {
+		unsigned device;
+		device = ctrl->channel0[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".0: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+		device = ctrl->channel1[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".1: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/failover.c ../freebios2/src/mainboard/tyan/s2881/failover.c
--- ./freebios2/src/mainboard/tyan/s2881/failover.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/failover.c	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,38 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <device/pci_ids.h>
+#include <arch/io.h>
+#include "arch/romcc_io.h"
+#include "pc80/mc146818rtc_early.c"
+#include "southbridge/amd/amd8111/amd8111_enable_rom.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+
+static void main(void)
+{
+	/* Nothing special needs to be done to find bus 0 */
+	/* Allow the HT devices to be found */
+	enumerate_ht_chain(0);
+
+	/* Setup the 8111 */
+	amd8111_enable_rom();
+
+	/* Is this a cpu reset? */
+	if (cpu_init_detected()) {
+		if (last_boot_normal()) {
+			asm("jmp __normal_image");
+		} else {
+			asm("jmp __cpu_reset");
+		}
+	}
+	/* Is this a secondary cpu? */
+	else if (!boot_cpu() && last_boot_normal()) {
+		asm("jmp __normal_image");
+	}
+	/* This is the primary cpu how should I boot? */
+	else if (do_normal_boot()) {
+		asm("jmp __normal_image");
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/hypertransport.c ../freebios2/src/mainboard/tyan/s2881/hypertransport.c
--- ./freebios2/src/mainboard/tyan/s2881/hypertransport.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/hypertransport.c	2003-11-22 05:22:06.000000000 -0500
@@ -0,0 +1,63 @@
+/* coherent hypertransport initialization for AMD64 
+ *
+ * tyan mainboard specific setup code from lyh
+ * 
+ * This code is licensed under GPL.
+ */
+
+ static void coherent_ht_mainboard(unsigned cpus)
+{
+
+     static const unsigned int register_values[] = {
+        PCI_ADDR(0, 0x18, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x18, 0, 0xa4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x18, 0, 0xc4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x19, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x19, 0, 0xa4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x19, 0, 0xc4), 0x88ff9c05, 0x770000d0,
+
+
+        PCI_ADDR(0, 0x18, 0, 0x88), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x18, 0, 0xa8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xc8), 0xfffff0ff, 0x00000400,
+        PCI_ADDR(0, 0x19, 0, 0x88), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x19, 0, 0xa8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xc8), 0xfffff0ff, 0x00000000,
+
+        PCI_ADDR(0, 0x18, 0, 0x94), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xd4), 0xff0000ff, 0x00ff0000,
+        PCI_ADDR(0, 0x19, 0, 0x94), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xd4), 0xff0000ff, 0x00000000,
+
+      };
+        int i;
+        int max;
+
+
+        device_t dev;
+        unsigned where;
+        unsigned long reg;
+	
+        print_debug("setting up ht links....\r\n");
+        max = sizeof(register_values)/sizeof(register_values[0]);
+        for(i = 0; i < max; i += 3) {
+#if 0
+                print_debug_hex32(i);
+                print_debug(": ");
+                print_debug_hex32(register_values[i]);
+                print_debug(" <-");
+                print_debug_hex32(register_values[i+2]);
+                print_debug("\r\n");
+#endif
+                dev = register_values[i] & ~0xff;
+                where = register_values[i] & 0xff;
+                reg = pci_read_config32(dev, where);
+                reg &= register_values[i+1];
+                reg |= register_values[i+2];
+                pci_write_config32(dev, where, reg);
+        }
+	print_debug("done\r\n");
+
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/intel_nic.c ../freebios2/src/mainboard/tyan/s2881/intel_nic.c
--- ./freebios2/src/mainboard/tyan/s2881/intel_nic.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/intel_nic.c	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void intel_nic_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("INTEL_NIC_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations intel_nic_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = intel_nic_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver intel_nic_driver __pci_driver = {
+	.ops    = &intel_nic_ops,
+	.vendor = PCI_VENDOR_ID_INTEL,
+	.device = 0x1010,
+};
+static struct pci_driver intel_nic2_driver __pci_driver = {
+        .ops    = &intel_nic_ops,
+        .vendor = PCI_VENDOR_ID_INTEL,
+        .device = 0x100f,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s2881/irq_tables.c ../freebios2/src/mainboard/tyan/s2881/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s2881/irq_tables.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/irq_tables.c	2003-11-22 04:38:28.000000000 -0500
@@ -0,0 +1,33 @@
+/* This file was generated by getpir.c, do not modify! 
+   (but if you do, please run checkpir on it to verify)
+   Contains the IRQ Routing Table dumped directly from your memory , wich BIOS sets up
+
+   Documentation at : http://www.microsoft.com/hwdev/busbios/PCIIRQ.HTM
+*/
+
+#include <arch/pirq_routing.h>
+
+const struct irq_routing_table intel_irq_routing_table = {
+	PIRQ_SIGNATURE, /* u32 signature */
+	PIRQ_VERSION,   /* u16 version   */
+	32+16*9,        /* there can be total 9 devices on the bus */
+	1,           /* Where the interrupt router lies (bus) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
+	0,         /* IRQs devoted exclusively to PCI usage */
+	0x1022,         /* Vendor */
+	0x746b,         /* Device */
+	0,         /* Crap (miniport) */
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
+	0x3d,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
+	{
+		{1,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{0x4,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
+		{0x3,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
+		{0x2,0x38, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x40, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x4, 0},
+		{0x4,0x30, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x48, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,0x50, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x4,0x28, {{0x2, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+	}
+};
diff -uNr ./freebios2/src/mainboard/tyan/s2881/irq_tables.c.old ../freebios2/src/mainboard/tyan/s2881/irq_tables.c.old
--- ./freebios2/src/mainboard/tyan/s2881/irq_tables.c.old	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/irq_tables.c.old	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,37 @@
+/* This file was generated by getpir.c, do not modify! 
+   (but if you do, please run checkpir on it to verify)
+   Contains the IRQ Routing Table dumped directly from your memory , wich BIOS sets up
+
+   Documentation at : http://www.microsoft.com/hwdev/busbios/PCIIRQ.HTM
+*/
+
+#include <arch/pirq_routing.h>
+
+const struct irq_routing_table intel_irq_routing_table = {
+	PIRQ_SIGNATURE, /* u32 signature */
+	PIRQ_VERSION,   /* u16 version   */
+	32+16*12,        /* there can be total 13 devices on the bus */
+	1,           /* Where the interrupt router lies (bus) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
+	0,         /* IRQs devoted exclusively to PCI usage */
+	0x1022,         /* Vendor */
+	0x746b,         /* Device */
+	0,         /* Crap (miniport) */
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
+	0x2b,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
+	{
+		{0x1,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+//		{0x4,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
+		{0x3,(3<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
+		{0x3,(6<<3)|0, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x2, 0},
+		{0x2,(8<<3)|0, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x3, 0},
+		{0x2,(7<<3)|0, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x4, 0},
+		{0x4,(6<<3)|0, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x4,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x5, 0},
+		{0x2,(9<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x2,(0xa<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0, 0},
+		{0x4,(5<<3)|0, {{0x2, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
+		{0x3,(4<<3)|0, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x6, 0},
+		{0x3,(5<<3)|0, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x7, 0},
+	}
+};
diff -uNr ./freebios2/src/mainboard/tyan/s2881/mainboard.c ../freebios2/src/mainboard/tyan/s2881/mainboard.c
--- ./freebios2/src/mainboard/tyan/s2881/mainboard.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/mainboard.c	2003-11-22 03:56:22.000000000 -0500
@@ -0,0 +1,196 @@
+#include <console/console.h>
+#include <device/device.h>
+#include <device/chip.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+#include "../../../northbridge/amd/amdk8/northbridge.h"
+#include "chip.h"
+//#include <part/mainboard.h>
+//#include "lsi_scsi.c"
+unsigned long initial_apicid[CONFIG_MAX_CPUS] =
+{
+	0,1
+};
+#if 0
+static void fixup_lsi_53c1030(struct device *pdev)
+{
+//	uint8_t byte;
+	uint16_t word;
+
+	byte = 1;
+        pci_write_config8(pdev, 0xff, byte);
+           // Set the device id 
+//      pci_write_config_word(pdev, PCI_DEVICE_ID, PCI_DEVICE_ID_LSILOGIC_53C1030);
+           // Set the subsytem vendor id 
+//      pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, PCI_VENDOR_ID_TYAN);  
+        word = 0x10f1;
+	pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, word);
+            // Set the subsytem id 
+	word = 0x2881;
+        pci_write_config16(pdev, PCI_SUBSYSTEM_ID, word);
+            // Disable writes to the device id 
+	byte = 0;
+        pci_write_config8(pdev, 0xff, byte);
+
+//	lsi_scsi_init(pdev);
+	
+}
+#endif
+//extern static void lsi_scsi_init(struct device *dev);
+#if 1
+static void print_pci_regs(struct device *dev)
+{
+      uint8_t byte;
+      int i;
+
+      for(i=0;i<256;i++) {
+	     byte = pci_read_config8(dev, i);
+   
+             if((i%16)==0) printk_debug("\n%02x:",i);
+             printk_debug(" %02x",byte);
+      }
+      printk_debug("\n");
+	
+//        pci_write_config8(dev, 0x4, byte);
+
+}
+#endif
+#if 0
+static void print_mem(void)
+{
+        int i;
+	int low_1MB = 0;
+	for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %02x ",(unsigned char)*((unsigned char *)i));
+             }
+
+        for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %c ",(unsigned char)*((unsigned char *)i));
+             }
+ }
+#endif
+#if 0
+static void amd8111_enable_rom(void)
+{
+        uint8_t byte;
+        struct device *dev;
+
+        /* Enable 4MB rom access at 0xFFC00000 - 0xFFFFFFFF */
+        /* Locate the amd8111 */
+        dev = dev_find_device(0x1022, 0x7468, 0);
+
+        /* Set the 4MB enable bit bit */
+        byte = pci_read_config8(dev, 0x43);
+        byte |= 0x80;
+        pci_write_config8(dev, 0x43, byte);
+}
+#endif
+static void onboard_scsi_fixup(void)
+{
+        struct device *dev;
+#if 0
+	unsigned char i,j,k;
+
+	for(i=0;i<=6;i++) {
+		for(j=0;j<=0x1f;j++) {
+			for (k=0;k<=6;k++){
+				dev = dev_find_slot(i, PCI_DEVFN(j, k));
+				if (dev) {
+			                printk_debug("%02x:%02x:%02x",i,j,k);
+					print_pci_regs(dev);
+        			}
+			}
+		}
+	}
+#endif
+
+
+#if 0
+        dev = dev_find_device(PCI_VENDOR_ID_LSI_LOGIC, PCI_DEVICE_ID_LSI_53C1030,0);
+        if(!dev) {
+                printk_info("LSI_SCSI_FW_FIXUP: No Device Found!");
+                return;
+        }
+
+	lsi_scsi_init(dev); 
+#endif
+//	print_mem();
+//	amd8111_enable_rom();
+}
+#if 1
+static void vga_fixup(void) {
+        // we do this right here because:
+        // - all the hardware is working, and some VGA bioses seem to need
+        //   that
+        // - we need page 0 below for linuxbios tables.
+#if CONFIG_REALMODE_IDT == 1
+        printk_debug("INSTALL REAL-MODE IDT\n");
+        setup_realmode_idt();
+#endif
+#if CONFIG_VGABIOS == 1
+        printk_debug("DO THE VGA BIOS\n");
+        do_vgabios();
+        post_code(0x93);
+#endif
+
+}
+#endif 
+
+static void
+enable(struct chip *chip, enum chip_pass pass)
+{
+
+        struct mainboard_tyan_s2881_config *conf = 
+		(struct mainboard_tyan_s2881_config *)chip->chip_info;
+
+        switch (pass) {
+		default: break;
+//		case CONF_PASS_PRE_CONSOLE:
+//		case CONF_PASS_PRE_PCI:
+//		case CONF_PASS_POST_PCI:		
+                case CONF_PASS_PRE_BOOT:
+			if (conf->fixup_scsi)
+        			onboard_scsi_fixup();
+			if (conf->fixup_vga)
+				vga_fixup();
+			printk_debug("mainboard fixup pass %d done\r\n",
+					pass);
+			break;
+	}
+
+}
+void final_mainboard_fixup(void)
+{
+#if 0
+        enable_ide_devices();
+#endif
+}
+static struct device_operations mainboard_operations = {
+        .read_resources   = root_dev_read_resources,
+        .set_resources    = root_dev_set_resources,
+        .enable_resources = enable_childrens_resources,
+        .init             = 0,
+        .scan_bus         = amdk8_scan_root_bus,
+        .enable           = 0,
+};
+
+static void enumerate(struct chip *chip)
+{
+        struct chip *child;
+        dev_root.ops = &mainboard_operations;
+        chip->dev = &dev_root;
+        chip->bus = 0;
+        for(child = chip->children; child; child = child->next) {
+                child->bus = &dev_root.link[0];
+        }
+}
+struct chip_control mainboard_tyan_s2881_control = {
+        .enable = enable,
+        .enumerate = enumerate,
+        .name      = "Tyan s2881 mainboard ",
+};
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s2881/mptable.c ../freebios2/src/mainboard/tyan/s2881/mptable.c
--- ./freebios2/src/mainboard/tyan/s2881/mptable.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/mptable.c	2003-11-22 04:37:39.000000000 -0500
@@ -0,0 +1,171 @@
+#include <console/console.h>
+#include <arch/smp/mpspec.h>
+#include <device/pci.h>
+#include <string.h>
+#include <stdint.h>
+
+void *smp_write_config_table(void *v, unsigned long * processor_map)
+{
+        static const char sig[4] = "PCMP";
+        static const char oem[8] = "TYAN    ";
+        static const char productid[12] = "S2881       ";
+        struct mp_config_table *mc;
+
+        unsigned char bus_num;
+        unsigned char bus_isa;
+        unsigned char bus_8131_1;
+        unsigned char bus_8131_2;
+        unsigned char bus_8111_1;
+  
+        mc = (void *)(((char *)v) + SMP_FLOATING_TABLE_LEN);
+        memset(mc, 0, sizeof(*mc));
+
+        memcpy(mc->mpc_signature, sig, sizeof(sig));
+        mc->mpc_length = sizeof(*mc); /* initially just the header */
+        mc->mpc_spec = 0x04;
+        mc->mpc_checksum = 0; /* not yet computed */
+        memcpy(mc->mpc_oem, oem, sizeof(oem));
+        memcpy(mc->mpc_productid, productid, sizeof(productid));
+        mc->mpc_oemptr = 0;
+        mc->mpc_oemsize = 0;
+        mc->mpc_entry_count = 0; /* No entries yet... */
+        mc->mpc_lapic = LAPIC_ADDR;
+        mc->mpe_length = 0;
+        mc->mpe_checksum = 0;
+        mc->reserved = 0;
+
+        smp_write_processors(mc, processor_map);
+
+       
+        {
+                device_t dev;
+                
+                /* 8111 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x03,0));
+                if (dev) {
+                        bus_8111_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+                        bus_isa    = pci_read_config8(dev, PCI_SUBORDINATE_BUS);
+                        bus_isa++; 
+                }       
+                else {
+                        printk_debug("ERROR - could not find PCI 1:03.0, using defaults\n");
+
+                        bus_8111_1 = 4;
+                        bus_isa = 5;
+                }
+                /* 8131-1 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x01,0));
+                if (dev) {
+                        bus_8131_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:01.0, using defaults\n");
+
+                        bus_8131_1 = 2;
+                }
+                /* 8131-2 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x02,0));
+                if (dev) {
+                        bus_8131_2 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:02.0, using defaults\n");
+
+                        bus_8131_2 = 3;
+                }
+        }
+
+/*Bus:          Bus ID  Type*/
+        /* define bus and isa numbers */
+        for(bus_num = 0; bus_num < bus_isa; bus_num++) {
+                smp_write_bus(mc, bus_num, "PCI   ");
+        }
+        smp_write_bus(mc, bus_isa, "ISA   ");
+
+	
+/*I/O APICs:	APIC ID	Version	State		Address*/
+	smp_write_ioapic(mc, 2, 0x11, 0xfec00000);
+        {
+                struct pci_dev *dev;
+                uint32_t base;
+                dev = dev_find_slot(1, PCI_DEVFN(0x1,1));
+                if (dev) {
+                        base = pci_read_config32(dev, PCI_BASE_ADDRESS_0);
+                        base &= PCI_BASE_ADDRESS_MEM_MASK;
+                        smp_write_ioapic(mc, 3, 0x11, base);
+                }
+                dev = dev_find_slot(1, PCI_DEVFN(0x2,1));
+                if (dev) {
+                        base = pci_read_config32(dev, PCI_BASE_ADDRESS_0);
+                        base &= PCI_BASE_ADDRESS_MEM_MASK;
+                        smp_write_ioapic(mc, 4, 0x11, base);
+                }
+	}
+  
+/*I/O Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#
+*/	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x2, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x1, 0x2, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x2, 0x2);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x3, 0x2, 0x3);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x4, 0x2, 0x4);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x6, 0x2, 0x6);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x7, 0x2, 0x7);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x8, 0x2, 0x8);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xc, 0x2, 0xc);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xd, 0x2, 0xd);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xe, 0x2, 0xe);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xf, 0x2, 0xf);
+	
+//8111 LPC ????
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 1, (4<<2)|0, 0x2, 0x13);
+
+//On Board AMD USB ???
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (0<<2)|3, 0x2, 0x13);
+
+//On Board ATI Display Adapter
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (6<<2)|0, 0x2, 0x12);
+
+//On Board SI Serial ATA
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (5<<2)|0, 0x2, 0x11);
+
+//Slot 3 PCIX 100/66
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|0, 0x3, 0x3);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|1, 0x3, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|2, 0x3, 0x1);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (8<<2)|3, 0x3, 0x2);//
+
+
+//On Board NIC and LSI scsi
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|0, 0x3, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|1, 0x3, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (0xa<<2)|0, 0x3, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (0xa<<2)|1, 0x3, 0x1);
+
+//Slot 1 PCI-X 133/100/66
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|0, 0x4, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|1, 0x4, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|2, 0x4, 0x2); //
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|3, 0x4, 0x3); //
+
+
+/*Local Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#*/
+	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x0);
+	smp_write_intsrc(mc, mp_NMI, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x1);
+	/* There is no extension information... */
+
+	/* Compute the checksums */
+	mc->mpe_checksum = smp_compute_checksum(smp_next_mpc_entry(mc), mc->mpe_length);
+	mc->mpc_checksum = smp_compute_checksum(mc, mc->mpc_length);
+	printk_debug("Wrote the mp table end at: %p - %p\n",
+		mc, smp_next_mpe_entry(mc));
+	return smp_next_mpe_entry(mc);
+}
+
+unsigned long write_smp_table(unsigned long addr, unsigned long *processor_map)
+{
+	void *v;
+	v = smp_write_floating_table(addr);
+	return (unsigned long)smp_write_config_table(v, processor_map);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/reset.c ../freebios2/src/mainboard/tyan/s2881/reset.c
--- ./freebios2/src/mainboard/tyan/s2881/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/reset.c	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x04, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2881/resourcemap.c ../freebios2/src/mainboard/tyan/s2881/resourcemap.c
--- ./freebios2/src/mainboard/tyan/s2881/resourcemap.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/resourcemap.c	2003-11-22 05:27:25.000000000 -0500
@@ -0,0 +1,264 @@
+/*
+ * Tyan S2881 needs a different resource map
+ *
+ */
+
+static void setup_s2881_resource_map(void)
+{
+	static const unsigned int register_values[] = {
+	/* Careful set limit registers before base registers which contain the enables */
+	/* DRAM Limit i Registers
+	 * F1:0x44 i = 0
+	 * F1:0x4C i = 1
+	 * F1:0x54 i = 2
+	 * F1:0x5C i = 3
+	 * F1:0x64 i = 4
+	 * F1:0x6C i = 5
+	 * F1:0x74 i = 6
+	 * F1:0x7C i = 7
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 7: 3] Reserved
+	 * [10: 8] Interleave select
+	 *	   specifies the values of A[14:12] to use with interleave enable.
+	 * [15:11] Reserved
+	 * [31:16] DRAM Limit Address i Bits 39-24
+	 *	   This field defines the upper address bits of a 40 bit  address
+	 *	   that define the end of the DRAM region.
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x44), 0x0000f8f8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x4C), 0x0000f8f8, 0x00000001,
+	PCI_ADDR(0, 0x18, 1, 0x54), 0x0000f8f8, 0x00000002,
+	PCI_ADDR(0, 0x18, 1, 0x5C), 0x0000f8f8, 0x00000003,
+	PCI_ADDR(0, 0x18, 1, 0x64), 0x0000f8f8, 0x00000004,
+	PCI_ADDR(0, 0x18, 1, 0x6C), 0x0000f8f8, 0x00000005,
+	PCI_ADDR(0, 0x18, 1, 0x74), 0x0000f8f8, 0x00000006,
+	PCI_ADDR(0, 0x18, 1, 0x7C), 0x0000f8f8, 0x00000007,
+	/* DRAM Base i Registers
+	 * F1:0x40 i = 0
+	 * F1:0x48 i = 1
+	 * F1:0x50 i = 2
+	 * F1:0x58 i = 3
+	 * F1:0x60 i = 4
+	 * F1:0x68 i = 5
+	 * F1:0x70 i = 6
+	 * F1:0x78 i = 7
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 7: 2] Reserved
+	 * [10: 8] Interleave Enable
+	 *	   000 = No interleave
+	 *	   001 = Interleave on A[12] (2 nodes)
+	 *	   010 = reserved
+	 *	   011 = Interleave on A[12] and A[14] (4 nodes)
+	 *	   100 = reserved
+	 *	   101 = reserved
+	 *	   110 = reserved
+	 *	   111 = Interleve on A[12] and A[13] and A[14] (8 nodes)
+	 * [15:11] Reserved
+	 * [13:16] DRAM Base Address i Bits 39-24
+	 *	   This field defines the upper address bits of a 40-bit address
+	 *	   that define the start of the DRAM region.
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x40), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x48), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x50), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x58), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x60), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x68), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x70), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x78), 0x0000f8fc, 0x00000000,
+
+	/* Memory-Mapped I/O Limit i Registers
+	 * F1:0x84 i = 0
+	 * F1:0x8C i = 1
+	 * F1:0x94 i = 2
+	 * F1:0x9C i = 3
+	 * F1:0xA4 i = 4
+	 * F1:0xAC i = 5
+	 * F1:0xB4 i = 6
+	 * F1:0xBC i = 7
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 3: 3] Reserved
+	 * [ 5: 4] Destination Link ID
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 = Reserved
+	 * [ 6: 6] Reserved
+	 * [ 7: 7] Non-Posted
+	 *	   0 = CPU writes may be posted
+	 *	   1 = CPU writes must be non-posted
+	 * [31: 8] Memory-Mapped I/O Limit Address i (39-16)
+	 *	   This field defines the upp adddress bits of a 40-bit address that
+	 *	   defines the end of a memory-mapped I/O region n
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x84), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x8C), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x94), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x9C), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA4), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xAC), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB4), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xBC), 0x00000048, 0x00ffff20,
+
+	/* Memory-Mapped I/O Base i Registers
+	 * F1:0x80 i = 0
+	 * F1:0x88 i = 1
+	 * F1:0x90 i = 2
+	 * F1:0x98 i = 3
+	 * F1:0xA0 i = 4
+	 * F1:0xA8 i = 5
+	 * F1:0xB0 i = 6
+	 * F1:0xB8 i = 7
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes disabled
+	 *	   1 = Writes Enabled
+	 * [ 2: 2] Cpu Disable
+	 *	   0 = Cpu can use this I/O range
+	 *	   1 = Cpu requests do not use this I/O range
+	 * [ 3: 3] Lock
+	 *	   0 = base/limit registers i are read/write
+	 *	   1 = base/limit registers i are read-only
+	 * [ 7: 4] Reserved
+	 * [31: 8] Memory-Mapped I/O Base Address i (39-16)
+	 *	   This field defines the upper address bits of a 40bit address 
+	 *	   that defines the start of memory-mapped I/O region i
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x80), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x88), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x90), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x98), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA0), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA8), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB0), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB8), 0x000000f0, 0x00fc0003,
+
+	/* PCI I/O Limit i Registers
+	 * F1:0xC4 i = 0
+	 * F1:0xCC i = 1
+	 * F1:0xD4 i = 2
+	 * F1:0xDC i = 3
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 3: 3] Reserved
+	 * [ 5: 4] Destination Link ID
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 = reserved
+	 * [11: 6] Reserved
+	 * [24:12] PCI I/O Limit Address i
+	 *	   This field defines the end of PCI I/O region n
+	 * [31:25] Reserved
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xC4), 0xFE000FC8, 0x01fff020,
+	PCI_ADDR(0, 0x18, 1, 0xCC), 0xFE000FC8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD4), 0xFE000FC8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xDC), 0xFE000FC8, 0x00000000,
+
+	/* PCI I/O Base i Registers
+	 * F1:0xC0 i = 0
+	 * F1:0xC8 i = 1
+	 * F1:0xD0 i = 2
+	 * F1:0xD8 i = 3
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 3: 2] Reserved
+	 * [ 4: 4] VGA Enable
+	 *	   0 = VGA matches Disabled
+	 *	   1 = matches all address < 64K and where A[9:0] is in the 
+	 *	       range 3B0-3BB or 3C0-3DF independen of the base & limit registers
+	 * [ 5: 5] ISA Enable
+	 *	   0 = ISA matches Disabled
+	 *	   1 = Blocks address < 64K and in the last 768 bytes of eack 1K block
+	 *	       from matching agains this base/limit pair
+	 * [11: 6] Reserved
+	 * [24:12] PCI I/O Base i
+	 *	   This field defines the start of PCI I/O region n 
+	 * [31:25] Reserved
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xC0), 0xFE000FCC, 0x00000003,
+	PCI_ADDR(0, 0x18, 1, 0xC8), 0xFE000FCC, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD0), 0xFE000FCC, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD8), 0xFE000FCC, 0x00000000,
+
+	/* Config Base and Limit i Registers
+	 * F1:0xE0 i = 0
+	 * F1:0xE4 i = 1
+	 * F1:0xE8 i = 2
+	 * F1:0xEC i = 3
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 2: 2] Device Number Compare Enable
+	 *	   0 = The ranges are based on bus number
+	 *	   1 = The ranges are ranges of devices on bus 0
+	 * [ 3: 3] Reserved
+	 * [ 6: 4] Destination Node
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 7: 7] Reserved
+	 * [ 9: 8] Destination Link
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 - Reserved
+	 * [15:10] Reserved
+	 * [23:16] Bus Number Base i
+	 *	   This field defines the lowest bus number in configuration region i
+	 * [31:24] Bus Number Limit i
+	 *	   This field defines the highest bus number in configuration regin i
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xE0), 0x0000FC88, 0xff000203,
+	PCI_ADDR(0, 0x18, 1, 0xE4), 0x0000FC88, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xE8), 0x0000FC88, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xEC), 0x0000FC88, 0x00000000,
+	};
+	int max;
+	max = sizeof(register_values)/sizeof(register_values[0]);
+	setup_resource_map(register_values, max);
+}
+
diff -uNr ./freebios2/src/mainboard/tyan/s2881/si_sata.c ../freebios2/src/mainboard/tyan/s2881/si_sata.c
--- ./freebios2/src/mainboard/tyan/s2881/si_sata.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/si_sata.c	2003-11-22 05:34:05.000000000 -0500
@@ -0,0 +1,45 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void si_sata_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("SI_SATA_FIXUP:  done  \n");
+	
+}
+
+static struct device_operations si_sata_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = si_sata_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver si_sata_driver __pci_driver = {
+        .ops    = &si_sata_ops,
+        .vendor = 0x1095,
+        .device = 0x3114,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s2881/VERSION ../freebios2/src/mainboard/tyan/s2881/VERSION
--- ./freebios2/src/mainboard/tyan/s2881/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2881/VERSION	2003-11-21 02:59:54.000000000 -0500
@@ -0,0 +1 @@
+2.0
Binary files ./freebios2/src/mainboard/tyan/s2882/ati.rom and ../freebios2/src/mainboard/tyan/s2882/ati.rom differ
Binary files ./freebios2/src/mainboard/tyan/s2882/atix.rom and ../freebios2/src/mainboard/tyan/s2882/atix.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s2882/auto.c ../freebios2/src/mainboard/tyan/s2882/auto.c
--- ./freebios2/src/mainboard/tyan/s2882/auto.c	2003-11-04 07:06:03.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2882/auto.c	2003-11-18 21:17:45.000000000 -0500
@@ -17,23 +17,27 @@
 #include "debug.c"
 #include "northbridge/amd/amdk8/cpu_rev.c"
  
-
+#define REV_B_RESET 0
 static void memreset_setup(void)
 {
-	/* Set the memreset low */
-//	outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 28);
-	/* Ensure the BIOS has control of the memory lines */
-//	outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 29);
+#if REV_B_RESET==1
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=0
+#else
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=1
+#endif
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 17);
 }
 
 static void memreset(int controllers, const struct mem_controller *ctrl)
 {
-	udelay(800);
-	/* Set memreset_high */
-//	outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 28);
-	udelay(90);
+        udelay(800);
+#if REV_B_RESET==1
+        outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 17); //REVB_MEMRST_L=1
+#endif
+        udelay(90);
 }
 
+
 static unsigned int generate_row(uint8_t node, uint8_t row, uint8_t maxnodes)
 {
 	/* Routing Table Node i 
@@ -80,9 +84,9 @@
 
 static inline void activate_spd_rom(const struct mem_controller *ctrl)
 {
-	/* nothing to do */
+        /* nothing to do */
 }
-
+ 
 static inline int spd_read_byte(unsigned device, unsigned address)
 {
 	return smbus_read_byte(device, address);
diff -uNr ./freebios2/src/mainboard/tyan/s2882/irq_tables.c ../freebios2/src/mainboard/tyan/s2882/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s2882/irq_tables.c	2003-09-25 18:04:19.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2882/irq_tables.c	2003-12-01 16:21:39.000000000 -0500
@@ -12,7 +12,7 @@
 	PIRQ_VERSION,   /* u16 version   */
 	32+16*15,        /* there can be total 15 devices on the bus */
 	1,           /* Where the interrupt router lies (bus) */
-	0x3b,           /* Where the interrupt router lies (dev) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
 	0,         /* IRQs devoted exclusively to PCI usage */
 	0x1022,         /* Vendor */
 	0x746b,         /* Device */
@@ -20,7 +20,7 @@
 	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
 	0x8d,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
 	{
-		{0,0x38, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{1,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
 		{0x4,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
 		{0x4,0x30, {{0x3, 0xdef8}, {0, 0}, {0, 0}, {0, 0}}, 0, 0},
 		{0x3,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
diff -uNr ./freebios2/src/mainboard/tyan/s2882/reset.c ../freebios2/src/mainboard/tyan/s2882/reset.c
--- ./freebios2/src/mainboard/tyan/s2882/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2882/reset.c	2003-09-16 16:08:40.000000000 -0400
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x04, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2882/tyan-fallback.config ../freebios2/src/mainboard/tyan/s2882/tyan-fallback.config
--- ./freebios2/src/mainboard/tyan/s2882/tyan-fallback.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2882/tyan-fallback.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,131 +0,0 @@
-## This will make a target directory of ./fallback
-## This is relative to where the configuration file resides in the filesystem
-target ./fallback
-
-mainboard tyan/s2882
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Fallback
-
-## Build a fallback not a normal image.
-option USE_FALLBACK_IMAGE=1
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./fallback/romimage is just the last 64KB which we reserve for the fallback image.
-option ROM_SIZE=524288
-#option ROM_SIZE=1048576
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#48K
-#option ROM_IMAGE_SIZE=49152
-#42K
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#39K
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536
-#59k
-#option ROM_IMAGE_SIZE=60416
- 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-#payload ../../../../../../etherboot-5.1.8/src/bin/tg3--ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3.zelf
- 
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline console=ttyS0,9600n8 root=/dev/ram0
-                                              
diff -uNr ./freebios2/src/mainboard/tyan/s2882/tyan-normal.config ../freebios2/src/mainboard/tyan/s2882/tyan-normal.config
--- ./freebios2/src/mainboard/tyan/s2882/tyan-normal.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2882/tyan-normal.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,134 +0,0 @@
-## This will make a target directory of ./normal
-## This is relative to where the configuration file resides in the filesystem
-target ./normal
-
-mainboard tyan/s2882
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Normal
-
-## Build a normal not a fallback image.
-option USE_FALLBACK_IMAGE=0
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./normal/romimage is the entire rom image except for the last 64KB
-## which are reserved for the fallback image.
-option ROM_SIZE=524288
-#option ROM_SIZE=475136
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#option ROM_IMAGE_SIZE=49152
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536  
- 
-
-## 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-#option CONFIG_IDE_STREAM=1
-#option CONFIG_ROM_STREAM=0
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ./bootloader.ebi
-
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3--ide_disk.zelf
-#payload ../../../../../../freebios/util/ADLO/payload
-#linux ../../../../../../linuxkernel
-
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters	
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-#option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline root=/dev/hda3 rw console=ttyS0,9600 
-                                                    
diff -uNr ./freebios2/src/mainboard/tyan/s2885/Config ../freebios2/src/mainboard/tyan/s2885/Config
--- ./freebios2/src/mainboard/tyan/s2885/Config	2003-10-07 10:56:46.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2885/Config	1969-12-31 19:00:00.000000000 -0500
@@ -1,264 +0,0 @@
-##
-## Set all of the defaults for an x86 architecture
-##
-arch i386
-cpu k8
-
-option DEBUG=1
-
-##
-## Build our 16 bit and 32 bit linuxBIOS entry code
-##
-mainboardinit cpu/i386/entry16.inc
-mainboardinit cpu/i386/entry32.inc
-ldscript cpu/i386/entry16.lds
-ldscript cpu/i386/entry32.lds
-
-##
-## Build our reset vector (This is where linuxBIOS is entered)
-##
-mainboardinit cpu/i386/reset16.inc USE_FALLBACK_IMAGE
-ldscript cpu/i386/reset16.lds USE_FALLBACK_IMAGE
-mainboardinit cpu/i386/reset32.inc USE_NORMAL_IMAGE
-ldscript cpu/i386/reset32.lds USE_NORMAL_IMAGE
-
-### Should this be in the northbridge code?
-mainboardinit arch/i386/lib/cpu_reset.inc
-
-##
-## Include an id string (For safe flashing)
-##
-mainboardinit arch/i386/lib/id.inc
-ldscript arch/i386/lib/id.lds
-
-##
-## Setup our mtrrs
-##
-mainboardinit cpu/k8/earlymtrr.inc
-
-###
-### This is the early phase of linuxBIOS startup 
-### Things are delicate and we test to see if we should
-### failover to another image.
-###
-option MAX_REBOOT_CNT=1
-ldscript arch/i386/lib/failover.lds USE_FALLBACK_IMAGE
-
-
-##
-## Only the bootstrap cpu makes it here.
-## Failover if we need to 
-##
-
-mainboardinit ./failover.inc USE_FALLBACK_IMAGE
-
-###
-### O.k. We aren't just an intermediary anymore!
-###
-
-##
-## When debugging disable the watchdog timer
-##
-#option MAXIMUM_CONSOLE_LOGLEVEL=7
-
-##
-## Setup the serial port
-##
-#mainboardinit superio/winbond/w83627hf/setup_serial.inc
-mainboardinit pc80/serial.inc
-mainboardinit arch/i386/lib/console.inc
-#mainboardinit arch/i386/lib/noop_failover.inc USE_FALLBACK_IMAGE
-
-##
-## Romcc output
-##
-
-makerule ./failover.E: $(MAINBOARD)/failover.c; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E
-makerule ./failover.inc: ./romcc ./failover.E ; ./romcc -O -o failover.inc --label-prefix=failover ./failover.E
-makerule ./auto.E: $(MAINBOARD)/auto.c  ; $(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E
-makerule ./auto.inc: ./romcc ./auto.E ; ./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E
-mainboardinit cpu/k8/enable_mmx_sse.inc
-mainboardinit ./auto.inc
-mainboardinit cpu/k8/disable_mmx_sse.inc
-
-##
-## Include the secondary Configuration files 
-##
-northbridge amd/amdk8
-southbridge amd/amd8111
-southbridge amd/amd8131
-#mainboardinit arch/i386/smp/secondary.inc
-#nsuperio winbond/w83627hf com1={1} com2={0} floppy=1 lpt=1 keyboard=1
-dir ../../../pc80
-#dir /src/superio/winbond/w83627hf
-cpu p5
-cpu p6
-cpu k7
-cpu k8
-
-##
-## Build the objects we have code for in this directory.
-##
-#object mainboard.o
-#driver lsi_scsi.o
-#driver adaptec_scsi.o
-#driver intel_nic.o
-#driver promise_sata.o
-driver mainboard.o
-object static_devices.o
-object mptable.o HAVE_MP_TABLE
-object irq_tables.o HAVE_PIRQ_TABLE
-
-###
-### Build options
-###
-
-## OPTION ROM
-#option CONFIG_OPTION_ROM=0
-#option CONFIG_OPTION_ROM_BUSID_DEVFN=0x0340
-#option OPTION_ROM_LSILOGIC_53C1030=1
-
-option CONFIG_LSI_SCSI_FW_FIXUP=1
- 
-##
-## Build code for the fallback boot
-##
-option HAVE_FALLBACK_BOOT=1
-
-##
-## Delay timer options
-##
-#option CONFIG_UDELAY_TSC=1
-#option CONFIG_TSC_X86RDTSC_CALIBRATE_WITH_TIMER2=1
-#option CONFIG_UDELAY_TIMER2=1
- 
-##
-## Build code to reset the motherboard from linuxBIOS
-##
-# option HAVE_HARD_RESET=1
-
-##
-## Build code to export a programmable irq routing table
-##
-option HAVE_PIRQ_TABLE=1
-option IRQ_SLOT_COUNT=13
-
-##
-## Build code to export an x86 MP table
-## Useful for specifying IRQ routing values
-##
-option HAVE_MP_TABLE=1
-
-##
-## Build code to export a CMOS option table
-##
-option HAVE_OPTION_TABLE=1
-
-##
-## Build code for SMP support
-## Only worry about 2 micro processors
-##
-option CONFIG_SMP=1
-option CONFIG_MAX_CPUS=2
-
-option MEMORY_CONFIG=MEMORY_TYAN_S2880
-
-##
-## Build code to setup a generic IOAPIC
-##
-option CONFIG_IOAPIC=1
-
-##
-## MEMORY_HOLE instructs earlymtrr.inc to
-## enable caching from 0-640KB and to disable 
-## caching from 640KB-1MB using fixed MTRRs 
-##
-## Enabling this option breaks SMP because secondary
-## CPU identification depends on only variable MTRRs
-## being enabled.
-##
-nooption MEMORY_HOLE
-
-##
-## Clean up the motherboard id strings
-##
-option MAINBOARD_PART_NUMBER=s2885
-option MAINBOARD_VENDOR=Tyan
-
-##
-## Figure out which type of linuxBIOS image to build
-## If we aren't a fallback image we must be a normal image
-## This is useful for optional includes
-##
-option USE_FALLBACK_IMAGE=0
-expr USE_NORMAL_IMAGE=!USE_FALLBACK_IMAGE
-
-###
-### LinuxBIOS layout values
-###
-
-## ROM_SIZE is the size of boot ROM that this board will use.
-#option ROM_SIZE=262144
-option ROM_SIZE=524288
-
-
-## LinuxBIOS C code runs at this location in RAM
-#option _RAMBASE=0x00008000
-
-## For the trick of using cache as ram
-## put the fake ram location at this address
-#option CACHE_RAM_BASE=0xfff70000
-#option CACHE_RAM_SIZE=0x00010000
- 
-## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
-option ROM_IMAGE_SIZE=65535
-#option ROM_IMAGE_SIZE=49152
-
-##
-## Use a small 8K stack
-##
-option STACK_SIZE=0x2000
-
-##
-## Use a small 8K heap
-##
-option HEAP_SIZE=0x2000
-#option HEAP_SIZE=0x10000
-
-##
-## Only use the option table in a normal image
-##
-expr USE_OPTION_TABLE=!USE_FALLBACK_IMAGE
-
-##
-## Compute the location and size of where this firmware image
-## (linuxBIOS plus bootloader) will live in the boot rom chip.
-##
-expr ROM_SECTION_SIZE  =(USE_FALLBACK_IMAGE*98304)+(USE_NORMAL_IMAGE*(ROM_SIZE - 98304))
-expr ROM_SECTION_OFFSET=(USE_FALLBACK_IMAGE*(ROM_SIZE-98304))+(USE_NORMAL_IMAGE*0)
-
-##
-## Compute the start location and size size of
-## The linuxBIOS bootloader.
-##
-expr PAYLOAD_SIZE            = ROM_SECTION_SIZE - ROM_IMAGE_SIZE
-expr CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
-option CONFIG_ROM_STREAM     = 1
-
-##
-## Compute where this copy of linuxBIOS will start in the boot rom
-##
-expr _ROMBASE      = CONFIG_ROM_STREAM_START + PAYLOAD_SIZE
-
-##
-## Compute a range of ROM that can cached to speed up linuxBIOS,
-## execution speed.
-##
-expr XIP_ROM_SIZE = 98304 
-expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
-#option XIP_ROM_SIZE=65536
-#option XIP_ROM_BASE=0xffff0000
-
-# XIP_ROM_SIZE && XIP_ROM_BASE values that work.
-#option XIP_ROM_SIZE=0x8000
-#option XIP_ROM_BASE=0xffff8000
diff -uNr ./freebios2/src/mainboard/tyan/s2885/irq_tables.c ../freebios2/src/mainboard/tyan/s2885/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s2885/irq_tables.c	2003-09-25 18:04:19.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2885/irq_tables.c	2003-12-01 16:20:42.000000000 -0500
@@ -12,7 +12,7 @@
 	PIRQ_VERSION,   /* u16 version   */
 	32+16*11,        /* there can be total 11 devices on the bus */
 	1,           /* Where the interrupt router lies (bus) */
-	0x3b,           /* Where the interrupt router lies (dev) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
 	0,         /* IRQs devoted exclusively to PCI usage */
 	0x1022,         /* Vendor */
 	0x746b,         /* Device */
@@ -20,7 +20,7 @@
 	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
 	0x35,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
 	{
-		{0,0x38, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{1,(4<<3)|0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
 		{0x4,0, {{0, 0}, {0, 0}, {0, 0}, {0x4, 0xdef8}}, 0, 0},
 		{0x6,0, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0}, {0, 0}}, 0x6, 0},
 		{0x3,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
diff -uNr ./freebios2/src/mainboard/tyan/s2885/reset.c ../freebios2/src/mainboard/tyan/s2885/reset.c
--- ./freebios2/src/mainboard/tyan/s2885/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2885/reset.c	2003-09-03 23:42:43.000000000 -0400
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x04, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2885/tyan-fallback.config ../freebios2/src/mainboard/tyan/s2885/tyan-fallback.config
--- ./freebios2/src/mainboard/tyan/s2885/tyan-fallback.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2885/tyan-fallback.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,131 +0,0 @@
-## This will make a target directory of ./fallback
-## This is relative to where the configuration file resides in the filesystem
-target ./fallback
-
-mainboard tyan/s2885
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Fallback
-
-## Build a fallback not a normal image.
-option USE_FALLBACK_IMAGE=1
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./fallback/romimage is just the last 64KB which we reserve for the fallback image.
-option ROM_SIZE=524288
-#option ROM_SIZE=1048576
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#48K
-#option ROM_IMAGE_SIZE=49152
-#42K
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#39K
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536
-#59k
-#option ROM_IMAGE_SIZE=60416
- 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-#payload ../../../../../../etherboot-5.1.8/src/bin/tg3--ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3.zelf
- 
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline console=ttyS0,9600n8 root=/dev/ram0
-                                              
diff -uNr ./freebios2/src/mainboard/tyan/s2885/tyan-normal.config ../freebios2/src/mainboard/tyan/s2885/tyan-normal.config
--- ./freebios2/src/mainboard/tyan/s2885/tyan-normal.config	2003-09-01 19:17:56.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2885/tyan-normal.config	1969-12-31 19:00:00.000000000 -0500
@@ -1,134 +0,0 @@
-## This will make a target directory of ./normal
-## This is relative to where the configuration file resides in the filesystem
-target ./normal
-
-mainboard tyan/s2885
-
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../VERSION)_Normal
-
-## Build a normal not a fallback image.
-option USE_FALLBACK_IMAGE=0
-
-## Use kgcc (egcs-2.91.66) As the default compiler
-option CC=gcc
-option HOSTCC=gcc
-
-## Build an image for a 512KB rom
-## ./normal/romimage is the entire rom image except for the last 64KB
-## which are reserved for the fallback image.
-option ROM_SIZE=524288
-#option ROM_SIZE=475136
-
-## Select the maximum size the linuxBIOS code can compile to.
-## Allow linuxBIOS to be up to 40KB in size
-#option ROM_IMAGE_SIZE=40960
-#option ROM_IMAGE_SIZE=38922
-#option ROM_IMAGE_SIZE=49152
-#option ROM_IMAGE_SIZE=43008
-#41K
-#option ROM_IMAGE_SIZE=41984
-#option ROM_IMAGE_SIZE=39936
-option ROM_IMAGE_SIZE=65536  
- 
-
-## 
-### The Serial Console
-##
-## Hardware flow control is currently ignored.
-
-## Enable the Serial Console
-option CONFIG_CONSOLE_SERIAL8250=1
-
-## Select the serial console baud rate.
-option TTYS0_BAUD=115200
-#option TTYS0_BAUD=57600
-#option TTYS0_BAUD=38400
-#option TTYS0_BAUD=19200
-#option TTYS0_BAUD=9600
-#option TTYS0_BAUD=4800
-#option TTYS0_BAUD=2400
-#option TTYS0_BAUD=1200
-
-# Select the serial console base port
-option TTYS0_BASE=0x3f8
-
-# Select the serial protocol
-# This defaults to 8 data bits, 1 stop bit, and no parity
-option TTYS0_LCS=0x3
-
-
-##
-### Select the linuxBIOS loglevel
-##
-## EMERG      1   system is unusable               
-## ALERT      2   action must be taken immediately 
-## CRIT       3   critical conditions              
-## ERR        4   error conditions                 
-## WARNING    5   warning conditions               
-## NOTICE     6   normal but significant condition 
-## INFO       7   informational                    
-## DEBUG      8   debug-level messages             
-## SPEW       9   Way too many details             
-
-## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=8
-## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=9
-
-## Select the boot device
-option USE_GENERIC_ROM=1
-#option BOOT_FLOPPY=1
-#option USE_SERIAL_FILL_INBUF=1
-#option BOOT_IDE=1
-#option CONFIG_IDE_STREAM=1
-#option CONFIG_ROM_STREAM=0
-
-# Load etherboot with the elf bootloader
-# The payload command is relative the build directory
-# So .. is the directory this config file resides in
-#payload ./bootloader.ebi
-
-#payload ../../../../../../etherboot-5.1.8/src/bin/ide_disk.zelf
-payload ../../../../../../etherboot-5.1.8/src/binx/tg3--ide_disk.zelf
-#payload ../../../../../../freebios/util/ADLO/payload
-#linux ../../../../../../linuxkernel
-
-# Path to your kernel (vmlinux)
-# NOTE; you need a path to your test12 kernel here. 
-#linux ~/projects/linux/linux-2.4.4.eb1.1
-
-# Kernel command line parameters	
-#commandline ro panic=5 root=/dev/hda5 console=ttyS0,115200 debug 3 
-
-##
-## Cpu Speed
-##
-#option CPU_CLOCK_MULTIPLIER=XEON_X8
-#option CPU_CLOCK_MULTIPLIER=XEON_X9
-#option CPU_CLOCK_MULTIPLIER=XEON_X10
-#option CPU_CLOCK_MULTIPLIER=XEON_X11
-#option CPU_CLOCK_MULTIPLIER=XEON_X12
-#option CPU_CLOCK_MULTIPLIER=XEON_X13
-#option CPU_CLOCK_MULTIPLIER=XEON_X14
-#option CPU_CLOCK_MULTIPLIER=XEON_X15
-#option CPU_CLOCK_MULTIPLIER=XEON_X16
-#option CPU_CLOCK_MULTIPLIER=XEON_X17
-#option CPU_CLOCK_MULTIPLIER=XEON_X18
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X19
-#option CPU_CLOCK_MULTIPLIER=XEON_X20
-#option CPU_CLOCK_MULTIPLIER=XEON_X21
-#option CPU_CLOCK_MULTIPLIER=XEON_X22
-#option CPU_CLOCK_MULTIPLIER=XEON_X23
-
-##
-## Select power on after power fail setting
-option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-#option MAINBOARD_POWER_ON_AFTER_POWER_FAIL=MAINBOARD_POWER_ON
-
-##
-## Should hyper threading be enabled by default
-option CONFIG_LOGICAL_CPUS=0
-
-#commandline root=/dev/hda3 rw console=ttyS0,9600 
-                                                    
diff -uNr ./freebios2/src/mainboard/tyan/s4880/adaptec_scsi.c ../freebios2/src/mainboard/tyan/s4880/adaptec_scsi.c
--- ./freebios2/src/mainboard/tyan/s4880/adaptec_scsi.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/adaptec_scsi.c	2003-09-01 23:33:27.000000000 -0400
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void adaptec_scsi_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("ADAPTEC_SCSI_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations adaptec_scsi_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = adaptec_scsi_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver adaptec2_scsi_driver __pci_driver = {
+	.ops    = &adaptec_scsi_ops,
+	.vendor = PCI_VENDOR_ID_ADAPTEC2,
+	.device = 0x8012,
+};
+static struct pci_driver adaptec_scsi_driver __pci_driver = {
+        .ops    = &adaptec_scsi_ops,
+        .vendor = PCI_VENDOR_ID_ADAPTEC,
+        .device = PCI_DEVICE_ID_ADAPTEC_7895,
+};
+ 
Binary files ./freebios2/src/mainboard/tyan/s4880/ati.rom and ../freebios2/src/mainboard/tyan/s4880/ati.rom differ
Binary files ./freebios2/src/mainboard/tyan/s4880/atix.rom and ../freebios2/src/mainboard/tyan/s4880/atix.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s4880/auto.c ../freebios2/src/mainboard/tyan/s4880/auto.c
--- ./freebios2/src/mainboard/tyan/s4880/auto.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/auto.c	2003-11-27 02:10:47.000000000 -0500
@@ -0,0 +1,284 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <cpu/p6/apic.h>
+#include <arch/io.h>
+#include <arch/romcc_io.h>
+#include "pc80/serial.c"
+#include "arch/i386/lib/console.c"
+#include "ram/ramtest.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "southbridge/amd/amd8111/amd8111_early_smbus.c"
+#include "northbridge/amd/amdk8/raminit.h"
+#include "cpu/k8/apic_timer.c"
+#include "lib/delay.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+#include "debug.c"
+#include "northbridge/amd/amdk8/cpu_rev.c"
+
+
+#define REV_B_RESET 0
+static void memreset_setup(void)
+{
+#if REV_B_RESET==1
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=0
+#else
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 16);  //REVC_MEMRST_EN=1
+#endif
+        outb((0 << 7)|(0 << 6)|(0<<5)|(0<<4)|(1<<2)|(0<<0), SMBUS_IO_BASE + 0xc0 + 17); 
+}
+
+static void memreset(int controllers, const struct mem_controller *ctrl)
+{
+        udelay(800);
+#if REV_B_RESET==1
+        outb((0<<7)|(0<<6)|(0<<5)|(0<<4)|(1<<2)|(1<<0), SMBUS_IO_BASE + 0xc0 + 17); //REVB_MEMRST_L=1
+#endif
+        udelay(90);
+}
+
+static unsigned int generate_row(uint8_t node, uint8_t row, uint8_t maxnodes)
+{
+	/* Routing Table Node i 
+	 *
+	 * F0: 0x40, 0x44, 0x48, 0x4c, 0x50, 0x54, 0x58, 0x5c 
+	 *  i:    0,    1,    2,    3,    4,    5,    6,    7
+	 *
+	 * [ 0: 3] Request Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [11: 8] Response Route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 * [19:16] Broadcast route
+	 *     [0] Route to this node
+	 *     [1] Route to Link 0
+	 *     [2] Route to Link 1
+	 *     [3] Route to Link 2
+	 */
+        uint32_t ret=0x00010101; /* default row entry */
+
+
+        static const unsigned int rows_4p[4][4] = {
+                { 0x00070101, 0x00010202, 0x00030404, 0x00010204 },
+                { 0x00010202, 0x000b0101, 0x00010208, 0x00030808 },
+                { 0x00030808, 0x00010208, 0x000b0101, 0x00010202 },
+                { 0x00010204, 0x00030404, 0x00010202, 0x00070101 }
+        };
+        
+        if (!(node>=maxnodes || row>=maxnodes)) {
+		ret=rows_4p[node][row];
+        }
+
+        return ret;
+}
+
+static inline void activate_spd_rom(const struct mem_controller *ctrl)
+{
+#define SMBUS_HUB 0x18
+        unsigned device=(ctrl->channel0[0])>>8;
+        smbus_write_byte(SMBUS_HUB , 0x01, device);
+        smbus_write_byte(SMBUS_HUB , 0x03, 0);
+}
+#if 0
+static inline void change_i2c_mux(unsigned device)
+{
+#define SMBUS_HUB 0x18
+        smbus_write_byte(SMBUS_HUB , 0x01, device);
+        smbus_write_byte(SMBUS_HUB , 0x03, 0);
+}
+#endif
+
+static inline int spd_read_byte(unsigned device, unsigned address)
+{
+	return smbus_read_byte(device, address);
+}
+
+/* include mainboard specific ht code */
+#include "hypertransport.c"
+
+//#include "northbridge/amd/amdk8/cpu_ldtstop.c"
+//#include "southbridge/amd/amd8111/amd8111_ldtstop.c"
+
+#include "northbridge/amd/amdk8/raminit.c"
+#include "northbridge/amd/amdk8/coherent_ht.c"
+#include "sdram/generic_sdram.c"
+
+#include "resourcemap.c" /* tyan does not want the default */
+
+static void enable_lapic(void)
+{
+	msr_t msr;
+	msr = rdmsr(0x1b);
+	msr.hi &= 0xffffff00;
+	msr.lo &= 0x000007ff;
+	msr.lo |= APIC_DEFAULT_BASE | (1 << 11);
+	wrmsr(0x1b, msr);
+}
+
+static void stop_this_cpu(void)
+{
+	unsigned apicid;
+	apicid = apic_read(APIC_ID) >> 24;
+
+	/* Send an APIC INIT to myself */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR, APIC_INT_LEVELTRIG | APIC_INT_ASSERT | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* Deassert the APIC INIT */
+	apic_write(APIC_ICR2, SET_APIC_DEST_FIELD(apicid));
+	apic_write(APIC_ICR,  APIC_INT_LEVELTRIG | APIC_DM_INIT);
+	/* Wait for the ipi send to finish */
+	apic_wait_icr_idle();
+
+	/* If I haven't halted spin forever */
+	for(;;) {
+		hlt();
+	}
+}
+#define FIRST_CPU  1
+#define SECOND_CPU 1
+
+#define THIRD_CPU  1 
+#define FOURTH_CPU 1 
+
+#define TOTAL_CPUS (FIRST_CPU + SECOND_CPU + THIRD_CPU + FOURTH_CPU)
+
+#define RC0 ((1<<1)<<8)
+#define RC1 ((1<<2)<<8)
+#define RC2 ((1<<3)<<8)
+#define RC3 ((1<<4)<<8)
+
+#define DIMM0 0x50
+#define DIMM1 0x51
+#define DIMM2 0x52
+#define DIMM3 0x53
+        
+static void main(void)
+{
+	static const struct mem_controller cpu[] = {
+#if FIRST_CPU
+                {
+                        .node_id = 0,
+                        .f0 = PCI_DEV(0, 0x18, 0),
+                        .f1 = PCI_DEV(0, 0x18, 1),
+                        .f2 = PCI_DEV(0, 0x18, 2),
+                        .f3 = PCI_DEV(0, 0x18, 3),
+                        .channel0 = { RC0|DIMM0, RC0|DIMM2, 0, 0 },
+                        .channel1 = { RC0|DIMM1, RC0|DIMM3, 0, 0 },
+                },
+#endif
+#if SECOND_CPU
+                {
+                        .node_id = 1,
+                        .f0 = PCI_DEV(0, 0x19, 0),
+                        .f1 = PCI_DEV(0, 0x19, 1),
+                        .f2 = PCI_DEV(0, 0x19, 2),
+                        .f3 = PCI_DEV(0, 0x19, 3),
+                        .channel0 = { RC1|DIMM0, 0 , 0, 0 },
+                        .channel1 = { RC1|DIMM1, 0, 0, 0 },
+
+                },
+#endif
+
+#if THIRD_CPU
+                {
+                        .node_id = 2,
+                        .f0 = PCI_DEV(0, 0x1a, 0),
+                        .f1 = PCI_DEV(0, 0x1a, 1),
+                        .f2 = PCI_DEV(0, 0x1a, 2),
+                        .f3 = PCI_DEV(0, 0x1a, 3),
+                        .channel0 = { RC2|DIMM0, 0, 0, 0 },
+                        .channel1 = { RC2|DIMM1, 0, 0, 0 },
+
+                },
+#endif
+#if FOURTH_CPU
+                {
+                        .node_id = 3,
+                        .f0 = PCI_DEV(0, 0x1b, 0),
+                        .f1 = PCI_DEV(0, 0x1b, 1),
+                        .f2 = PCI_DEV(0, 0x1b, 2),
+                        .f3 = PCI_DEV(0, 0x1b, 3),
+                        .channel0 = { RC3|DIMM0, 0, 0, 0 },
+                        .channel1 = { RC3|DIMM1, 0, 0, 0 },
+
+                },
+#endif
+	};
+	int i;
+	if (cpu_init_detected()) {
+		asm("jmp __cpu_reset");
+	}
+	enable_lapic();
+	init_timer();
+	if (!boot_cpu() ) {
+//		notify_bsp_ap_is_stopped();
+		stop_this_cpu();
+	}
+	uart_init();
+	console_init();
+	setup_s4880_resource_map();
+	setup_coherent_ht_domain();
+	enumerate_ht_chain(0);
+	distinguish_cpu_resets(0);
+	
+#if 0
+	dump_pci_devices();
+#endif
+	enable_smbus();
+#if 0
+
+//	activate_spd_rom(&cpu[0]); 
+//	dump_spd_registers(&cpu[0]);
+
+//	for(i=0;i<4;i++) {
+//		activate_spd_rom(&cpu[i]); 
+//        	dump_smbus_registers();
+//	}
+        for(i=1;i<256;i=i*2) {
+                change_i2c_mux(i);
+                dump_smbus_registers();
+        }
+
+#endif
+	memreset_setup();
+	sdram_initialize(sizeof(cpu)/sizeof(cpu[0]), cpu);
+
+#if 0
+	dump_pci_devices();
+#endif
+#if 0
+	dump_pci_device(PCI_DEV(0, 0x18, 1));
+#endif
+
+	/* Check all of memory */
+#if 0
+	msr_t msr;
+	msr = rdmsr(TOP_MEM2);
+	print_debug("TOP_MEM2: ");
+	print_debug_hex32(msr.hi);
+	print_debug_hex32(msr.lo);
+	print_debug("\r\n");
+#endif
+/*
+#if  0
+	ram_check(0x00000000, msr.lo+(msr.hi<<32));
+#else
+#if TOTAL_CPUS < 2
+	// Check 16MB of memory @ 0
+	ram_check(0x00000000, 0x01000000);
+#else
+	// Check 16MB of memory @ 2GB 
+	ram_check(0x80000000, 0x81000000);
+#endif
+#endif
+*/
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/chip.h ../freebios2/src/mainboard/tyan/s4880/chip.h
--- ./freebios2/src/mainboard/tyan/s4880/chip.h	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/chip.h	2003-11-24 22:31:10.000000000 -0500
@@ -0,0 +1,6 @@
+extern struct chip_control mainboard_tyan_s4880_control;
+
+struct mainboard_tyan_s4880_config {
+//	int fixup_scsi;
+//	int fixup_vga;
+};
diff -uNr ./freebios2/src/mainboard/tyan/s4880/cmos.layout ../freebios2/src/mainboard/tyan/s4880/cmos.layout
--- ./freebios2/src/mainboard/tyan/s4880/cmos.layout	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/cmos.layout	2003-07-21 16:13:43.000000000 -0400
@@ -0,0 +1,74 @@
+entries
+
+#start-bit length  config config-ID    name
+#0            8       r       0        seconds
+#8            8       r       0        alarm_seconds
+#16           8       r       0        minutes
+#24           8       r       0        alarm_minutes
+#32           8       r       0        hours
+#40           8       r       0        alarm_hours
+#48           8       r       0        day_of_week
+#56           8       r       0        day_of_month
+#64           8       r       0        month
+#72           8       r       0        year
+#80           4       r       0        rate_select
+#84           3       r       0        REF_Clock
+#87           1       r       0        UIP
+#88           1       r       0        auto_switch_DST
+#89           1       r       0        24_hour_mode
+#90           1       r       0        binary_values_enable
+#91           1       r       0        square-wave_out_enable
+#92           1       r       0        update_finished_enable
+#93           1       r       0        alarm_interrupt_enable
+#94           1       r       0        periodic_interrupt_enable
+#95           1       r       0        disable_clock_updates
+#96         288       r       0        temporary_filler
+0          384       r       0        reserved_memory
+384          1       e       4        boot_option
+385          1       e       4        last_boot
+386          1       e       1        ECC_memory
+388          4       r       0        reboot_bits
+392          3       e       5        baud_rate
+400          1       e       1        power_on_after_fail
+412          4       e       6        debug_level
+416          4       e       7        boot_first
+420          4       e       7        boot_second
+424          4       e       7        boot_third
+428          4       h       0        boot_index
+432	     8       h       0        boot_countdown
+1008         16      h       0        check_sum
+
+enumerations
+
+#ID value   text
+1     0     Disable
+1     1     Enable
+2     0     Enable
+2     1     Disable
+4     0     Fallback
+4     1     Normal
+5     0     115200
+5     1     57600
+5     2     38400
+5     3     19200
+5     4     9600
+5     5     4800
+5     6     2400
+5     7     1200
+6     6     Notice
+6     7     Info
+6     8     Debug
+6     9     Spew
+7     0     Network
+7     1     HDD
+7     2     Floppy
+7     8     Fallback_Network
+7     9     Fallback_HDD
+7     10    Fallback_Floppy
+#7     3     ROM
+
+checksums
+
+checksum 392 1007 1008
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s4880/Config.lb ../freebios2/src/mainboard/tyan/s4880/Config.lb
--- ./freebios2/src/mainboard/tyan/s4880/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/Config.lb	2003-11-27 02:11:04.000000000 -0500
@@ -0,0 +1,221 @@
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses USE_FALLBACK_IMAGE
+uses MAINBOARD
+uses ARCH
+#
+#
+###
+### Set all of the defaults for an x86 architecture
+###
+#
+#
+###
+### Build the objects we have code for in this directory.
+###
+##object mainboard.o
+config chip.h
+#register "fixup_scsi" = "1" 
+#register "fixup_vga" = "1"
+
+
+driver mainboard.o
+driver lsi_scsi.o
+#driver adaptec_scsi.o
+driver si_sata.o
+#driver intel_nic.o
+object reset.o
+if HAVE_MP_TABLE object mptable.o end
+if HAVE_PIRQ_TABLE object irq_tables.o end
+#
+arch i386 end
+#cpu k8 end
+#
+###
+### Build our 16 bit and 32 bit linuxBIOS entry code
+###
+mainboardinit cpu/i386/entry16.inc
+mainboardinit cpu/i386/entry32.inc
+ldscript /cpu/i386/entry16.lds
+ldscript /cpu/i386/entry32.lds
+#
+###
+### Build our reset vector (This is where linuxBIOS is entered)
+###
+if USE_FALLBACK_IMAGE 
+	mainboardinit cpu/i386/reset16.inc 
+	ldscript /cpu/i386/reset16.lds 
+else
+	mainboardinit cpu/i386/reset32.inc 
+	ldscript /cpu/i386/reset32.lds 
+end
+#
+#### Should this be in the northbridge code?
+mainboardinit arch/i386/lib/cpu_reset.inc
+#
+###
+### Include an id string (For safe flashing)
+###
+mainboardinit arch/i386/lib/id.inc
+ldscript /arch/i386/lib/id.lds
+#
+####
+#### This is the early phase of linuxBIOS startup 
+#### Things are delicate and we test to see if we should
+#### failover to another image.
+####
+#option MAX_REBOOT_CNT=2
+if USE_FALLBACK_IMAGE
+  ldscript /arch/i386/lib/failover.lds 
+end
+#
+###
+### Setup our mtrrs
+###
+mainboardinit cpu/k8/earlymtrr.inc
+###
+### Only the bootstrap cpu makes it here.
+### Failover if we need to 
+###
+#
+if USE_FALLBACK_IMAGE
+  mainboardinit ./failover.inc
+end
+
+#
+#
+###
+### Setup the serial port
+###
+#mainboardinit superiowinbond/w83627hf/setup_serial.inc
+mainboardinit pc80/serial.inc
+mainboardinit arch/i386/lib/console.inc
+#
+####
+#### O.k. We aren't just an intermediary anymore!
+####
+#
+###
+### When debugging disable the watchdog timer
+###
+##option MAXIMUM_CONSOLE_LOGLEVEL=7
+#default MAXIMUM_CONSOLE_LOGLEVEL=7
+#
+#if USE_FALLBACK_IMAGE mainboardinit arch/i386/lib/noop_failover.inc  end
+#
+###
+### Romcc output
+###
+#makerule ./failover.E dep "$(MAINBOARD)/failover.c" act "$(CPP) -I$(TOP)/src $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failever.E"
+#makerule ./failover.inc dep "./romcc ./failover.E" act "./romcc -O ./failover.E > failover.inc"
+#mainboardinit .failover.inc
+
+makerule ./failover.E
+	depends "$(MAINBOARD)/failover.c" 
+	action "$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/failover.c > ./failover.E"
+end
+
+makerule ./failover.inc
+	depends "./romcc ./failover.E"
+	action "./romcc -O -o failover.inc --label-prefix=failover ./failover.E"end
+
+makerule ./auto.E 
+	depends	"$(MAINBOARD)/auto.c" 
+	action	"$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E"
+end
+makerule ./auto.inc 
+	depends "./romcc ./auto.E"
+	action "./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E" 
+#	action	"./romcc -mcpu=k8  -O ./auto.E > auto.inc"
+end
+mainboardinit cpu/k8/enable_mmx_sse.inc
+mainboardinit ./auto.inc
+mainboardinit cpu/k8/disable_mmx_sse.inc
+#
+###
+### Include the secondary Configuration files 
+###
+northbridge amd/amdk8 "mc0"
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.0
+        pci 0:18.1
+        pci 0:18.2
+        pci 0:18.3
+        southbridge amd/amd8131 "amd8131" link 2
+                pci 0:0.0
+                pci 0:0.1
+                pci 0:1.0
+                pci 0:1.1
+	end
+        southbridge amd/amd8111 "amd8111" link 2
+                pci 0:0.0
+                pci 0:1.0 on
+                pci 0:1.1 on
+                pci 0:1.2 on
+                pci 0:1.3 on
+                pci 0:1.5 off
+                pci 0:1.6 off
+                pci 1:0.0 on
+                pci 1:0.1 on
+                pci 1:0.2 on
+                pci 1:1.0 off
+        end
+end
+
+northbridge amd/amdk8 "mc1"
+        pci 0:19.0
+        pci 0:19.0
+        pci 0:19.0
+        pci 0:19.1
+        pci 0:19.2
+        pci 0:19.3
+end
+
+northbridge amd/amdk8 "mc2"
+        pci 0:1a.0
+        pci 0:1a.0
+        pci 0:1a.0
+        pci 0:1a.1
+        pci 0:1a.2
+        pci 0:1a.3
+end
+
+
+northbridge amd/amdk8 "mc3"
+        pci 0:1b.0
+        pci 0:1b.0
+        pci 0:1b.0
+        pci 0:1b.1
+        pci 0:1b.2
+        pci 0:1b.3
+end
+
+
+#northbridge amd/amdk8
+#end
+#southbridge amd/amd8111 "amd8111"
+#end
+#southbridge amd/amd8131 "amd8131"
+#end
+#mainboardinit archi386/smp/secondary.inc
+#superio NSC/pc87360
+#	register "com1" = "{1}"
+#	register "lpt" = "{1}"
+#end
+dir /pc80
+##dir /src/superio/winbond/w83627hf
+#dir /bioscall
+#dir /cpu/k8
+cpu k8 "cpu0"
+  register "up" = "{.chip = &amd8131, .ht_width=16, .ht_speed=600}"
+end
+
+cpu k8 "cpu1"
+end
+
+cpu k8 "cpu2"
+end
+
+cpu k8 "cpu3"
+end
diff -uNr ./freebios2/src/mainboard/tyan/s4880/debug.c ../freebios2/src/mainboard/tyan/s4880/debug.c
--- ./freebios2/src/mainboard/tyan/s4880/debug.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/debug.c	2003-11-27 01:01:52.000000000 -0500
@@ -0,0 +1,157 @@
+
+static void print_debug_pci_dev(unsigned dev)
+{
+	print_debug("PCI: ");
+	print_debug_hex8((dev >> 16) & 0xff);
+	print_debug_char(':');
+	print_debug_hex8((dev >> 11) & 0x1f);
+	print_debug_char('.');
+	print_debug_hex8((dev >> 8) & 7);
+}
+
+static void print_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		print_debug_pci_dev(dev);
+		print_debug("\r\n");
+	}
+}
+
+static void dump_pci_device(unsigned dev)
+{
+	int i;
+	print_debug_pci_dev(dev);
+	print_debug("\r\n");
+	
+	for(i = 0; i <= 255; i++) {
+		unsigned char val;
+		if ((i & 0x0f) == 0) {
+			print_debug_hex8(i);
+			print_debug_char(':');
+		}
+		val = pci_read_config8(dev, i);
+		print_debug_char(' ');
+		print_debug_hex8(val);
+		if ((i & 0x0f) == 0x0f) {
+			print_debug("\r\n");
+		}
+	}
+}
+
+static void dump_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		dump_pci_device(dev);
+	}
+}
+
+static void dump_spd_registers(const struct mem_controller *ctrl)
+{
+	int i;
+	print_debug("\r\n");
+	for(i = 0; i < 4; i++) {
+		unsigned device;
+		device = ctrl->channel0[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".0: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+		device = ctrl->channel1[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".1: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+	}
+}
+static void dump_smbus_registers(void)
+{
+        int i;
+        print_debug("\r\n");
+        for(i = 1; i < 0x80; i++) {
+                unsigned device;
+                device = i;
+                int j;
+                print_debug("smbus: ");
+                print_debug_hex8(device);
+                for(j = 0; j < 256; j++) {
+                	int status; 
+                        unsigned char byte;
+                        if ((j & 0xf) == 0) {
+                	        print_debug("\r\n");
+                                print_debug_hex8(j);
+                                print_debug(": ");
+                        }
+                        status = smbus_read_byte(device, j);
+                        if (status < 0) {
+                                print_debug("bad device\r\n");
+                                break;
+                        }
+                        byte = status & 0xff;
+                        print_debug_hex8(byte);
+                        print_debug_char(' ');
+                }
+                print_debug("\r\n");
+	}	
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/failover.c ../freebios2/src/mainboard/tyan/s4880/failover.c
--- ./freebios2/src/mainboard/tyan/s4880/failover.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/failover.c	2003-07-24 23:05:54.000000000 -0400
@@ -0,0 +1,38 @@
+#define ASSEMBLY 1
+#include <stdint.h>
+#include <device/pci_def.h>
+#include <device/pci_ids.h>
+#include <arch/io.h>
+#include "arch/romcc_io.h"
+#include "pc80/mc146818rtc_early.c"
+#include "southbridge/amd/amd8111/amd8111_enable_rom.c"
+#include "northbridge/amd/amdk8/early_ht.c"
+#include "cpu/p6/boot_cpu.c"
+#include "northbridge/amd/amdk8/reset_test.c"
+
+static void main(void)
+{
+	/* Nothing special needs to be done to find bus 0 */
+	/* Allow the HT devices to be found */
+	enumerate_ht_chain(0);
+
+	/* Setup the 8111 */
+	amd8111_enable_rom();
+
+	/* Is this a cpu reset? */
+	if (cpu_init_detected()) {
+		if (last_boot_normal()) {
+			asm("jmp __normal_image");
+		} else {
+			asm("jmp __cpu_reset");
+		}
+	}
+	/* Is this a secondary cpu? */
+	else if (!boot_cpu() && last_boot_normal()) {
+		asm("jmp __normal_image");
+	}
+	/* This is the primary cpu how should I boot? */
+	else if (do_normal_boot()) {
+		asm("jmp __normal_image");
+	}
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/hypertransport.c ../freebios2/src/mainboard/tyan/s4880/hypertransport.c
--- ./freebios2/src/mainboard/tyan/s4880/hypertransport.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/hypertransport.c	2003-11-27 02:28:17.000000000 -0500
@@ -0,0 +1,87 @@
+/* coherent hypertransport initialization for AMD64 
+ *
+ * tyan mainboard specific setup code from lyh
+ * 
+ * This code is licensed under GPL.
+ */
+
+ static void coherent_ht_mainboard(unsigned cpus)
+{
+/*
+     static const unsigned int register_values[] = {
+        PCI_ADDR(0, 0x18, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x18, 0, 0xa4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x18, 0, 0xc4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x19, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x19, 0, 0xa4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x19, 0, 0xc4), 0x88ff9c05, 0x11000020,
+
+        PCI_ADDR(0, 0x1a, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x1a, 0, 0xa4), 0x88ff9c05, 0x770000d0,
+        PCI_ADDR(0, 0x1a, 0, 0xc4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x1b, 0, 0x84), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x1b, 0, 0xa4), 0x88ff9c05, 0x11000020,
+        PCI_ADDR(0, 0x1b, 0, 0xc4), 0x88ff9c05, 0x770000d0,
+
+
+
+        PCI_ADDR(0, 0x18, 0, 0x88), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x18, 0, 0xa8), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x18, 0, 0xc8), 0xfffff0ff, 0x00000400,
+        PCI_ADDR(0, 0x19, 0, 0x88), 0xfffff0ff, 0x00000500,
+//        PCI_ADDR(0, 0x19, 0, 0xa8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x19, 0, 0xc8), 0xfffff0ff, 0x00000500,
+
+        PCI_ADDR(0, 0x1a, 0, 0x88), 0xfffff0ff, 0x00000500,
+//        PCI_ADDR(0, 0x1a, 0, 0xa8), 0xfffff0ff, 0x00000000,
+        PCI_ADDR(0, 0x1a, 0, 0xc8), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x1b, 0, 0x88), 0xfffff0ff, 0x00000500,
+        PCI_ADDR(0, 0x1b, 0, 0xa8), 0xfffff0ff, 0x00000500,
+//        PCI_ADDR(0, 0x1b, 0, 0xc8), 0xfffff0ff, 0x00000000,
+
+
+
+//        PCI_ADDR(0, 0x18, 0, 0x94), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x18, 0, 0xb4), 0xff0000ff, 0x00000000,
+        PCI_ADDR(0, 0x18, 0, 0xd4), 0xff0000ff, 0x00ff0000,
+//        PCI_ADDR(0, 0x19, 0, 0x94), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x19, 0, 0xb4), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x19, 0, 0xd4), 0xff0000ff, 0x00000000,
+
+//        PCI_ADDR(0, 0x1a, 0, 0x94), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x1a, 0, 0xb4), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x1a, 0, 0xd4), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x1b, 0, 0x94), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x1b, 0, 0xb4), 0xff0000ff, 0x00000000,
+//        PCI_ADDR(0, 0x1b, 0, 0xd4), 0xff0000ff, 0x00000000,
+      };
+        int i;
+        int max;
+
+
+        device_t dev;
+        unsigned where;
+        unsigned long reg;
+	
+        print_debug("setting up ht links....\r\n");
+        max = sizeof(register_values)/sizeof(register_values[0]);
+        for(i = 0; i < max; i += 3) {
+#if 0
+                print_debug_hex32(i);
+                print_debug(": ");
+                print_debug_hex32(register_values[i]);
+                print_debug(" <-");
+                print_debug_hex32(register_values[i+2]);
+                print_debug("\r\n");
+#endif
+                dev = register_values[i] & ~0xff;
+                where = register_values[i] & 0xff;
+                reg = pci_read_config32(dev, where);
+                reg &= register_values[i+1];
+                reg |= register_values[i+2];
+                pci_write_config32(dev, where, reg);
+        }
+	print_debug("done\r\n");
+
+*/
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/intel_nic.c ../freebios2/src/mainboard/tyan/s4880/intel_nic.c
--- ./freebios2/src/mainboard/tyan/s4880/intel_nic.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/intel_nic.c	2003-09-01 23:33:27.000000000 -0400
@@ -0,0 +1,51 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void intel_nic_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("INTEL_NIC_FIXUP:  done  \n");
+	
+	
+}
+
+static struct device_operations intel_nic_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = intel_nic_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver intel_nic_driver __pci_driver = {
+	.ops    = &intel_nic_ops,
+	.vendor = PCI_VENDOR_ID_INTEL,
+	.device = 0x1010,
+};
+static struct pci_driver intel_nic2_driver __pci_driver = {
+        .ops    = &intel_nic_ops,
+        .vendor = PCI_VENDOR_ID_INTEL,
+        .device = 0x100f,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s4880/irq_tables.c ../freebios2/src/mainboard/tyan/s4880/irq_tables.c
--- ./freebios2/src/mainboard/tyan/s4880/irq_tables.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/irq_tables.c	2003-11-24 21:51:54.000000000 -0500
@@ -0,0 +1,46 @@
+/* This file was generated by getpir.c, do not modify! 
+   (but if you do, please run checkpir on it to verify)
+   Contains the IRQ Routing Table dumped directly from your memory , wich BIOS sets up
+
+   Documentation at : http://www.microsoft.com/hwdev/busbios/PCIIRQ.HTM
+*/
+
+#include <arch/pirq_routing.h>
+
+const struct irq_routing_table intel_irq_routing_table = {
+	PIRQ_SIGNATURE, /* u32 signature */
+	PIRQ_VERSION,   /* u16 version   */
+	32+16*22,        /* there can be total 22 devices on the bus */
+	1,           /* Where the interrupt router lies (bus) */
+	(4<<3)|3,           /* Where the interrupt router lies (dev) */
+	0,         /* IRQs devoted exclusively to PCI usage */
+	0x1022,         /* Vendor */
+	0x7400,         /* Device */
+	0,         /* Crap (miniport) */
+	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, /* u8 rfu[11] */
+	0x9a,         /*  u8 checksum , this hase to set to some value that would give 0 after the sum of all bytes for this structure (including checksum) */
+	{
+		{0,0xc0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{1,(3<<3)|0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x4,0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0x4, 0xdef8}}, 0, 0},
+		{0x4,0x8, {{0x1, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x4,0x20, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x1, 0},
+		{0x4,0x18, {{0x2, 0xdef8}, {0x1, 0xdef8}, {0x3, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x4,0x28, {{0x4, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x4,0x30, {{0x3, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{1,(4<<3)|0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{1,(1<<3)|0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x2,0x18, {{0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}}, 0x2, 0},
+		{0x2,0x10, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x3, 0},
+		{0x2,0x48, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x2,0x20, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{1,(2<<3)|0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0x3,0x18, {{0x1, 0xdef8}, {0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}}, 0x4, 0},
+		{0x3,0x8, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x5, 0},
+		{0x3,0x20, {{0x2, 0xdef8}, {0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}}, 0x6, 0},
+		{0x3,0x28, {{0x3, 0xdef8}, {0x4, 0xdef8}, {0x1, 0xdef8}, {0x2, 0xdef8}}, 0x7, 0},
+		{0,0xc8, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0,0xd0, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+		{0,0xd8, {{0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}, {0, 0xdef8}}, 0, 0},
+	}
+};
diff -uNr ./freebios2/src/mainboard/tyan/s4880/mainboard.c ../freebios2/src/mainboard/tyan/s4880/mainboard.c
--- ./freebios2/src/mainboard/tyan/s4880/mainboard.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/mainboard.c	2003-11-24 23:31:11.000000000 -0500
@@ -0,0 +1,192 @@
+#include <console/console.h>
+#include <device/device.h>
+#include <device/chip.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+#include "../../../northbridge/amd/amdk8/northbridge.h"
+#include "chip.h"
+//#include <part/mainboard.h>
+//#include "lsi_scsi.c"
+unsigned long initial_apicid[CONFIG_MAX_CPUS] =
+{
+	0,1,2,3
+};
+#if 0
+static void fixup_lsi_53c1030(struct device *pdev)
+{
+//	uint8_t byte;
+	uint16_t word;
+
+	byte = 1;
+        pci_write_config8(pdev, 0xff, byte);
+           // Set the device id 
+//      pci_write_config_word(pdev, PCI_DEVICE_ID, PCI_DEVICE_ID_LSILOGIC_53C1030);
+           // Set the subsytem vendor id 
+//      pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, PCI_VENDOR_ID_TYAN);  
+        word = 0x10f1;
+	pci_write_config16(pdev, PCI_SUBSYSTEM_VENDOR_ID, word);
+            // Set the subsytem id 
+	word = 0x4880;
+        pci_write_config16(pdev, PCI_SUBSYSTEM_ID, word);
+            // Disable writes to the device id 
+	byte = 0;
+        pci_write_config8(pdev, 0xff, byte);
+
+//	lsi_scsi_init(pdev);
+	
+}
+#endif
+//extern static void lsi_scsi_init(struct device *dev);
+#if 0
+static void print_pci_regs(struct device *dev)
+{
+      uint8_t byte;
+      int i;
+
+      for(i=0;i<256;i++) {
+	     byte = pci_read_config8(dev, i);
+   
+             if((i%16)==0) printk_debug("\n%02x:",i);
+             printk_debug(" %02x",byte);
+      }
+      printk_debug("\n");
+	
+//        pci_write_config8(dev, 0x4, byte);
+
+}
+#endif
+#if 0
+static void print_mem(void)
+{
+        int i;
+	int low_1MB = 0;
+	for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %02x ",(unsigned char)*((unsigned char *)i));
+             }
+
+        for(i=low_1MB;i<low_1MB+1024*4;i++) {
+             if((i%16)==0) printk_debug("\n %08x:",i);
+             printk_debug(" %c ",(unsigned char)*((unsigned char *)i));
+             }
+ }
+#endif
+#if 0
+static void amd8111_enable_rom(void)
+{
+        uint8_t byte;
+        struct device *dev;
+
+        /* Enable 4MB rom access at 0xFFC00000 - 0xFFFFFFFF */
+        /* Locate the amd8111 */
+        dev = dev_find_device(0x1022, 0x7468, 0);
+
+        /* Set the 4MB enable bit bit */
+        byte = pci_read_config8(dev, 0x43);
+        byte |= 0x80;
+        pci_write_config8(dev, 0x43, byte);
+}
+#endif
+#if 0
+static void onboard_scsi_fixup(void)
+{
+        struct device *dev;
+#if 0
+	unsigned char i,j,k;
+
+	for(i=0;i<=6;i++) {
+		for(j=0;j<=0x1f;j++) {
+			for (k=0;k<=6;k++){
+				dev = dev_find_slot(i, PCI_DEVFN(j, k));
+				if (dev) {
+			                printk_debug("%02x:%02x:%02x",i,j,k);
+					print_pci_regs(dev);
+        			}
+			}
+		}
+	}
+#endif
+
+
+#if 0
+        dev = dev_find_device(PCI_VENDOR_ID_LSI_LOGIC, PCI_DEVICE_ID_LSI_53C1030,0);
+        if(!dev) {
+                printk_info("LSI_SCSI_FW_FIXUP: No Device Found!");
+                return;
+        }
+
+	lsi_scsi_init(dev); 
+#endif
+//	print_mem();
+//	amd8111_enable_rom();
+}
+#endif
+#if 0
+static void vga_fixup(void) {
+        // we do this right here because:
+        // - all the hardware is working, and some VGA bioses seem to need
+        //   that
+        // - we need page 0 below for linuxbios tables.
+#if CONFIG_REALMODE_IDT == 1
+        printk_debug("INSTALL REAL-MODE IDT\n");
+        setup_realmode_idt();
+#endif
+#if CONFIG_VGABIOS == 1
+        printk_debug("DO THE VGA BIOS\n");
+        do_vgabios();
+        post_code(0x93);
+#endif
+
+}
+#endif 
+
+static void
+enable(struct chip *chip, enum chip_pass pass)
+{
+
+        struct mainboard_tyan_s4880_config *conf = 
+		(struct mainboard_tyan_s4880_config *)chip->chip_info;
+
+        switch (pass) {
+		default: break;
+//		case CONF_PASS_PRE_CONSOLE:
+//		case CONF_PASS_PRE_PCI:
+//		case CONF_PASS_POST_PCI:		
+                case CONF_PASS_PRE_BOOT:
+//			if (conf->fixup_scsi)
+//        			onboard_scsi_fixup();
+//			if (conf->fixup_vga)
+//				vga_fixup();
+			printk_debug("mainboard fixup pass %d done\r\n",
+					pass);
+			break;
+	}
+
+}
+static struct device_operations mainboard_operations = {
+        .read_resources   = root_dev_read_resources,
+        .set_resources    = root_dev_set_resources,
+        .enable_resources = enable_childrens_resources,
+        .init             = 0,
+        .scan_bus         = amdk8_scan_root_bus,
+        .enable           = 0,
+};
+
+static void enumerate(struct chip *chip)
+{
+        struct chip *child;
+        dev_root.ops = &mainboard_operations;
+        chip->dev = &dev_root;
+        chip->bus = 0;
+        for(child = chip->children; child; child = child->next) {
+                child->bus = &dev_root.link[0];
+        }
+}
+struct chip_control mainboard_tyan_s4880_control = {
+        .enable = enable,
+        .enumerate = enumerate,
+        .name      = "Tyan s4880 mainboard ",
+};
+
+
diff -uNr ./freebios2/src/mainboard/tyan/s4880/mptable.c ../freebios2/src/mainboard/tyan/s4880/mptable.c
--- ./freebios2/src/mainboard/tyan/s4880/mptable.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/mptable.c	2003-12-01 18:13:37.000000000 -0500
@@ -0,0 +1,198 @@
+#include <console/console.h>
+#include <arch/smp/mpspec.h>
+#include <device/pci.h>
+#include <string.h>
+#include <stdint.h>
+
+void *smp_write_config_table(void *v, unsigned long * processor_map)
+{
+        static const char sig[4] = "PCMP";
+        static const char oem[8] = "TYAN    ";
+        static const char productid[12] = "S4880       ";
+        struct mp_config_table *mc;
+
+        unsigned char bus_num;
+        unsigned char bus_isa;
+        unsigned char bus_8131_1;
+        unsigned char bus_8131_2;
+        unsigned char bus_8111_1;
+  
+        mc = (void *)(((char *)v) + SMP_FLOATING_TABLE_LEN);
+        memset(mc, 0, sizeof(*mc));
+
+        memcpy(mc->mpc_signature, sig, sizeof(sig));
+        mc->mpc_length = sizeof(*mc); /* initially just the header */
+        mc->mpc_spec = 0x04;
+        mc->mpc_checksum = 0; /* not yet computed */
+        memcpy(mc->mpc_oem, oem, sizeof(oem));
+        memcpy(mc->mpc_productid, productid, sizeof(productid));
+        mc->mpc_oemptr = 0;
+        mc->mpc_oemsize = 0;
+        mc->mpc_entry_count = 0; /* No entries yet... */
+        mc->mpc_lapic = LAPIC_ADDR;
+        mc->mpe_length = 0;
+        mc->mpe_checksum = 0;
+        mc->reserved = 0;
+
+        smp_write_processors(mc, processor_map);
+
+       
+        {
+                device_t dev;
+                
+                /* 8111 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x03,0));
+                if (dev) {
+                        bus_8111_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+                        bus_isa    = pci_read_config8(dev, PCI_SUBORDINATE_BUS);
+                        bus_isa++; 
+                }       
+                else {
+                        printk_debug("ERROR - could not find PCI 1:03.0, using defaults\n");
+
+                        bus_8111_1 = 4;
+                        bus_isa = 5;
+                }
+                /* 8131-1 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x01,0));
+                if (dev) {
+                        bus_8131_1 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:01.0, using defaults\n");
+
+                        bus_8131_1 = 2;
+                }
+                /* 8131-2 */
+                dev = dev_find_slot(1, PCI_DEVFN(0x02,0));
+                if (dev) {
+                        bus_8131_2 = pci_read_config8(dev, PCI_SECONDARY_BUS);
+
+                }
+                else {
+                        printk_debug("ERROR - could not find PCI 1:02.0, using defaults\n");
+
+                        bus_8131_2 = 3;
+                }
+        }
+
+/*Bus:          Bus ID  Type*/
+        /* define bus and isa numbers */
+        for(bus_num = 0; bus_num < bus_isa; bus_num++) {
+                smp_write_bus(mc, bus_num, "PCI   ");
+        }
+        smp_write_bus(mc, bus_isa, "ISA   ");
+
+	
+/*I/O APICs:	APIC ID	Version	State		Address*/
+	smp_write_ioapic(mc, 4, 0x11, 0xfec00000);
+        {
+                struct pci_dev *dev;
+                uint32_t base;
+                dev = dev_find_slot(1, PCI_DEVFN(0x1,1));
+                if (dev) {
+                        base = pci_read_config32(dev, PCI_BASE_ADDRESS_0);
+                        base &= PCI_BASE_ADDRESS_MEM_MASK;
+                        smp_write_ioapic(mc, 5, 0x11, base);
+                }
+                dev = dev_find_slot(1, PCI_DEVFN(0x2,1));
+                if (dev) {
+                        base = pci_read_config32(dev, PCI_BASE_ADDRESS_0);
+                        base &= PCI_BASE_ADDRESS_MEM_MASK;
+                        smp_write_ioapic(mc, 6, 0x11, base);
+                }
+	}
+  
+/*I/O Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#
+*/	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x4, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x1, 0x4, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, 0x4, 0x2);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x3, 0x4, 0x3);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x4, 0x4, 0x4);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x5, 0x4, 0x5);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x6, 0x4, 0x6);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x7, 0x4, 0x7);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x8, 0x4, 0x8);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x9, 0x4, 0x9);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xa, 0x4, 0xa);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xb, 0x4, 0xb);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xc, 0x4, 0xc);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xd, 0x4, 0xd);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xe, 0x4, 0xe);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0xf, 0x4, 0xf);
+	
+
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, 1, (4<<2)|0, 0x4, 0x13);
+
+
+//On Board AMD USB
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (0<<2)|3, 0x4, 0x13);
+
+//On Board Via USB 1.1 and 2
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (3<<2)|0, 0x4, 0x11); //1.1
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (3<<2)|1, 0x4, 0x12); //1.1
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (3<<2)|2, 0x4, 0x10); //2
+
+//Slot 5 PCI 32
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|0, 0x4, 0x10);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|1, 0x4, 0x11);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|2, 0x4, 0x12); //
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (4<<2)|3, 0x4, 0x13); //
+
+
+//On Board SI Serial ATA
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (5<<2)|0, 0x4, 0x13);
+//On Board ATI Display Adapter
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8111_1, (6<<2)|0, 0x4, 0x12);
+
+
+//Slot 4 PCIX 100/66
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (3<<2)|0, 0x5, 0x3);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (3<<2)|1, 0x5, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (3<<2)|2, 0x5, 0x1);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (3<<2)|3, 0x5, 0x2);//
+
+//Slot 3 PCIX 100/66        
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (2<<2)|0, 0x5, 0x2);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (2<<2)|1, 0x5, 0x3);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (2<<2)|2, 0x5, 0x0);//
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (2<<2)|3, 0x5, 0x1);//
+
+//On Board LSI scsi and NIC
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (4<<2)|0, 0x5, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (4<<2)|1, 0x5, 0x1);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|0, 0x5, 0x0);
+	smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_1, (9<<2)|1, 0x5, 0x1);
+
+//Slot 2 PCI-X 133/100/66
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|0, 0x6, 0x0);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|1, 0x6, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|2, 0x6, 0x2); //
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (3<<2)|3, 0x6, 0x3); //
+
+//Slot 1 PCI-X 133/100/66
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (1<<2)|0, 0x6, 0x1);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (1<<2)|1, 0x6, 0x2);
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (1<<2)|2, 0x6, 0x3);//
+        smp_write_intsrc(mc, mp_INT, MP_IRQ_TRIGGER_LEVEL|MP_IRQ_POLARITY_LOW, bus_8131_2, (1<<2)|3, 0x6, 0x0);//
+
+/*Local Ints:	Type	Polarity    Trigger	Bus ID	 IRQ	APIC ID	PIN#*/
+	smp_write_intsrc(mc, mp_ExtINT, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x0);
+	smp_write_intsrc(mc, mp_NMI, MP_IRQ_TRIGGER_EDGE|MP_IRQ_POLARITY_HIGH, bus_isa, 0x0, MP_APIC_ALL, 0x1);
+	/* There is no extension information... */
+
+	/* Compute the checksums */
+	mc->mpe_checksum = smp_compute_checksum(smp_next_mpc_entry(mc), mc->mpe_length);
+	mc->mpc_checksum = smp_compute_checksum(mc, mc->mpc_length);
+	printk_debug("Wrote the mp table end at: %p - %p\n",
+		mc, smp_next_mpe_entry(mc));
+	return smp_next_mpe_entry(mc);
+}
+
+unsigned long write_smp_table(unsigned long addr, unsigned long *processor_map)
+{
+	void *v;
+	v = smp_write_floating_table(addr);
+	return (unsigned long)smp_write_config_table(v, processor_map);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/reset.c ../freebios2/src/mainboard/tyan/s4880/reset.c
--- ./freebios2/src/mainboard/tyan/s4880/reset.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/reset.c	2003-09-12 17:32:45.000000000 -0400
@@ -0,0 +1,41 @@
+//#include "arch/romcc_io.h"
+#include <arch/io.h>
+
+typedef unsigned device_t;
+
+#define PCI_DEV(BUS, DEV, FN) ( \
+	(((BUS) & 0xFF) << 16) | \
+	(((DEV) & 0x1f) << 11) | \
+	(((FN)  & 0x7) << 8))
+
+static void pci_write_config8(device_t dev, unsigned where, unsigned char value)
+{
+        unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outb(value, 0xCFC + (addr & 3));
+}
+
+static void pci_write_config32(device_t dev, unsigned where, unsigned value)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        outl(value, 0xCFC);
+}
+
+static unsigned pci_read_config32(device_t dev, unsigned where)
+{
+	unsigned addr;
+        addr = dev | where;
+        outl(0x80000000 | (addr & ~3), 0xCF8);
+        return inl(0xCFC);
+}
+
+#include "../../../northbridge/amd/amdk8/reset_test.c"
+
+void hard_reset(void)
+{
+	set_bios_reset();
+	pci_write_config8(PCI_DEV(1, 0x04, 0), 0x47, 1);
+}
diff -uNr ./freebios2/src/mainboard/tyan/s4880/resourcemap.c ../freebios2/src/mainboard/tyan/s4880/resourcemap.c
--- ./freebios2/src/mainboard/tyan/s4880/resourcemap.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/resourcemap.c	2003-11-24 21:56:44.000000000 -0500
@@ -0,0 +1,264 @@
+/*
+ * Tyan S4880 needs a different resource map
+ *
+ */
+
+static void setup_s4880_resource_map(void)
+{
+	static const unsigned int register_values[] = {
+	/* Careful set limit registers before base registers which contain the enables */
+	/* DRAM Limit i Registers
+	 * F1:0x44 i = 0
+	 * F1:0x4C i = 1
+	 * F1:0x54 i = 2
+	 * F1:0x5C i = 3
+	 * F1:0x64 i = 4
+	 * F1:0x6C i = 5
+	 * F1:0x74 i = 6
+	 * F1:0x7C i = 7
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 7: 3] Reserved
+	 * [10: 8] Interleave select
+	 *	   specifies the values of A[14:12] to use with interleave enable.
+	 * [15:11] Reserved
+	 * [31:16] DRAM Limit Address i Bits 39-24
+	 *	   This field defines the upper address bits of a 40 bit  address
+	 *	   that define the end of the DRAM region.
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x44), 0x0000f8f8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x4C), 0x0000f8f8, 0x00000001,
+	PCI_ADDR(0, 0x18, 1, 0x54), 0x0000f8f8, 0x00000002,
+	PCI_ADDR(0, 0x18, 1, 0x5C), 0x0000f8f8, 0x00000003,
+	PCI_ADDR(0, 0x18, 1, 0x64), 0x0000f8f8, 0x00000004,
+	PCI_ADDR(0, 0x18, 1, 0x6C), 0x0000f8f8, 0x00000005,
+	PCI_ADDR(0, 0x18, 1, 0x74), 0x0000f8f8, 0x00000006,
+	PCI_ADDR(0, 0x18, 1, 0x7C), 0x0000f8f8, 0x00000007,
+	/* DRAM Base i Registers
+	 * F1:0x40 i = 0
+	 * F1:0x48 i = 1
+	 * F1:0x50 i = 2
+	 * F1:0x58 i = 3
+	 * F1:0x60 i = 4
+	 * F1:0x68 i = 5
+	 * F1:0x70 i = 6
+	 * F1:0x78 i = 7
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 7: 2] Reserved
+	 * [10: 8] Interleave Enable
+	 *	   000 = No interleave
+	 *	   001 = Interleave on A[12] (2 nodes)
+	 *	   010 = reserved
+	 *	   011 = Interleave on A[12] and A[14] (4 nodes)
+	 *	   100 = reserved
+	 *	   101 = reserved
+	 *	   110 = reserved
+	 *	   111 = Interleve on A[12] and A[13] and A[14] (8 nodes)
+	 * [15:11] Reserved
+	 * [13:16] DRAM Base Address i Bits 39-24
+	 *	   This field defines the upper address bits of a 40-bit address
+	 *	   that define the start of the DRAM region.
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x40), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x48), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x50), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x58), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x60), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x68), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x70), 0x0000f8fc, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x78), 0x0000f8fc, 0x00000000,
+
+	/* Memory-Mapped I/O Limit i Registers
+	 * F1:0x84 i = 0
+	 * F1:0x8C i = 1
+	 * F1:0x94 i = 2
+	 * F1:0x9C i = 3
+	 * F1:0xA4 i = 4
+	 * F1:0xAC i = 5
+	 * F1:0xB4 i = 6
+	 * F1:0xBC i = 7
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 3: 3] Reserved
+	 * [ 5: 4] Destination Link ID
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 = Reserved
+	 * [ 6: 6] Reserved
+	 * [ 7: 7] Non-Posted
+	 *	   0 = CPU writes may be posted
+	 *	   1 = CPU writes must be non-posted
+	 * [31: 8] Memory-Mapped I/O Limit Address i (39-16)
+	 *	   This field defines the upp adddress bits of a 40-bit address that
+	 *	   defines the end of a memory-mapped I/O region n
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x84), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x8C), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x94), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x9C), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA4), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xAC), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB4), 0x00000048, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xBC), 0x00000048, 0x00ffff20,
+
+	/* Memory-Mapped I/O Base i Registers
+	 * F1:0x80 i = 0
+	 * F1:0x88 i = 1
+	 * F1:0x90 i = 2
+	 * F1:0x98 i = 3
+	 * F1:0xA0 i = 4
+	 * F1:0xA8 i = 5
+	 * F1:0xB0 i = 6
+	 * F1:0xB8 i = 7
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes disabled
+	 *	   1 = Writes Enabled
+	 * [ 2: 2] Cpu Disable
+	 *	   0 = Cpu can use this I/O range
+	 *	   1 = Cpu requests do not use this I/O range
+	 * [ 3: 3] Lock
+	 *	   0 = base/limit registers i are read/write
+	 *	   1 = base/limit registers i are read-only
+	 * [ 7: 4] Reserved
+	 * [31: 8] Memory-Mapped I/O Base Address i (39-16)
+	 *	   This field defines the upper address bits of a 40bit address 
+	 *	   that defines the start of memory-mapped I/O region i
+	 */
+	PCI_ADDR(0, 0x18, 1, 0x80), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x88), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x90), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0x98), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA0), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xA8), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB0), 0x000000f0, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xB8), 0x000000f0, 0x00fc0003,
+
+	/* PCI I/O Limit i Registers
+	 * F1:0xC4 i = 0
+	 * F1:0xCC i = 1
+	 * F1:0xD4 i = 2
+	 * F1:0xDC i = 3
+	 * [ 2: 0] Destination Node ID
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 3: 3] Reserved
+	 * [ 5: 4] Destination Link ID
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 = reserved
+	 * [11: 6] Reserved
+	 * [24:12] PCI I/O Limit Address i
+	 *	   This field defines the end of PCI I/O region n
+	 * [31:25] Reserved
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xC4), 0xFE000FC8, 0x01fff020,
+	PCI_ADDR(0, 0x18, 1, 0xCC), 0xFE000FC8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD4), 0xFE000FC8, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xDC), 0xFE000FC8, 0x00000000,
+
+	/* PCI I/O Base i Registers
+	 * F1:0xC0 i = 0
+	 * F1:0xC8 i = 1
+	 * F1:0xD0 i = 2
+	 * F1:0xD8 i = 3
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 3: 2] Reserved
+	 * [ 4: 4] VGA Enable
+	 *	   0 = VGA matches Disabled
+	 *	   1 = matches all address < 64K and where A[9:0] is in the 
+	 *	       range 3B0-3BB or 3C0-3DF independen of the base & limit registers
+	 * [ 5: 5] ISA Enable
+	 *	   0 = ISA matches Disabled
+	 *	   1 = Blocks address < 64K and in the last 768 bytes of eack 1K block
+	 *	       from matching agains this base/limit pair
+	 * [11: 6] Reserved
+	 * [24:12] PCI I/O Base i
+	 *	   This field defines the start of PCI I/O region n 
+	 * [31:25] Reserved
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xC0), 0xFE000FCC, 0x00000003,
+	PCI_ADDR(0, 0x18, 1, 0xC8), 0xFE000FCC, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD0), 0xFE000FCC, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xD8), 0xFE000FCC, 0x00000000,
+
+	/* Config Base and Limit i Registers
+	 * F1:0xE0 i = 0
+	 * F1:0xE4 i = 1
+	 * F1:0xE8 i = 2
+	 * F1:0xEC i = 3
+	 * [ 0: 0] Read Enable
+	 *	   0 = Reads Disabled
+	 *	   1 = Reads Enabled
+	 * [ 1: 1] Write Enable
+	 *	   0 = Writes Disabled
+	 *	   1 = Writes Enabled
+	 * [ 2: 2] Device Number Compare Enable
+	 *	   0 = The ranges are based on bus number
+	 *	   1 = The ranges are ranges of devices on bus 0
+	 * [ 3: 3] Reserved
+	 * [ 6: 4] Destination Node
+	 *	   000 = Node 0
+	 *	   001 = Node 1
+	 *	   010 = Node 2
+	 *	   011 = Node 3
+	 *	   100 = Node 4
+	 *	   101 = Node 5
+	 *	   110 = Node 6
+	 *	   111 = Node 7
+	 * [ 7: 7] Reserved
+	 * [ 9: 8] Destination Link
+	 *	   00 = Link 0
+	 *	   01 = Link 1
+	 *	   10 = Link 2
+	 *	   11 - Reserved
+	 * [15:10] Reserved
+	 * [23:16] Bus Number Base i
+	 *	   This field defines the lowest bus number in configuration region i
+	 * [31:24] Bus Number Limit i
+	 *	   This field defines the highest bus number in configuration regin i
+	 */
+	PCI_ADDR(0, 0x18, 1, 0xE0), 0x0000FC88, 0xff000203,
+	PCI_ADDR(0, 0x18, 1, 0xE4), 0x0000FC88, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xE8), 0x0000FC88, 0x00000000,
+	PCI_ADDR(0, 0x18, 1, 0xEC), 0x0000FC88, 0x00000000,
+	};
+	int max;
+	max = sizeof(register_values)/sizeof(register_values[0]);
+	setup_resource_map(register_values, max);
+}
+
diff -uNr ./freebios2/src/mainboard/tyan/s4880/si_sata.c ../freebios2/src/mainboard/tyan/s4880/si_sata.c
--- ./freebios2/src/mainboard/tyan/s4880/si_sata.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/si_sata.c	2003-11-24 20:34:31.000000000 -0500
@@ -0,0 +1,45 @@
+/* Copyright 2003 Tyan */
+
+/* Author: Yinghai Lu 
+ *
+ */
+
+
+#include <delay.h>
+#include <stdlib.h>
+#include <string.h>
+#include <arch/io.h>
+
+#include <console/console.h>
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <device/pci_ops.h>
+
+
+static void si_sata_init(struct device *dev)
+{
+	uint16_t word;
+
+        word = pci_read_config16(dev, 0x4);
+        word |= ((1 << 2) |(1<<4)); // Command: 3--> 17
+        pci_write_config16(dev, 0x4, word);
+
+	printk_debug("SI_SATA_FIXUP:  done  \n");
+	
+}
+
+static struct device_operations si_sata_ops  = {
+	.read_resources   = pci_dev_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init             = si_sata_init,
+	.scan_bus         = 0,
+};
+
+static struct pci_driver si_sata_driver __pci_driver = {
+        .ops    = &si_sata_ops,
+        .vendor = 0x1095,
+        .device = 0x3114,
+};
+ 
diff -uNr ./freebios2/src/mainboard/tyan/s4880/VERSION ../freebios2/src/mainboard/tyan/s4880/VERSION
--- ./freebios2/src/mainboard/tyan/s4880/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s4880/VERSION	2003-07-21 16:13:43.000000000 -0400
@@ -0,0 +1 @@
+2.0
diff -uNr ./freebios2/src/northbridge/amd/amdk8/raminit.h ../freebios2/src/northbridge/amd/amdk8/raminit.h
--- ./freebios2/src/northbridge/amd/amdk8/raminit.h	2003-07-21 16:13:44.000000000 -0400
+++ ../freebios2/src/northbridge/amd/amdk8/raminit.h	2003-12-01 16:40:25.000000000 -0500
@@ -4,8 +4,8 @@
 struct mem_controller {
 	unsigned node_id;
 	device_t f0, f1, f2, f3;
-	uint8_t channel0[4];
-	uint8_t channel1[4];
+	uint16_t channel0[4]; //By LYH
+	uint16_t channel1[4]; //By LYH
 };
 
 
diff -uNr ./freebios2/src/southbridge/amd/amd8111/amd8111_early_smbus.c ../freebios2/src/southbridge/amd/amd8111/amd8111_early_smbus.c
--- ./freebios2/src/southbridge/amd/amd8111/amd8111_early_smbus.c	2003-10-13 06:01:13.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8111/amd8111_early_smbus.c	2003-12-01 16:14:18.000000000 -0500
@@ -120,24 +120,19 @@
 		return;
 	}
 
-	/* setup transaction */
-	/* disable interrupts */
-	outw(inw(SMBUS_IO_BASE + SMBGCTL) & ~((1<<10)|(1<<9)|(1<<8)|(1<<4)),
-			SMBUS_IO_BASE + SMBGCTL);
+//By LYH Begin
+	outb(0x37,SMBUS_IO_BASE + SMBGSTATUS);
 	/* set the device I'm talking too */
-	outw(((device & 0x7f) << 1) | 1, SMBUS_IO_BASE + SMBHSTADDR);
-	outb(address & 0xFF, SMBUS_IO_BASE + SMBHSTCMD);
-	/* set up for a byte data write */ /* FIXME */
-	outw((inw(SMBUS_IO_BASE + SMBGCTL) & ~7) | (0x1), SMBUS_IO_BASE + SMBGCTL);
-	/* clear any lingering errors, so the transaction will run */
-	/* Do I need to write the bits to a 1 to clear an error? */
-	outw(inw(SMBUS_IO_BASE + SMBGSTATUS), SMBUS_IO_BASE + SMBGSTATUS);
+	outw(((device & 0x7f) << 1) | 0, SMBUS_IO_BASE + SMBHSTADDR);
+        
+	/* data to send */
+        outb(val, SMBUS_IO_BASE + SMBHSTDAT);
 
-	/* clear the data word...*/
-	outw(val, SMBUS_IO_BASE + SMBHSTDAT);
+	outb(address & 0xFF, SMBUS_IO_BASE + SMBHSTCMD);
 
 	/* start the command */
-	outw((inw(SMBUS_IO_BASE + SMBGCTL) | (1 << 3)), SMBUS_IO_BASE + SMBGCTL);
+	outb(0xa, SMBUS_IO_BASE + SMBGCTL);
+//By LYH END
 
 	/* poll for transaction completion */
 	smbus_wait_until_done();
diff -uNr ./freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c ../freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c
--- ./freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c	2003-10-11 02:20:21.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8131/amd8131_bridge.c	2003-12-01 20:30:02.000000000 -0500
@@ -69,6 +69,13 @@
 		value &= ~((1 << 1) | (1 << 0));
 	}
 	pci_write_config32(dev, 0x44, value);
+
+//BY LYH
+        value = pci_read_config32(dev, 0x4);
+        value |= 6;
+        pci_write_config32(dev, 0x4, value);
+//BY LYH END
+
 }
 
 static struct device_operations ioapic_ops = {
diff -uNr ./freebios2/targets/amd/quartet/Config.lb ../freebios2/targets/amd/quartet/Config.lb
--- ./freebios2/targets/amd/quartet/Config.lb	2003-11-19 07:30:07.000000000 -0500
+++ ../freebios2/targets/amd/quartet/Config.lb	2003-11-06 11:31:40.000000000 -0500
@@ -48,7 +48,6 @@
 uses XIP_ROM_SIZE
 uses XIP_ROM_BASE
 uses LINUXBIOS_EXTRA_VERSION
-uses FAKE_SPDROM
 uses CC
 
 option CC="gcc -m32"
@@ -74,8 +73,6 @@
 option CONFIG_ROM_STREAM=1
 option HAVE_FALLBACK_BOOT=1
 
-option FAKE_SPDROM=1
-
 ###
 ### Compute the location and size of where this firmware image
 ### (linuxBIOS plus bootloader) will live in the boot rom chip.
Binary files ./freebios2/targets/tyan/s2850/atix.rom and ../freebios2/targets/tyan/s2850/atix.rom differ
diff -uNr ./freebios2/targets/tyan/s2850/Config.lb ../freebios2/targets/tyan/s2850/Config.lb
--- ./freebios2/targets/tyan/s2850/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2850/Config.lb	2003-10-16 18:42:27.000000000 -0400
@@ -0,0 +1,239 @@
+# Sample config file for 
+# the Tyan s2850 
+# This will make a target directory of ./s2850
+
+loadoptions
+
+target s2850
+
+uses ARCH
+uses CONFIG_COMPRESS
+uses CONFIG_IOAPIC
+uses CONFIG_ROM_STREAM
+uses CONFIG_ROM_STREAM_START
+uses CONFIG_SMP
+uses CONFIG_UDELAY_TSC
+uses CPU_FIXUP
+uses FALLBACK_SIZE
+uses HAVE_FALLBACK_BOOT
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses i586
+uses i686
+uses INTEL_PPRO_MTRR
+uses HEAP_SIZE
+uses IRQ_SLOT_COUNT
+uses k7
+uses k8
+uses MAINBOARD
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+#uses MEMORY_HOLE
+uses PAYLOAD_SIZE
+uses _RAMBASE
+uses _ROMBASE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_OFFSET
+uses ROM_SECTION_SIZE
+uses ROM_SIZE
+uses STACK_SIZE
+uses USE_FALLBACK_IMAGE
+uses USE_OPTION_TABLE
+uses HAVE_OPTION_TABLE
+uses CONFIG_CHIP_CONFIGURE
+ 
+uses CONFIG_CONSOLE_SERIAL8250
+uses TTYS0_BAUD
+uses DEFAULT_CONSOLE_LOGLEVEL
+uses MAXIMUM_CONSOLE_LOGLEVEL
+uses DEBUG
+uses CONFIG_MAX_CPUS
+uses CONFIG_LOGICAL_CPUS
+uses CONFIG_MAX_PHYSICAL_CPUS
+uses LINUXBIOS_EXTRA_VERSION
+uses XIP_ROM_SIZE
+uses XIP_ROM_BASE
+
+uses HAVE_HARD_RESET
+
+#uses CONFIG_VGABIOS
+#uses CONFIG_REALMODE_IDT
+#uses CONFIG_PCIBIOS
+#uses VGABIOS_START
+#uses SCSIFW_START
+
+#
+#uses CONFIG_LSI_SCSI_FW_FIXUP
+
+option HAVE_HARD_RESET=0
+
+option HAVE_OPTION_TABLE=1
+option HAVE_MP_TABLE=1
+option CPU_FIXUP=1
+option CONFIG_UDELAY_TSC=0
+option i686=1
+option i586=1
+option INTEL_PPRO_MTRR=1
+option k7=1
+option k8=1
+option ROM_SIZE=524288
+
+#option CONFIG_VGABIOS=0
+#option CONFIG_REALMODE_IDT=0
+#option CONFIG_PCIBIOS=0
+#option VGABIOS_START=0xfff8c000
+#option SCSIFW_START=0xfff80000
+
+
+option HAVE_FALLBACK_BOOT=1
+  
+# use the new chip configure code.
+
+option CONFIG_CHIP_CONFIGURE=1
+#option CONFIG_LSI_SCSI_FW_FIXUP=1
+
+
+#
+###
+### Build code to export a programmable irq routing table
+###
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=12
+#
+###
+### Build code for SMP support
+### Only worry about 2 micro processors
+###
+option CONFIG_SMP=1
+option CONFIG_MAX_CPUS=1
+option CONFIG_LOGICAL_CPUS=0
+option CONFIG_MAX_PHYSICAL_CPUS=1
+#
+###
+### Build code to setup a generic IOAPIC
+###
+option CONFIG_IOAPIC=1
+#
+###
+### MEMORY_HOLE instructs earlymtrr.inc to
+### enable caching from 0-640KB and to disable 
+### caching from 640KB-1MB using fixed MTRRs 
+###
+### Enabling this option breaks SMP because secondary
+### CPU identification depends on only variable MTRRs
+### being enabled.
+###
+#option MEMORY_HOLE=0
+#
+###
+### Clean up the motherboard id strings
+###
+option MAINBOARD_PART_NUMBER="S2850"
+option MAINBOARD_VENDOR="Tyan"
+#
+###
+### Compute the location and size of where this firmware image
+### (linuxBIOS plus bootloader) will live in the boot rom chip.
+###
+#option FALLBACK_SIZE=524288
+option FALLBACK_SIZE=98304
+
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=65536
+ 
+
+###
+### Compute where this copy of linuxBIOS will start in the boot rom
+###
+#
+###
+
+## We do use compressed image
+option CONFIG_COMPRESS=1
+
+option CONFIG_CONSOLE_SERIAL8250=1
+option TTYS0_BAUD=115200
+
+##
+### Select the linuxBIOS loglevel
+##
+## EMERG      1   system is unusable
+## ALERT      2   action must be taken immediately
+## CRIT       3   critical conditions
+## ERR        4   error conditions
+## WARNING    5   warning conditions
+## NOTICE     6   normal but significant condition
+## INFO       7   informational
+## DEBUG      8   debug-level messages
+## SPEW       9   Way too many details
+
+## Request this level of debugging output
+option DEFAULT_CONSOLE_LOGLEVEL=8
+## At a maximum only compile in this level of debugging
+option MAXIMUM_CONSOLE_LOGLEVEL=9
+
+option DEBUG=1
+
+#
+
+## LinuxBIOS C code runs at this location in RAM
+option _RAMBASE=0x004000
+
+##
+## Use a 128K stack
+##
+option STACK_SIZE=0x4000
+
+##
+## Use a 256K heap
+##
+option HEAP_SIZE=0x8000
+
+#
+###
+### Compute the start location and size size of
+### The linuxBIOS bootloader.
+###
+option CONFIG_ROM_STREAM     = 1
+
+#
+# 
+romimage "normal"
+#	48K for SCSI FW
+#        option ROM_SIZE = 475136
+#	48K for SCSI FW and 48K for ATI ROM
+#	option ROM_SIZE = 425984  
+        option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+	option USE_FALLBACK_IMAGE=0
+	option ROM_SECTION_SIZE  = (ROM_SIZE - FALLBACK_SIZE)
+	option ROM_SECTION_OFFSET= 0
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s2850
+	payload ../../tg3--ide_disk.zelf 
+end
+
+romimage "fallback" 
+	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+	option USE_FALLBACK_IMAGE=1
+	option ROM_SECTION_SIZE  = FALLBACK_SIZE
+	option ROM_SECTION_OFFSET= (ROM_SIZE - FALLBACK_SIZE)
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s2850
+	payload ../../tg3--ide_disk.zelf
+end
+
+buildrom ./linuxbios.rom ROM_SIZE "normal" "fallback"
diff -uNr ./freebios2/targets/tyan/s2850/ns2850 ../freebios2/targets/tyan/s2850/ns2850
--- ./freebios2/targets/tyan/s2850/ns2850	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2850/ns2850	2003-09-18 21:51:07.000000000 -0400
@@ -0,0 +1,7 @@
+#!/bin/bash
+TYANMB=s2850
+cd "$TYANMB"
+make
+#cat ../atix.rom ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cat ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cp -f $TYANMB"_linuxbios.rom" /home/yhlu/
Binary files ./freebios2/targets/tyan/s2850/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s2850/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2850/tg3.zelf and ../freebios2/targets/tyan/s2850/tg3.zelf differ
diff -uNr ./freebios2/targets/tyan/s2850/VERSION ../freebios2/targets/tyan/s2850/VERSION
--- ./freebios2/targets/tyan/s2850/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2850/VERSION	2003-07-26 02:34:45.000000000 -0400
@@ -0,0 +1 @@
+2.0
Binary files ./freebios2/targets/tyan/s2880/atix.rom and ../freebios2/targets/tyan/s2880/atix.rom differ
diff -uNr ./freebios2/targets/tyan/s2880/Config.lb ../freebios2/targets/tyan/s2880/Config.lb
--- ./freebios2/targets/tyan/s2880/Config.lb	2003-10-15 16:05:09.000000000 -0400
+++ ../freebios2/targets/tyan/s2880/Config.lb	2003-11-22 02:35:53.000000000 -0500
@@ -98,7 +98,7 @@
 ### Build code to export a programmable irq routing table
 ###
 option HAVE_PIRQ_TABLE=1
-option IRQ_SLOT_COUNT=13
+option IRQ_SLOT_COUNT=12
 #
 ###
 ### Build code for SMP support
Binary files ./freebios2/targets/tyan/s2880/fwx.rom and ../freebios2/targets/tyan/s2880/fwx.rom differ
Binary files ./freebios2/targets/tyan/s2880/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s2880/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2880/tg3.zelf and ../freebios2/targets/tyan/s2880/tg3.zelf differ
Binary files ./freebios2/targets/tyan/s2881/atix.rom and ../freebios2/targets/tyan/s2881/atix.rom differ
diff -uNr ./freebios2/targets/tyan/s2881/Config.lb ../freebios2/targets/tyan/s2881/Config.lb
--- ./freebios2/targets/tyan/s2881/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2881/Config.lb	2003-11-22 03:51:21.000000000 -0500
@@ -0,0 +1,239 @@
+# Sample config file for 
+# the Tyan s2880 
+# This will make a target directory of ./s2880
+
+loadoptions
+
+target s2881
+
+uses ARCH
+uses CONFIG_COMPRESS
+uses CONFIG_IOAPIC
+uses CONFIG_ROM_STREAM
+uses CONFIG_ROM_STREAM_START
+uses CONFIG_SMP
+uses CONFIG_UDELAY_TSC
+uses CPU_FIXUP
+uses FALLBACK_SIZE
+uses HAVE_FALLBACK_BOOT
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses i586
+uses i686
+uses INTEL_PPRO_MTRR
+uses HEAP_SIZE
+uses IRQ_SLOT_COUNT
+uses k7
+uses k8
+uses MAINBOARD
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+#uses MEMORY_HOLE
+uses PAYLOAD_SIZE
+uses _RAMBASE
+uses _ROMBASE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_OFFSET
+uses ROM_SECTION_SIZE
+uses ROM_SIZE
+uses STACK_SIZE
+uses USE_FALLBACK_IMAGE
+uses USE_OPTION_TABLE
+uses HAVE_OPTION_TABLE
+uses CONFIG_CHIP_CONFIGURE
+ 
+uses CONFIG_CONSOLE_SERIAL8250
+uses TTYS0_BAUD
+uses DEFAULT_CONSOLE_LOGLEVEL
+uses MAXIMUM_CONSOLE_LOGLEVEL
+uses DEBUG
+uses CONFIG_MAX_CPUS
+uses CONFIG_LOGICAL_CPUS
+uses CONFIG_MAX_PHYSICAL_CPUS
+uses LINUXBIOS_EXTRA_VERSION
+uses XIP_ROM_SIZE
+uses XIP_ROM_BASE
+
+uses HAVE_HARD_RESET
+
+#uses CONFIG_VGABIOS
+#uses CONFIG_REALMODE_IDT
+#uses CONFIG_PCIBIOS
+#uses VGABIOS_START
+#uses SCSIFW_START
+
+#
+#uses CONFIG_LSI_SCSI_FW_FIXUP
+
+option HAVE_HARD_RESET=1
+
+option HAVE_OPTION_TABLE=1
+option HAVE_MP_TABLE=1
+option CPU_FIXUP=1
+option CONFIG_UDELAY_TSC=0
+option i686=1
+option i586=1
+option INTEL_PPRO_MTRR=1
+option k7=1
+option k8=1
+option ROM_SIZE=524288
+
+#option CONFIG_VGABIOS=0
+#option CONFIG_REALMODE_IDT=0
+#option CONFIG_PCIBIOS=0
+#option VGABIOS_START=0xfff8c000
+#option SCSIFW_START=0xfff80000
+
+
+option HAVE_FALLBACK_BOOT=1
+  
+# use the new chip configure code.
+
+option CONFIG_CHIP_CONFIGURE=1
+#option CONFIG_LSI_SCSI_FW_FIXUP=1
+
+
+#
+###
+### Build code to export a programmable irq routing table
+###
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=9
+#
+###
+### Build code for SMP support
+### Only worry about 2 micro processors
+###
+option CONFIG_SMP=1
+option CONFIG_MAX_CPUS=2
+option CONFIG_LOGICAL_CPUS=0
+option CONFIG_MAX_PHYSICAL_CPUS=2
+#
+###
+### Build code to setup a generic IOAPIC
+###
+option CONFIG_IOAPIC=1
+#
+###
+### MEMORY_HOLE instructs earlymtrr.inc to
+### enable caching from 0-640KB and to disable 
+### caching from 640KB-1MB using fixed MTRRs 
+###
+### Enabling this option breaks SMP because secondary
+### CPU identification depends on only variable MTRRs
+### being enabled.
+###
+#option MEMORY_HOLE=0
+#
+###
+### Clean up the motherboard id strings
+###
+option MAINBOARD_PART_NUMBER="S2881"
+option MAINBOARD_VENDOR="Tyan"
+#
+###
+### Compute the location and size of where this firmware image
+### (linuxBIOS plus bootloader) will live in the boot rom chip.
+###
+#option FALLBACK_SIZE=524288
+option FALLBACK_SIZE=98304
+
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=65536
+ 
+
+###
+### Compute where this copy of linuxBIOS will start in the boot rom
+###
+#
+###
+
+## We do use compressed image
+option CONFIG_COMPRESS=1
+
+option CONFIG_CONSOLE_SERIAL8250=1
+option TTYS0_BAUD=115200
+
+##
+### Select the linuxBIOS loglevel
+##
+## EMERG      1   system is unusable
+## ALERT      2   action must be taken immediately
+## CRIT       3   critical conditions
+## ERR        4   error conditions
+## WARNING    5   warning conditions
+## NOTICE     6   normal but significant condition
+## INFO       7   informational
+## DEBUG      8   debug-level messages
+## SPEW       9   Way too many details
+
+## Request this level of debugging output
+option DEFAULT_CONSOLE_LOGLEVEL=8
+## At a maximum only compile in this level of debugging
+option MAXIMUM_CONSOLE_LOGLEVEL=9
+
+option DEBUG=1
+
+#
+
+## LinuxBIOS C code runs at this location in RAM
+option _RAMBASE=0x004000
+
+##
+## Use a 128K stack
+##
+option STACK_SIZE=0x4000
+
+##
+## Use a 256K heap
+##
+option HEAP_SIZE=0x8000
+
+#
+###
+### Compute the start location and size size of
+### The linuxBIOS bootloader.
+###
+option CONFIG_ROM_STREAM     = 1
+
+#
+# 
+romimage "normal"
+#	48K for SCSI FW
+#        option ROM_SIZE = 475136
+#	48K for SCSI FW and 48K for ATI ROM
+#	option ROM_SIZE = 425984  
+        option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+	option USE_FALLBACK_IMAGE=0
+	option ROM_SECTION_SIZE  = (ROM_SIZE - FALLBACK_SIZE)
+	option ROM_SECTION_OFFSET= 0
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s2881
+	payload ../../tg3--ide_disk.zelf 
+end
+
+romimage "fallback" 
+	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+	option USE_FALLBACK_IMAGE=1
+	option ROM_SECTION_SIZE  = FALLBACK_SIZE
+	option ROM_SECTION_OFFSET= (ROM_SIZE - FALLBACK_SIZE)
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s2881
+	payload ../../tg3.zelf
+end
+
+buildrom ./linuxbios.rom ROM_SIZE "normal" "fallback"
diff -uNr ./freebios2/targets/tyan/s2881/lyh.txt ../freebios2/targets/tyan/s2881/lyh.txt
--- ./freebios2/targets/tyan/s2881/lyh.txt	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2881/lyh.txt	2003-11-22 03:49:45.000000000 -0500
@@ -0,0 +1,40 @@
+2,3c2,3
+< # the Tyan s2880 
+< # This will make a target directory of ./s2880
+---
+> # the Tyan s2885 
+> # This will make a target directory of ./s2885
+7c7
+< target s2880
+---
+> target s2885
+56d55
+< 
+68,69d66
+< option HAVE_HARD_RESET=0
+< 
+96c93,94
+< #
+---
+> option HAVE_HARD_RESET=0
+> 
+101c99
+< option IRQ_SLOT_COUNT=13
+---
+> option IRQ_SLOT_COUNT=11
+131c129
+< option MAINBOARD_PART_NUMBER="S2880"
+---
+> option MAINBOARD_PART_NUMBER="S2885"
+207c205
+< 	option USE_FALLBACK_IMAGE=0
+---
+>         option USE_FALLBACK_IMAGE=0
+218c216
+< 	mainboard tyan/s2880
+---
+> 	mainboard tyan/s2885
+235c233
+< 	mainboard tyan/s2880
+---
+> 	mainboard tyan/s2885
diff -uNr ./freebios2/targets/tyan/s2881/ns2881 ../freebios2/targets/tyan/s2881/ns2881
--- ./freebios2/targets/tyan/s2881/ns2881	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2881/ns2881	2003-12-01 16:11:43.000000000 -0500
@@ -0,0 +1,8 @@
+#!/bin/bash
+TYANMB=s2881
+cd "$TYANMB"
+make
+#cat ../fwx.rom ../atix.rom ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cat ../fwx.rom ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+#cat ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cp -f $TYANMB"_linuxbios.rom" /home/yhlu/
Binary files ./freebios2/targets/tyan/s2881/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s2881/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2881/tg3.zelf and ../freebios2/targets/tyan/s2881/tg3.zelf differ
diff -uNr ./freebios2/targets/tyan/s2881/VERSION ../freebios2/targets/tyan/s2881/VERSION
--- ./freebios2/targets/tyan/s2881/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2881/VERSION	2003-11-22 03:49:45.000000000 -0500
@@ -0,0 +1 @@
+2.0
Binary files ./freebios2/targets/tyan/s2882/atix.rom and ../freebios2/targets/tyan/s2882/atix.rom differ
diff -uNr ./freebios2/targets/tyan/s2882/Config.lb ../freebios2/targets/tyan/s2882/Config.lb
--- ./freebios2/targets/tyan/s2882/Config.lb	2003-10-15 16:05:09.000000000 -0400
+++ ../freebios2/targets/tyan/s2882/Config.lb	2003-10-16 18:26:32.000000000 -0400
@@ -76,7 +76,7 @@
 option k8=1
 option ROM_SIZE=524288
 
-option HAVE_HARD_RESET=1
+option HAVE_HARD_RESET=0
 
 #option CONFIG_VGABIOS=1
 #option CONFIG_REALMODE_IDT=1
Binary files ./freebios2/targets/tyan/s2882/e1000.zelf and ../freebios2/targets/tyan/s2882/e1000.zelf differ
Binary files ./freebios2/targets/tyan/s2882/ide_disk.zelf and ../freebios2/targets/tyan/s2882/ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2882/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s2882/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2882/tg3.zelf and ../freebios2/targets/tyan/s2882/tg3.zelf differ
Binary files ./freebios2/targets/tyan/s2885/e1000.zelf and ../freebios2/targets/tyan/s2885/e1000.zelf differ
Binary files ./freebios2/targets/tyan/s2885/eepro100.zelf and ../freebios2/targets/tyan/s2885/eepro100.zelf differ
Binary files ./freebios2/targets/tyan/s2885/ide_disk.zelf and ../freebios2/targets/tyan/s2885/ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2885/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s2885/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s2885/tg3x.zelf and ../freebios2/targets/tyan/s2885/tg3x.zelf differ
Binary files ./freebios2/targets/tyan/s2885/tg3.zelf and ../freebios2/targets/tyan/s2885/tg3.zelf differ
Binary files ./freebios2/targets/tyan/s4880/atix.rom and ../freebios2/targets/tyan/s4880/atix.rom differ
diff -uNr ./freebios2/targets/tyan/s4880/Config.lb ../freebios2/targets/tyan/s4880/Config.lb
--- ./freebios2/targets/tyan/s4880/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s4880/Config.lb	2003-12-01 15:59:10.000000000 -0500
@@ -0,0 +1,239 @@
+# Sample config file for 
+# the Tyan s2880 
+# This will make a target directory of ./s2880
+
+loadoptions
+
+target s4880
+
+uses ARCH
+uses CONFIG_COMPRESS
+uses CONFIG_IOAPIC
+uses CONFIG_ROM_STREAM
+uses CONFIG_ROM_STREAM_START
+uses CONFIG_SMP
+uses CONFIG_UDELAY_TSC
+uses CPU_FIXUP
+uses FALLBACK_SIZE
+uses HAVE_FALLBACK_BOOT
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses i586
+uses i686
+uses INTEL_PPRO_MTRR
+uses HEAP_SIZE
+uses IRQ_SLOT_COUNT
+uses k7
+uses k8
+uses MAINBOARD
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+#uses MEMORY_HOLE
+uses PAYLOAD_SIZE
+uses _RAMBASE
+uses _ROMBASE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_OFFSET
+uses ROM_SECTION_SIZE
+uses ROM_SIZE
+uses STACK_SIZE
+uses USE_FALLBACK_IMAGE
+uses USE_OPTION_TABLE
+uses HAVE_OPTION_TABLE
+uses CONFIG_CHIP_CONFIGURE
+ 
+uses CONFIG_CONSOLE_SERIAL8250
+uses TTYS0_BAUD
+uses DEFAULT_CONSOLE_LOGLEVEL
+uses MAXIMUM_CONSOLE_LOGLEVEL
+uses DEBUG
+uses CONFIG_MAX_CPUS
+uses CONFIG_LOGICAL_CPUS
+uses CONFIG_MAX_PHYSICAL_CPUS
+uses LINUXBIOS_EXTRA_VERSION
+uses XIP_ROM_SIZE
+uses XIP_ROM_BASE
+
+uses HAVE_HARD_RESET
+
+#uses CONFIG_VGABIOS
+#uses CONFIG_REALMODE_IDT
+#uses CONFIG_PCIBIOS
+#uses VGABIOS_START
+#uses SCSIFW_START
+
+#
+#uses CONFIG_LSI_SCSI_FW_FIXUP
+
+option HAVE_HARD_RESET=1
+
+option HAVE_OPTION_TABLE=1
+option HAVE_MP_TABLE=1
+option CPU_FIXUP=1
+option CONFIG_UDELAY_TSC=0
+option i686=1
+option i586=1
+option INTEL_PPRO_MTRR=1
+option k7=1
+option k8=1
+option ROM_SIZE=524288
+
+#option CONFIG_VGABIOS=0
+#option CONFIG_REALMODE_IDT=0
+#option CONFIG_PCIBIOS=0
+#option VGABIOS_START=0xfff8c000
+#option SCSIFW_START=0xfff80000
+
+
+option HAVE_FALLBACK_BOOT=1
+  
+# use the new chip configure code.
+
+option CONFIG_CHIP_CONFIGURE=1
+#option CONFIG_LSI_SCSI_FW_FIXUP=1
+
+
+#
+###
+### Build code to export a programmable irq routing table
+###
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=22
+#
+###
+### Build code for SMP support
+### Only worry about 2 micro processors
+###
+option CONFIG_SMP=1
+option CONFIG_MAX_CPUS=4
+option CONFIG_LOGICAL_CPUS=0
+option CONFIG_MAX_PHYSICAL_CPUS=4
+#
+###
+### Build code to setup a generic IOAPIC
+###
+option CONFIG_IOAPIC=1
+#
+###
+### MEMORY_HOLE instructs earlymtrr.inc to
+### enable caching from 0-640KB and to disable 
+### caching from 640KB-1MB using fixed MTRRs 
+###
+### Enabling this option breaks SMP because secondary
+### CPU identification depends on only variable MTRRs
+### being enabled.
+###
+#option MEMORY_HOLE=0
+#
+###
+### Clean up the motherboard id strings
+###
+option MAINBOARD_PART_NUMBER="S4880"
+option MAINBOARD_VENDOR="Tyan"
+#
+###
+### Compute the location and size of where this firmware image
+### (linuxBIOS plus bootloader) will live in the boot rom chip.
+###
+#option FALLBACK_SIZE=524288
+option FALLBACK_SIZE=98304
+
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=65536
+ 
+
+###
+### Compute where this copy of linuxBIOS will start in the boot rom
+###
+#
+###
+
+## We do use compressed image
+option CONFIG_COMPRESS=1
+
+option CONFIG_CONSOLE_SERIAL8250=1
+option TTYS0_BAUD=115200
+
+##
+### Select the linuxBIOS loglevel
+##
+## EMERG      1   system is unusable
+## ALERT      2   action must be taken immediately
+## CRIT       3   critical conditions
+## ERR        4   error conditions
+## WARNING    5   warning conditions
+## NOTICE     6   normal but significant condition
+## INFO       7   informational
+## DEBUG      8   debug-level messages
+## SPEW       9   Way too many details
+
+## Request this level of debugging output
+option DEFAULT_CONSOLE_LOGLEVEL=8
+## At a maximum only compile in this level of debugging
+option MAXIMUM_CONSOLE_LOGLEVEL=8
+
+option DEBUG=1
+
+#
+
+## LinuxBIOS C code runs at this location in RAM
+option _RAMBASE=0x004000
+
+##
+## Use a 256K stack
+##
+option STACK_SIZE=0x8000
+
+##
+## Use a 384K heap
+##
+option HEAP_SIZE=0xc000
+
+#
+###
+### Compute the start location and size size of
+### The linuxBIOS bootloader.
+###
+option CONFIG_ROM_STREAM     = 1
+
+#
+# 
+romimage "normal"
+#	48K for SCSI FW
+        option ROM_SIZE = 475136
+#	48K for SCSI FW and 48K for ATI ROM
+#	option ROM_SIZE = 425984  
+        option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+	option USE_FALLBACK_IMAGE=0
+	option ROM_SECTION_SIZE  = (ROM_SIZE - FALLBACK_SIZE)
+	option ROM_SECTION_OFFSET= 0
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s4880
+	payload ../../tg3--ide_disk.zelf 
+end
+
+romimage "fallback" 
+	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+	option USE_FALLBACK_IMAGE=1
+	option ROM_SECTION_SIZE  = FALLBACK_SIZE
+	option ROM_SECTION_OFFSET= (ROM_SIZE - FALLBACK_SIZE)
+
+	option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+	option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+	option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+	option XIP_ROM_SIZE = FALLBACK_SIZE
+	option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+	mainboard tyan/s4880
+	payload ../../tg3.zelf
+end
+
+buildrom ./linuxbios.rom ROM_SIZE "normal" "fallback"
Binary files ./freebios2/targets/tyan/s4880/fwx.rom and ../freebios2/targets/tyan/s4880/fwx.rom differ
diff -uNr ./freebios2/targets/tyan/s4880/ns4880 ../freebios2/targets/tyan/s4880/ns4880
--- ./freebios2/targets/tyan/s4880/ns4880	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s4880/ns4880	2003-11-24 20:28:06.000000000 -0500
@@ -0,0 +1,8 @@
+#!/bin/bash
+TYANMB=s4880
+cd "$TYANMB"
+make
+#cat ../fwx.rom ../atix.rom ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cat ../fwx.rom ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+#cat ./normal/linuxbios.rom ./fallback/linuxbios.rom > $TYANMB"_linuxbios.rom"
+cp -f $TYANMB"_linuxbios.rom" /home/yhlu/
Binary files ./freebios2/targets/tyan/s4880/tg3--ide_disk.zelf and ../freebios2/targets/tyan/s4880/tg3--ide_disk.zelf differ
Binary files ./freebios2/targets/tyan/s4880/tg3.zelf and ../freebios2/targets/tyan/s4880/tg3.zelf differ
diff -uNr ./freebios2/targets/tyan/s4880/VERSION ../freebios2/targets/tyan/s4880/VERSION
--- ./freebios2/targets/tyan/s4880/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s4880/VERSION	2003-07-26 02:34:45.000000000 -0400
@@ -0,0 +1 @@
+2.0
Binary files ./freebios2/util/newconfig/yappsrt.pyc and ../freebios2/util/newconfig/yappsrt.pyc differ
